create PACKAGE BODY ipcc_report is
--------------------------------------------------------
--  DDL for Procedure ASSERTTRUE
--------------------------------------------------------


  PROCEDURE "ASSERTTRUE" (rs out number,val IN VARCHAR2,
                                             u_id  IN NUMBER, u_name IN VARCHAR2, vtype in number)  IS
v_str1 varchar2(500);
BEGIN
rs := 1;
if val is not null then
  v_str1 := substr(val, 3);
end if;
INSERT_LOG('v_str1: ','assertTrue',sysdate, v_str1);
For record_cursor in (
     select REGEXP_SUBSTR (v_str1, '[^,]+', 1, level) output
     from dual
     connect by level <= regexp_count(v_str1,',')+1
    MINUS
    select line_code from user_line where user_name = u_name

     )
  loop
      if record_cursor.output is not null then
          rs := 0;
          DBMS_OUTPUT.PUT_LINE(record_cursor.output);
          exit;
      end if;
  end loop;

EXCEPTION
    WHEN OTHERS THEN
     rs := 0;
END assertTrue;



--------------------------------------------------------
--  DDL for Procedure DEL_DATA
--------------------------------------------------------


  PROCEDURE "DEL_DATA" (tbl_name IN VARCHAR2,
                                             DAY_NUM  IN NUMBER)  IS
  ERR_MSG       VARCHAR2(1000);
  v_sql         VARCHAR2(500);
  STSQL         VARCHAR2(100);
  v_date            date;
  v_partition_name  user_tab_partitions.partition_name%TYPE;
  v_high_value      user_tab_partitions.high_value%TYPE;
  CURSOR c1 IS select PARTITION_NAME, HIGH_VALUE
               from user_tab_partitions where table_name = tbl_name;
-- duongtb:15/03/2013
BEGIN
--  STSQL := 'Alter session set nls_date_format = ''yyyy-mm-dd hh24:mi:ss''';
--
--  EXECUTE IMMEDIATE STSQL;

  OPEN c1;
    LOOP
      FETCH c1 INTO v_partition_name, v_high_value;
      EXIT WHEN c1%NOTFOUND;
--      select to_date(SUBSTR(v_high_value,11,19),'YYYY-MM-DD HH24:MI:SS') into v_date from dual;
      v_date := to_date(SUBSTR(v_high_value,11,19),'YYYY-MM-DD HH24:MI:SS');

      IF v_date < (sysdate - DAY_NUM) then
       INSERT_LOG('INFO', 'Begin delete partition', SYSDATE, STSQL);
        v_sql := 'Alter table ' || tbl_name || ' drop partition ' || v_partition_name || ' update global indexes';
        DBMS_OUTPUT.PUT_LINE(v_sql);
----        execute immediate v_sql;
        EXECUTESQL(v_sql);
        INSERT_LOG('FINISH','Deleted partition ' || v_partition_name,SYSDATE,v_sql);
      END IF;
    END LOOP;

  CLOSE c1;
EXCEPTION
  WHEN TIMEOUT_ON_RESOURCE THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('TIMEOUT_ON_RESOURCE ','Cannot delete partition ' || v_partition_name || 'Error is:' ||
ERR_MSG,SYSDATE,v_sql);
      ROLLBACK;
  WHEN STORAGE_ERROR THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('STORAGE_ERROR ','Cannot delete partition ' || v_partition_name || 'Error is:' || ERR_MSG,SYSDATE,v_sql);
      ROLLBACK;
  WHEN OTHERS THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('ERROR ','Cannot delete partition ' || v_partition_name || 'Error is:' || ERR_MSG,SYSDATE,v_sql);
    ROLLBACK;
END del_data;



--------------------------------------------------------
--  DDL for Procedure DEL_DATA_CHAT
--------------------------------------------------------


  PROCEDURE "DEL_DATA_CHAT" (tbl_name IN VARCHAR2,
                                             DAY_NUM  IN NUMBER)  IS
  ERR_MSG       VARCHAR2(1000);
  v_sql         VARCHAR2(500);
  STSQL         VARCHAR2(100);
  v_date            number;
  v_left_point number;
  v_partition_name  user_tab_partitions.partition_name%TYPE;
  v_high_value      user_tab_partitions.high_value%TYPE;
  CURSOR c1 IS select PARTITION_NAME, HIGH_VALUE
               from user_tab_partitions where table_name = tbl_name;
-- duongtb:15/03/2013
BEGIN
--  STSQL := 'Alter session set nls_date_format = ''yyyy-mm-dd hh24:mi:ss''';
--
--  EXECUTE IMMEDIATE STSQL;
  v_left_point := round((sysdate - DAY_NUM - to_date('01-JAN-1970','DD-MON-YYYY'))  * 24 * 60 * 60 * 1000);

  OPEN c1;
    LOOP
      FETCH c1 INTO v_partition_name, v_high_value;
      EXIT WHEN c1%NOTFOUND;
      v_date := to_number(SUBSTR(v_high_value,0));

      IF v_date < v_left_point then
--       INSERT_LOG('INFO', 'Begin delete partition', SYSDATE, STSQL);
--        v_sql := 'Alter table ' || tbl_name || ' drop partition ' || v_partition_name || ' update global indexes';
--        DBMS_OUTPUT.PUT_LINE(v_sql);
------        execute immediate v_sql;
--        EXECUTESQL(v_sql);
        INSERT_LOG('FINISH','Deleted partition ' || v_partition_name,SYSDATE,v_sql);
      END IF;
    END LOOP;

  CLOSE c1;
EXCEPTION
  WHEN TIMEOUT_ON_RESOURCE THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('TIMEOUT_ON_RESOURCE ','Cannot delete partition ' || v_partition_name || 'Error is:' ||
ERR_MSG,SYSDATE,v_sql);
      ROLLBACK;
  WHEN STORAGE_ERROR THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('STORAGE_ERROR ','Cannot delete partition ' || v_partition_name || 'Error is:' || ERR_MSG,SYSDATE,v_sql);
      ROLLBACK;
  WHEN OTHERS THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('ERROR ','Cannot delete partition ' || v_partition_name || 'Error is:' || ERR_MSG,SYSDATE,v_sql);
    ROLLBACK;
END del_data_chat;



--------------------------------------------------------
--  DDL for Procedure EXECUTESQL
--------------------------------------------------------


  PROCEDURE "EXECUTESQL"
   ( STRING IN varchar2)
   IS
    cursor_name INTEGER;
    ret INTEGER;
BEGIN
    cursor_name := DBMS_SQL.OPEN_CURSOR;
    DBMS_SQL.PARSE(cursor_name, string, DBMS_SQL.native);
    ret := DBMS_SQL.EXECUTE(cursor_name);
    DBMS_SQL.CLOSE_CURSOR(cursor_name);
END; -- Procedure



--------------------------------------------------------
--  DDL for Procedure GETEMPS
--------------------------------------------------------


  PROCEDURE "GETEMPS" ( p_cursor out rs_types.ins_refcur)
as
rs_rec p_cursor%rowtype;
begin

open p_cursor for select id, agent_id from agent;

     loop
        fetch p_cursor into rs_rec;
        exit when p_cursor%notfound;
          dbms_output.put_line('AgentId:' || rs_rec.agent_id);
    end loop;
  COMMIT;
  close p_cursor;
end;



--------------------------------------------------------
--  DDL for Procedure GETGROUP
--------------------------------------------------------


  PROCEDURE "GETGROUP" (
  -- lay de qui danh sach nhom con
  -- chu y can dat job chay thu tuc synVSALoc de dong bo table location tu vsa
  -- so di de dong bo vi loi: ORA-02016: cannot use a subquery in a START WITH on a remote database
   rs in out rs_types.rs_cursor,
 userId NUMBER,
 parentId NUMBER,
 groupList VARCHAR2
) AS
  root_group_id number;
--  type t_row is record (group_id number, parent_id number, group_name VARCHAR2(50));
--  v_rec t_row;
BEGIN

select group_id into root_group_id from vsa_users where user_id = userid;

if groupList is null or groupList = '' THEN
    open rs for select distinct group_id , parent_id, group_name
    from vsa_group D start with d.group_id = root_group_id
    connect by prior d.group_id = d.parent_id;
else

    open rs for select distinct group_id , parent_id, group_name
    from vsa_group d start with d.group_id in (
              select regexp_substr(groupList,'[^,]+', 1, level) from dual
              connect by REGEXP_SUBSTR(groupList, '[^,]+', 1, level) is not null
              )
    connect by prior d.group_id = d.parent_id;
    -- print test
--        loop
--          fetch rs into v_rec;
--          exit when rs%notfound;
--          DBMS_OUTPUT.PUT_LINE('group_id = ' || v_rec.group_id);
--        end loop;
end if;
END GETGROUP;



--------------------------------------------------------
--  DDL for Procedure INSERT_LOG
--------------------------------------------------------


  PROCEDURE "INSERT_LOG" (P_LOG_INFO VARCHAR2,
                                       P_LOG_DESC VARCHAR,
                                       P_LOG_DATE DATE,
                                       P_LOG_SQL  VARCHAR2) IS
-- xu ly loi cannot perform a DML operation inside a query
PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
  INSERT INTO LOG_INFO
    (LOG_ID, LOG_INFO, LOG_DESC, LOG_DATE, LOG_SQL)
  VALUES
    (LOG_INFO_SEQ.NEXTVAL, P_LOG_INFO, P_LOG_DESC, P_LOG_DATE, P_LOG_SQL);
  COMMIT;
END;



--------------------------------------------------------
--  DDL for Procedure PARTITION_ADD_ALL
--------------------------------------------------------


  PROCEDURE "PARTITION_ADD_ALL" (LENGTH IN NUMBER) IS

  ERR_MSG VARCHAR2(1000);

BEGIN
   PARTITION_CREATE_TABLE('CALLINFO','CINFO',7);
   PARTITION_CREATE_TABLE('CALL','CALL',7);
   PARTITION_CREATE_TABLE('TRANS_INFO','TRANS',7);
   PARTITION_CREATE_TABLE('DTMF_LOG','DTMF',7);
   PARTITION_CREATE_TABLE('AGENT','AGENT',7);
   PARTITION_CREATE_TABLE('BLACK_LIST_LOG','BLLG',7);
   PARTITION_CHAT_MESSAGE('CHAT_MESSAGE','CME',7);
   PARTITION_CHAT_MESSAGE('CHAT_CONFERENCE','CCE',7);

EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'PARTITION_ADD_ALL' || ERR_MSG,

  SYSDATE,

  '');
END;



--------------------------------------------------------
--  DDL for Procedure PARTITION_CHAT_MESSAGE
--------------------------------------------------------


  PROCEDURE "PARTITION_CHAT_MESSAGE" (TABLE_NAME IN VARCHAR, PREFIX IN VARCHAR, LENGTH IN NUMBER) IS

  ERR_MSG VARCHAR2(1000);

  STRSQL VARCHAR2(2000);

  WNEWPARTITION VARCHAR2(28);

  WVALUELESSTHAN NUMBER;

  STSQL VARCHAR2(500);

  WMONPARTITION VARCHAR(10);

  WTABLESPACE VARCHAR(100);

BEGIN
  WTABLESPACE:='IPCC_CHAT';
  STSQL := 'Alter session set nls_date_format = ''dd/mm/yyyy''';

  EXECUTE IMMEDIATE STSQL;

  INSERT_LOG('INFO', 'Begin create partition', SYSDATE, STSQL);

  --Dat ten parttion
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH, 'yyyymmdd')

  INTO WNEWPARTITION

  FROM DUAL;

  --Khoang gia tri phan chia partition
  SELECT (TRUNC(SYSDATE)+LENGTH +1-TO_DATE('01011970','DDMMYYYY')) *60*60*24*1000
  INTO WVALUELESSTHAN
  from DUAL;

  --Cau lenh thuc hien danh partition
  STRSQL := 'Alter table ' || TABLE_NAME || ' ADD PARTITION ' || PREFIX ||

  WNEWPARTITION || ' values less than ('|| WVALUELESSTHAN || ') tablespace '|| WTABLESPACE;

  EXECUTESQL(STRSQL);

  INSERT_LOG('FINISH',

  'Created partition ' || WNEWPARTITION,

  SYSDATE,

  STRSQL);

  RETURN;

EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'Cannot create partition ' || WNEWPARTITION || '

  Error is:' || ERR_MSG,

  SYSDATE,

  STRSQL);

END;


--------------------------------------------------------
--  DDL for Procedure PARTITION_CREATE_TABLE
--------------------------------------------------------


  PROCEDURE "PARTITION_CREATE_TABLE" (TABLE_NAME IN VARCHAR, PREFIX IN VARCHAR, LENGTH IN NUMBER) IS

  ERR_MSG VARCHAR2(1000);

  STRSQL VARCHAR2(2000);

  WNEWPARTITION VARCHAR2(28);

  WVALUELESSTHAN VARCHAR2(28);

  STSQL VARCHAR2(500);

  WMONPARTITION VARCHAR(10);

  WTABLESPACE VARCHAR(100);

BEGIN

  STSQL := 'Alter session set nls_date_format = ''dd/mm/yyyy''';

  EXECUTE IMMEDIATE STSQL;

  INSERT_LOG('INFO', 'Begin create partition', SYSDATE, STSQL);

  --Lay month cua partition
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH, 'MM')

  INTO WMONPARTITION

  FROM DUAL;

  --Lua chon tablespace cho partition
  if '01' <= WMONPARTITION AND WMONPARTITION <= '03' THEN
     WTABLESPACE:='IPCC_DATA2012_I';

  elsif '04' <= WMONPARTITION AND WMONPARTITION <= '06' THEN
     WTABLESPACE:='IPCC_DATA2012_II';

  elsif '07' <= WMONPARTITION AND WMONPARTITION <= '09' THEN
     WTABLESPACE:='IPCC_DATA2012_III';

  elsif '10' <= WMONPARTITION AND WMONPARTITION <= '12' THEN
     WTABLESPACE:='IPCC_DATA2012_IV';
  else
     WTABLESPACE:='IPCC_CCMS';

  end if;

  --Dat ten parttion
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH, 'yyyymmdd')

  INTO WNEWPARTITION

  FROM DUAL;

  --Khoang gia tri phan chia partition
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH+ 1, 'dd/mm/yyyy')

  INTO WVALUELESSTHAN

  FROM DUAL;

  --Cau lenh thuc hien danh partition
  STRSQL := 'Alter table ' || TABLE_NAME || ' ADD PARTITION ' || PREFIX ||

  WNEWPARTITION || ' values less than (TO_DATE(''' ||

  TO_CHAR(WVALUELESSTHAN) ||

  ''' ,''dd/mm/yyyy'')) tablespace '|| WTABLESPACE;

  EXECUTESQL(STRSQL);

  INSERT_LOG('FINISH',

  'Created partition ' || WNEWPARTITION,

  SYSDATE,

  STRSQL);

  RETURN;

EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'Cannot create partition ' || WNEWPARTITION || '

  Error is:' || ERR_MSG,

  SYSDATE,

  STRSQL);

END;



--------------------------------------------------------
--  DDL for Procedure PARTITION_DEL_FULLSCAN
--------------------------------------------------------


  PROCEDURE "PARTITION_DEL_FULLSCAN" (DAY_NUM  IN NUMBER) IS
  ERR_MSG       VARCHAR2(1000);

BEGIN
  del_data('AGENT', day_num);
  del_data('CALL', day_num);
  del_data('CALLINFO', day_num);
  del_data('DTMF_LOG', day_num);
  del_data('TRANS_INFO', day_num);
  del_data('BLACK_LIST_LOG', 90);
  del_data_chat('CHAT_MESSAGE',90);
  del_data_chat('CHAT_CONFERENCE',90);
EXCEPTION
  WHEN OTHERS THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('ERROR ','Error is:' || ERR_MSG,SYSDATE,'partition_del_fullscan');
    ROLLBACK;
END partition_del_fullscan;

--------------------------------------------------------
--  DDL for Procedure PROC_DOSEARCH2_WS
--------------------------------------------------------


  PROCEDURE "PROC_DOSEARCH2_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,
  pagentid in varchar2,
  pcaller in varchar2,
  pminduration in number,
  pmaxduration in number,
  prn in number,
  prownum in number
) AS
begin
     open RS for
          select agent_id, startd, ring, connectd, endt, conference_time, url, caller, called  from (
          select agent_id
          , to_char(start_time,'yyyy-MM-dd hh24:mi:ss') as startd
          ,to_char(ring_time,'yyyy-MM-dd hh24:mi:ss') as ring
          ,to_char(connect_time,'yyyy-MM-dd hh24:mi:ss') as connectd
          ,to_char(end_time,'yyyy-MM-dd hh24:mi:ss') as endt
          ,answer_time as conference_time, url, caller, called
          ,row_number() over (partition by agent_id order by dbms_random.value) rn
          from call
          where START_TIME BETWEEN fromdate and todate
        --  and answer_time > 0
          and call_type = 0

         and (agent_id in (select REGEXP_SUBSTR(pagentid,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(pagentid, '[^,]+', 1, level) is not null ))
          --and (pcaller is null or pcaller = '' or caller like '%'||pcaller||'%')
          and caller like '%'||pcaller||'%'
          and answer_time between pminduration and pmaxduration)
          where rn<=prn
          and rownum<=prownum
 ;
END PROC_DOSEARCH2_WS;



--------------------------------------------------------
--  DDL for Procedure PROC_GETAGENTCHATLOG
--------------------------------------------------------


  PROCEDURE "PROC_GETAGENTCHATLOG" (
-- thong ke chat
  rs in out rs_types.rs_cursor,
  fromDate in NUMBER,
  toDate in NUMBER,
  listSender in VARCHAR2,
  listReceiver in VARCHAR2,
  pmax in number
) AS
BEGIN
  open rs for select time,  sender, receiver, message from chat_message
  where time between fromDate and toDate
   and (listSender is null or listSender = '' or lower(sender) in (
      select regexp_substr(listSender,'[^,]+', 1, level) from dual
      connect by regexp_substr(listSender, '[^,]+', 1, level) is not null ))
   and (listReceiver is null or listReceiver = '' or lower(receiver) in (
      select regexp_substr(listReceiver,'[^,]+', 1, level) from dual
      connect by regexp_substr(listReceiver, '[^,]+', 1, level) is not null ))
  order by chat_conference_id, time asc;
END PROC_GETAGENTCHATLOG;



--------------------------------------------------------
--  DDL for Procedure PROC_GETAVGWAITINGTIME
--------------------------------------------------------


  PROCEDURE "PROC_GETAVGWAITINGTIME" (
-- thong ke thoi gian cho trung binh
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pjoined in number,
  pmax in number
) AS
BEGIN
  if ptimetype = 0 then
    open rs for select * from (select to_char(trunc(start_time,'hh24'),'dd-MM-yyyy hh24:mi:ss') as date_hour,
    count(distinct call_id) total_call,
    round(max(case when first_connect_time is null then duration else waiting_time end)) time_max,
    round(min(case when first_connect_time is null then duration else waiting_time end)) time_min,
    round(avg(case when first_connect_time is null then duration else waiting_time end)) time_av
    from callinfo where start_time between fromDate and toDate
    and (pcustlevel = -1 or customer_level = pcustLevel)
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (pjoined = -1 or (pjoined = 1 and joined = 0) or (pjoined = 0 and joined > 0))
   -- and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
    and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    group by trunc(start_time,'hh24')
    order by date_hour desc)
    WHERE rownum <= pmax;
  else
    open rs for select * from (select to_char(trunc(start_time),'dd-MM-yyyy') as date_hour,
    count(distinct call_id) total_call,
    round(max(case when first_connect_time is null then duration else waiting_time end)) time_max,
    round(min(case when first_connect_time is null then duration else waiting_time end)) time_min,
    round(avg(case when first_connect_time is null then duration else waiting_time end)) time_av
    from callinfo where start_time between fromDate and toDate
    and (pcustlevel = -1 or customer_level = pcustLevel)
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (pjoined = -1 or (pjoined = 1 and joined = 0) or (pjoined = 0 and joined > 0))
    --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
    and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    group by trunc(start_time)
    order by date_hour desc)
    WHERE rownum <= pmax;
  end if;
END PROC_GETAVGWAITINGTIME;



--------------------------------------------------------
--  DDL for Procedure PROC_GETBLACKLISTLOG
--------------------------------------------------------


  PROCEDURE "PROC_GETBLACKLISTLOG" (
 --thong ke lich su chan mo thue bao
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pmax in number
) AS
BEGIN
    open rs for select black_list_id,total_call,status,line_id,
    to_char(last_lock_time,'yyyy-MM-dd hh24:mi:ss') as lastLockTime,
    to_char(last_unlock_time,'yyyy-MM-dd hh24:mi:ss') lastUnLockTime,
    last_lock_actor,last_unlock_actor,description,lock_level,caller,sms_status
    from black_list_log
    where insert_time between fromDate and toDate
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%')
    and line_id = pcalled
    order by insert_time desc;
END PROC_GETBLACKLISTLOG;





--------------------------------------------------------
--  DDL for Procedure PROC_GETBLACKLISTTOSENDTOBCCS
--------------------------------------------------------


  PROCEDURE "PROC_GETBLACKLISTTOSENDTOBCCS" (
  rs in out rs_types.rs_cursor
) AS
BEGIN
    open rs for select black_list_id,status,caller,line_id,lock_level,lock_sum, to_char(insert_time,'dd/MM/yyyy hh24:mi:ss'), last_lock_actor,last_unlock_actor
      from black_list
      where is_sent != 1 and rownum < 1000
      order by insert_time;
END PROC_GETBLACKLISTTOSENDTOBCCS;



--------------------------------------------------------
--  DDL for Procedure PROC_GETCALLBYFIRSTNUMBER
--------------------------------------------------------


  PROCEDURE "PROC_GETCALLBYFIRSTNUMBER" (
 --THONG KE THEO DAU SO KHACH HANG
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pcallType in number,
  ptype in number,
  listShortCode in VARCHAR2,
  pwaitTime in number,
  pduration in number,
  pmax in number
) AS
BEGIN
    open rs for select b.short_code_id,a.called,count(*) as num_call,
    count(DISTINCT a.caller) as num_caller,
    round(avg(a.duration)) as avgTime,
    count( case when a.acd_time < 10 then a.call_id end) as haveNoDemand,
    count( case when a.acd_time >= 10 then a.call_id end) as haveDemand,
    round(avg(case when a.acd_time < 10 then a.duration end)) as timeNoDemand,
    round(avg(case when a.acd_time >= 10 then a.duration end)) as timeHaveDemand,
    b.short_code_name from callinfo a, short_code b
    where a.start_time between fromDate and toDate
    and substr(a.caller,1, length(b.short_code_id)) = b.short_code_id
    and a.call_type = 0 and a.called_type = 1
    and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (listshortcode is null or listshortcode = '' or b.short_code_id in (
      select regexp_substr(listShortCode,'[^,]+', 1, level) from dual
      connect by regexp_substr(listShortCode, '[^,]+', 1, level) is not null ))
    and a.start_time between fromDate and toDate
  --  and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
    and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    group by b.short_code_id ,a.called,b.short_code_name
    order by b.short_code_id ,a.called,b.short_code_name;
END PROC_GETCALLBYFIRSTNUMBER;



--------------------------------------------------------
--  DDL for Procedure PROC_GETCALLBYHH
--------------------------------------------------------


  PROCEDURE "PROC_GETCALLBYHH" (
 -- thong ke theo thoi gian nghe (kenh IVR)
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    -- theo gio
    open rs for select to_char(trunc(a.start_time,'hh24'),'dd-MM-yyyy hh24:mi:ss') as date_hour,
    a.called , count(a.call_id) as totalCalls ,
    count(DISTINCT a.caller) as totalCallers,
    sum(duration) as totalTimes ,
    max(duration) as maxTime,
    min(duration) as minTime,
    trunc(avg (duration),3) as avgTime
     from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    group by trunc(a.start_time,'hh24'), a.called;
  else
  -- theo ngay
    open rs for select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour,
    a.called , count(a.call_id) as totalCalls ,
    count(DISTINCT a.caller) as totalCallers,
     sum(duration) as totalTimes ,
    max(duration) as maxTime,
    min(duration) as minTime,
    trunc(avg (duration),3) as avgTime
     from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    group by trunc(a.start_time);
  end if;
END PROC_GETCALLBYHH;



--------------------------------------------------------
--  DDL for Procedure PROC_GETCALLBYMM
--------------------------------------------------------


  PROCEDURE "PROC_GETCALLBYMM" (
 -- thong ke cuoc goi theo phut (kenh IVR)
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
  if ptype = 1 then
    -- theo gio
    open rs for select * from (select to_char(trunc(a.start_time,'hh24'),'dd-MM-yyyy hh24:mi:ss') as date_hour,
    a.called , count(distinct a.call_id) as totalCalls,
    count(distinct a.caller) as totalCallers,
    round(a.duration/60 + 0.5) as totalTimes
    from callinfo a where a.start_time between fromDate and toDate
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
          --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
          and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    group by trunc(a.start_time,'hh24'),a.called, round(a.duration/60 + 0.5))
    where rownum <= pmax;
  else
  -- theo ngay
    open rs for select * from (select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour,
    a.called , count(distinct a.call_id) as totalCalls,
    count(distinct a.caller) as totalCallers,
    round(a.duration/60 + 0.5) as totalTimes
    from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
          --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
          and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    group by trunc(a.start_time),a.called, round(a.duration/60 + 0.5))
    where rownum <= pmax;
  end if;
END PROC_GETCALLBYMM;



--------------------------------------------------------
--  DDL for Procedure PROC_GETCALLERDETAIL
--------------------------------------------------------


  PROCEDURE "PROC_GETCALLERDETAIL" (
 --THONG KE CHI TIET KHACH HANG
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pwaitTime in number,
  pduration in number,
  pmax in number
) AS
BEGIN

        open rs for select * from  (select caller, count(distinct call_id) total,
    count(distinct case when joined >=1 then call_id end) total_meet,
    count(distinct case when (joined = 0 or joined is null) then call_id end) total_miss
    from callinfo
    where  start_time between fromDate and toDate
    and (pcustlevel = -1 or customer_level = pcustLevel)
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%' escape '\')
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and ROUTING_TIME IS NULL
   -- and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
    and nvl(auto_transfer,0) not in (2,3)  -- LamNV10 sua R8247
    group by caller)
    where rownum <=pmax;
END PROC_GETCALLERDETAIL;



--------------------------------------------------------
--  DDL for Procedure PROC_GETCOLLECTCALLACD_OMAP2
--------------------------------------------------------


  PROCEDURE "PROC_GETCOLLECTCALLACD_OMAP2"
  (
    rs OUT rs_types.rs_cursor,
    slttransfertype  IN NUMBER,
    fromdate      IN DATE,
    todate        IN DATE,
    listline      IN VARCHAR2,
    listline1     IN VARCHAR2,
    sltreporttype IN NUMBER,
    chkgroupby    IN NUMBER,
    timetype      IN NUMBER,
    groupname     IN VARCHAR2,
    agentuname    IN VARCHAR2,
    pcallid       IN VARCHAR2,
    numbercaller  IN VARCHAR2,
    pdeviceid     IN VARCHAR2,
    pmax          IN NUMBER)
AS
BEGIN
  /*Thong ke tong hop, nhom theo agent khong duoc chon*/
  -- Theo ngay
  IF slttransfertype = 0 THEN
  IF sltreporttype = 0 AND chkgroupby = -1 AND timetype = 0 THEN
    OPEN rs FOR SELECT TO_CHAR (TRUNC (a.start_time), 'dd/mm/yyyy') date_hour, called,
    COUNT (DISTINCT a.caller) AS tongsothuebao, COUNT (DISTINCT a.call_id) AS tongsocuoc
    FROM callinfo a WHERE a.start_time BETWEEN fromdate AND todate
    AND (listline IS NULL OR listline = '' OR called IN
      (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
      ))
    AND (listline1 IS NULL OR listline1 = '' OR transfer_called IN
      (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
      ) )
    AND nvl(auto_transfer,0) = 0
    AND (agentuname  IS NULL OR agentuname = '' OR lower(transfer_agent_uname) LIKE '%' || lower(agentuname) || '%' escape '\')
    AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
    AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
    AND (pdeviceid IS NULL OR pdeviceid = '' OR transfer_device_id LIKE '%' || pdeviceid || '%' escape '\')
    AND transfer_agent_uname IN (SELECT user_name FROM vsa_users
      WHERE group_id IN (SELECT REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) IS NOT NULL
      ))
      --end hungnd35
--     AND ROWNUM <= pmax
     GROUP BY TRUNC (a.start_time), called
     ORDER BY date_hour;
    /*Thong ke tong hop theo gio : nhom theo agent khong duoc chon*/
  ELSIF sltreporttype = 0 AND chkgroupby = -1 AND timetype = 1 THEN

     OPEN rs FOR SELECT  TO_CHAR (TRUNC (a.start_time, 'hh24'), 'dd/mm/yyyy hh24:mi:ss') date_hour, called,
    COUNT (DISTINCT a.caller) AS tongsothuebao, COUNT (DISTINCT a.call_id) AS tongsocuoc
    FROM callinfo a WHERE a.start_time BETWEEN fromdate AND todate
    AND (listline IS NULL OR listline = '' OR called IN
      (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
      ))
    AND (listline1 IS NULL OR listline1 = '' OR transfer_called IN
      (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
      ) )
    AND nvl(auto_transfer,0) = 0
     AND (agentuname  IS NULL OR agentuname = '' OR lower(transfer_agent_uname) LIKE '%' || lower(agentuname) || '%' escape '\')
    AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
    AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
    AND (pdeviceid IS NULL OR pdeviceid = '' OR transfer_device_id LIKE '%' || pdeviceid || '%' escape '\')
    AND transfer_agent_uname IN (SELECT user_name FROM vsa_users
      WHERE group_id IN (SELECT REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) IS NOT NULL
      ))
--    AND ROWNUM <= pmax
    GROUP BY TRUNC (a.start_time, 'hh24'), called
    ORDER BY date_hour desc;

    /* Thong ke tong hop, nhom theo agent duoc chon*/
    --    Theo ngay
  ELSIF sltreporttype = 0 AND chkgroupby = 1 AND timetype = 0 THEN
    OPEN rs FOR SELECT TO_CHAR (TRUNC (a.start_time), 'dd/mm/yyyy') date_hour, called, transfer_agent_uname, COUNT (*) AS
    tongsocuoc FROM callinfo a WHERE a.start_time BETWEEN fromdate AND todate

    AND (listline IS NULL OR listline = '' OR called IN
      (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
      ))
    AND (listline1 IS NULL OR listline1 = '' OR transfer_called IN
      (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
      ) )
    AND nvl(auto_transfer,0) = 0
    AND (agentuname  IS NULL OR agentuname = '' OR lower(transfer_agent_uname) LIKE '%' || lower(agentuname) || '%' escape '\')
    AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
    AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
    AND (pdeviceid IS NULL OR pdeviceid = '' OR transfer_device_id LIKE '%' || pdeviceid || '%' escape '\')
    AND transfer_agent_uname IN (SELECT user_name FROM vsa_users
      WHERE group_id IN (SELECT REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) IS NOT NULL
      ))

--      AND ROWNUM <= pmax
      GROUP BY TRUNC (a.start_time), transfer_agent_uname, called
      ORDER BY date_hour desc;
    --Theo gio
  ELSIF sltreporttype = 0 AND chkgroupby = 1 AND timetype = 1 THEN
   OPEN rs FOR SELECT TO_CHAR (TRUNC (a.start_time, 'hh24'), 'dd/mm/yyyy hh24:mi:ss') date_hour, called, transfer_agent_uname, COUNT (*) AS
    tongsocuoc FROM callinfo a WHERE a.start_time BETWEEN fromdate AND todate

    AND (listline IS NULL OR listline = '' OR called IN
      (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
      ))
    AND (listline1 IS NULL OR listline1 = '' OR transfer_called IN
      (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
      ) )
    AND nvl(auto_transfer,0) = 0
    AND (agentuname  IS NULL OR agentuname = '' OR lower(transfer_agent_uname) LIKE '%' || lower(agentuname) || '%' escape '\')
    AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
    AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
    AND (pdeviceid IS NULL OR pdeviceid = '' OR transfer_device_id LIKE '%' || pdeviceid || '%' escape '\')
    AND transfer_agent_uname IN (SELECT user_name FROM vsa_users
      WHERE group_id IN (SELECT REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) IS NOT NULL
      ))

--      AND ROWNUM <= pmax
      GROUP BY TRUNC (a.start_time, 'hh24'), transfer_agent_uname, called
      ORDER BY date_hour desc;
    /* thong ke chi tiet*/
  ELSE
    OPEN rs FOR SELECT call_id, caller, called, transfer_device_id, call_type, TO_CHAR (a.start_time, 'dd/mm/yyyy hh24:mi:ss') date_hour,
    TO_CHAR(a.first_connect_time, 'dd/mm/yyyy hh24:mi:ss') first_connect_time, transfer_agent_uname,
    transfer_time, transfer_called
    FROM callinfo a
    WHERE a.start_time BETWEEN fromdate AND todate
     AND (listline IS NULL OR listline = '' OR called IN
      (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
      ))
    AND (listline1 IS NULL OR listline1 = '' OR transfer_called IN
      (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
      ) )
    AND nvl(auto_transfer,0) = 0
    AND (agentuname  IS NULL OR agentuname = '' OR lower(transfer_agent_uname) LIKE '%' || lower(agentuname) || '%' escape '\')
    AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
    AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
    AND (pdeviceid IS NULL OR pdeviceid = '' OR transfer_device_id LIKE '%' || pdeviceid || '%' escape '\')
    AND transfer_agent_uname IN (SELECT user_name FROM vsa_users
      WHERE group_id IN (SELECT REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) FROM DUAL
        CONNECT BY REGEXP_SUBSTR (groupname, '[^,]+', 1, LEVEL ) IS NOT NULL
      ))
    and rownum <= pmax
    ORDER BY date_hour desc;
  END IF;
  ELSIF slttransfertype = 1 THEN
        /* Thong ke tong hop cuoc goi transfer tu dong theo ngay */
      IF sltreporttype = 0 AND timetype = 0 THEN
        OPEN rs FOR SELECT TO_CHAR (TRUNC (a.start_time), 'dd/mm/yyyy') date_hour, prev_called,
        COUNT (DISTINCT a.caller) AS tongsothuebao, COUNT (DISTINCT a.call_id) AS tongsocuoc
        FROM callinfo a WHERE a.start_time BETWEEN fromdate AND todate
        AND auto_transfer = 1
        AND (listline IS NULL OR listline = '' OR prev_called IN
          (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
            CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
          ))
        AND (listline1 IS NULL OR listline1 = '' OR called IN
          (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
            CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
          ) )

        AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
        AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
         GROUP BY TRUNC (a.start_time), prev_called
         ORDER BY date_hour;
        /* Thong ke tong hop cuoc goi transfer tu dong theo gio */
      ELSIF sltreporttype = 0 AND timetype = 1 THEN

         OPEN rs FOR SELECT  TO_CHAR (TRUNC (a.start_time, 'hh24'), 'dd/mm/yyyy hh24:mi:ss') date_hour, prev_called,
        COUNT (DISTINCT a.caller) AS tongsothuebao, COUNT (DISTINCT a.call_id) AS tongsocuoc
        FROM callinfo a WHERE a.start_time BETWEEN fromdate AND todate
        AND auto_transfer = 1
        AND (listline IS NULL OR listline = '' OR prev_called IN
          (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
            CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
          ))
        AND (listline1 IS NULL OR listline1 = '' OR called IN
          (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
            CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
          ) )

        AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
        AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
        GROUP BY TRUNC (a.start_time, 'hh24'), prev_called
        ORDER BY date_hour desc;
      ELSE
        OPEN rs FOR SELECT call_id, caller, prev_called, called, start_time
        FROM callinfo a
        WHERE a.start_time BETWEEN fromdate AND todate
        AND auto_transfer = 1
         AND (listline IS NULL OR listline = '' OR prev_called IN
          (SELECT REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) FROM DUAL
            CONNECT BY REGEXP_SUBSTR (listline, '[^,]+', 1, LEVEL) IS NOT NULL
          ))
        AND (listline1 IS NULL OR listline1 = '' OR called IN
          (SELECT REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) FROM DUAL
            CONNECT BY REGEXP_SUBSTR (listline1, '[^,]+', 1, LEVEL ) IS NOT NULL
          ) )

        AND (pcallid IS NULL OR pcallid = '' OR lower(call_id) LIKE '%' || lower(pcallid) || '%' escape '\')
        AND (numbercaller IS NULL OR numbercaller = '' OR caller LIKE '%' || numbercaller || '%' escape '\')
        and rownum <= pmax
        ORDER BY start_time desc;
      END IF;
    END IF;
END proc_getcollectcallacd_omap2;



--------------------------------------------------------
--  DDL for Procedure PROC_GETCONFCALLDETAIL
--------------------------------------------------------


  PROCEDURE "PROC_GETCONFCALLDETAIL" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  in_callid in VARCHAR2,
  in_confid in VARCHAR2,
  pmax in number
) AS
BEGIN
      open rs for select to_char(listen_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(push_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(reject_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(mc_push_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(play_start_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(play_stop_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(mc_kickout_time,'dd/MM/yyyy hh24:mi:ss'),
      play_duration,
      round((play_duration)/60 + 0.49)
      from conf_call_segment where call_id = in_callid
      order by listen_time;
END PROC_GETCONFCALLDETAIL;

/*
-- vannt18 comment do invalid
--------------------------------------------------------
--  DDL for Procedure PROC_GETCONFREPORT
--------------------------------------------------------


  PROCEDURE "PROC_GETCONFREPORT" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  expert in VARCHAR2,
  expertid in VARCHAR2,
  agentid in VARCHAR2,
  deviceid in VARCHAR2,
  mc in VARCHAR2,
  mcid in VARCHAR2,
  in_caller in VARCHAR2,
  listConfId in VARCHAR2,
  in_callid in VARCHAR2,
  ptimetype in number,
  reporttype in NUMBER,
  reportid in VARCHAR2,
  pmax in number
) AS

cout NUMBER := 0;
BEGIN
--insert into tbltest(id, val) values(test_seq.nextval, listline);
--insert into tbltest(id, val) values(test_seq.nextval, listconfid);

COMMIT;
-- thong ke chi tiet cuoc goi
  if reportid = 'CR001' then
      open rs for select a.call_id,a.caller,a.expert_id,a.expert_uname,a.agent_id,a.agent_uname,to_char(a.agent_connect_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(a.join_start_time,'dd/MM/yyyy hh24:mi:ss'),to_char(a.expert_connect_time,'dd/MM/yyyy hh24:mi:ss'),
      to_char(a.join_stop_time,'dd/MM/yyyy hh24:mi:ss'),a.call_duration, a.mc_id,a.mc_uname, round (a.call_duration/60 + 0.499),b.conf_title
      from conf_call a, conference@toacd b
      where a.join_start_time between fromDate and toDate and a.conf_code=b.conf_code
      and (listLine is null or listLine = '' or a.called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
      and (expert is null or expert = '' or lower(a.expert_uname) like '%' || expert || '%')
      and (expertid is null or expertid = '' or a.expert_id like '%' || expertid || '%')
      and (agentid is null or agentid = '' or lower(a.agent_uname) like '%' || agentid || '%')
      and (deviceid is null or deviceid = '' or a.agent_id like '%' || deviceid || '%')
      and (mc is null or mc = '' or lower(a.mc_uname) like '%' || mc || '%')
      and (mcid is null or mcid = '' or a.mc_id like '%' || mcid || '%')
      and (in_caller is null or in_caller = '' or a.caller like '%' || in_caller || '%')
      and (listConfId is null or listConfId = '' or a.conf_code in (
            select regexp_substr(listConfId,'[^,]+', 1, level) from dual
            connect by regexp_substr(listConfId, '[^,]+', 1, level) is not null ))
      order by join_start_time;
--      dbms_output.put_line('cout:' || cout);
  end if;
-- thong ke cuoc goi khach hang
  if reportid = 'CR002' then
      open rs for select caller, count(*) as solangoi, sum(push_count) as solanyeucau,
      sum (case when join_count >0 then 1 else 0 end) as socuocgapchuyengia,
      sum(agent_delay_duration), sum(listen_duration), sum(join_duration),
      sum(agent_delay_duration + listen_duration + join_duration),
      sum (round((agent_delay_duration + listen_duration + join_duration)/60 + 0.499))
      from conf_call where join_start_time between fromDate and toDate
      and (listLine is null or listLine = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
      and (expert is null or expert = '' or lower(expert_uname) like '%' || expert || '%')
      and (expertid is null or expertid = '' or expert_id like '%' || expertid || '%')
      and (in_caller is null or in_caller = '' or caller like '%' || in_caller || '%')
      and (listConfId is null or listConfId = '' or conf_code in (
            select regexp_substr(listConfId,'[^,]+', 1, level) from dual
            connect by regexp_substr(listConfId, '[^,]+', 1, level) is not null ))
      group by caller
      order by caller;
  end if;
  -- thong ke cuoc goi theo chuyen gia
  if reportid = 'CR003' then
      open rs for select a.expert_id, a.expert_uname, count(*) as tongsocuoc, count(distinct a.caller) as tongthuebaovao,
      count(distinct case when a.join_count = 0 then a.caller end) as tongsothuebaoroi,
      count(distinct case when a.push_count > 0 then a.caller end) as tongsothuebaoyeucaugap,
      count(distinct case when a.reject_count > 0 then a.caller end) as tongsothuebaohuy,
      count(distinct case when a.join_count > 0 then a.caller end) as tongdagap,
      sum(a.total_duration), sum(round(a.total_duration/60 + 0.499)) ,b.conf_title,a.confcall_id
      from conf_call a, conference@toacd b
      where a.join_start_time between fromDate and toDate
      and a.conf_code=b.conf_code
      and (listLine is null or listLine = '' or a.called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
      and (expert is null or expert = '' or lower(a.expert_uname) like '%' || expert || '%')
      and (expertid is null or expertid = '' or a.expert_id like '%' || expertid || '%')
      and (listConfId is null or listConfId = '' or a.conf_code in (
            select regexp_substr(listConfId,'[^,]+', 1, level) from dual
            connect by regexp_substr(listConfId, '[^,]+', 1, level) is not null ))
      group by expert_id,expert_uname,b.conf_title,a.confcall_id
      order by expert_uname;
  end if;

END PROC_GETCONFREPORT;
*/


--------------------------------------------------------
--  DDL for Procedure PROC_GETDTMFSTATISTIC
--------------------------------------------------------


  PROCEDURE "PROC_GETDTMFSTATISTIC" (
 -- THONG KE TONG HOP PHIM BAM
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  pcaller in VARCHAR2,
  pdtmf in VARCHAR2,
  pcontent in VARCHAR2,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
     open rs for select * from (select a.dtmf, b.ivr_code,sum(1) as numCall,
     sum(a.duration) as totalTime,  trunc(avg(a.duration)/60,3) as avgTime ,
     round(max(a.duration)/60 + 0.499) as maxTime ,
     round(min(a.duration)/60 + 0.499) as minTime,
     sum(number_of_visits) from dtmf_log a, ivr_tree b
     where a.start_time between fromDate and toDate
     and a.dtmf=b.dtmf and a.called=b.root_node
     and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
     and (pdtmf is null or pdtmf = '' or a.dtmf like '%' || pdtmf || '%' escape '\')
     and (pcontent is null or pcontent = '' or b.ivr_code like '%' || pcontent || '%' escape '\')
     group by a.dtmf, b.ivr_name, b.ivr_code
     order by a.dtmf, b.ivr_name)
     where rownum <= pmax;
END PROC_GETDTMFSTATISTIC;



--------------------------------------------------------
--  DDL for Procedure PROC_GETIVRBYTIMES
--------------------------------------------------------


  PROCEDURE "PROC_GETIVRBYTIMES" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listline in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  fromN in number,
  toN in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    -- THEO SO LAN: TINH TONG SO CUOC GOI = SO LAN * TONG SO THUE BAO
    open rs for select byN, count(byN), called
    from (select a.called, count(a.call_id) as byN
        from dtmf_log a where a.start_time  between fromDate and toDate
         and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
        group by a.called, a.caller)
    where byN between fromN and toN  group by called, byN
    order by called, byN;
  else
     -- THEO THUE BAO
     open rs for select caller, sumCall, sumDuration
     from (select a.caller, count(a.call_id) as sumCall, sum(a.duration) as sumDuration
     from dtmf_log a
     where a.start_time between fromDate and toDate
             and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
     and (pcaller is null or pcaller = '' or a.caller like '%' || pcaller || '%' escape '\')
     group by a.caller)
     where sumCall between fromN and toN
     order by sumCall , sumDuration;
  end if;
END PROC_GETIVRBYTIMES;
---------


--------------------------------------------------------
--  DDL for Procedure PROC_GETIVRDETAIL
--------------------------------------------------------


  PROCEDURE "PROC_GETIVRDETAIL" (
 -- THONG KE CHI TIET CUOC GOI KENH IVR
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcustLevel in number,
  pcaller in number,
  pmax in number
) AS
BEGIN

    open rs for select called,caller,to_char(start_time,'dd/MM/yyyy hh24:mi:ss') as startTime,
    to_char(end_time,'dd/MM/yyyy hh24:mi:ss') as stopTime,
    duration as seconds,
    round(duration/60 + 0.499) as minutes, short_dtmf
    from callinfo
    where start_time between fromDate and toDate
    -- and  insert_time between fromDate and toDate
    and called = pcalled
    and (pcustlevel = -1 or customer_level = pcustLevel)
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%' escape '\');
END PROC_GETIVRDETAIL;



--------------------------------------------------------
--  DDL for Procedure PROC_GETLISTAGENT_WS
--------------------------------------------------------


  PROCEDURE "PROC_GETLISTAGENT_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in TIMESTAMP,
  toDate in TIMESTAMP,
  pagentid in varchar2,
  pminduration in number,
  prownum in number
) AS
begin
     open RS for
              select agent_id, count(*) from call
              where start_time between fromDate and toDate
              and answer_time >= pminduration
              and url is not null
              and connect_time is not null
              and call_type = 0
              and (pagentid is null or pagentid = '' or agent_id = pagentid)
--              and rownum <= prownum
              group by agent_id
 ;
END PROC_GETLISTAGENT_WS;


--------------------------------------------------------
--  DDL for Procedure PROC_GETLISTCALLBYCALLER_WS
--------------------------------------------------------


  PROCEDURE "PROC_GETLISTCALLBYCALLER_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in TIMESTAMP,
  toDate in TIMESTAMP,
  pcaller in varchar2,
  pagentid in varchar2,
  pminduration in number
) AS
begin
     open RS for
              select agent_id,
              to_char(start_time,'yyyy-MM-dd hh24:mi:ss'),
              to_char(ring_time,'yyyy-MM-dd hh24:mi:ss'),
              to_char(connect_time,'yyyy-MM-dd hh24:mi:ss'),
              to_char(end_time,'yyyy-MM-dd hh24:mi:ss'),
              answer_time as conference_time,url,caller,called
              from call where start_time between fromDate and toDate
              and (pcaller is null or pcaller = '' or caller like '%'||pcaller||'%'  escape '\')
              and (pagentid is null or pagentid = '' or agent_id = pagentid)
              and answer_time >= pminduration
              and url is not null
              and connect_time is not null
              and call_type = 0
              order by agent_id
 ;
END PROC_GETLISTCALLBYCALLER_WS;



--------------------------------------------------------
--  DDL for Procedure PROC_GETLOCKEDCALLER
--------------------------------------------------------


  PROCEDURE "PROC_GETLOCKEDCALLER" (
 -- thong ke khach hang bi chan van goi len he thong
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  ptotalCall in number,
  pmax in number
) AS
BEGIN
    open rs for select * from (select a.caller, a.called, count(*) total from callinfo a
    where a.in_reason = 6
    and a.start_time between fromDate and toDate
    and a.called = pcalled
     and (pcaller is null or pcaller = '' or a.caller like '%' || pcaller || '%'  escape '\')
    group by a.caller,a.called
    having count(a.callinfo_id) >= ptotalcall)
    where rownum <= pmax;
END PROC_GETLOCKEDCALLER;



--------------------------------------------------------
--  DDL for Procedure PROC_GETMISSNOTMISSLINESUM
--------------------------------------------------------


  PROCEDURE "PROC_GETMISSNOTMISSLINESUM" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pdur1 in number,
  pdur2 in number,
  pdur3 in number,
  pmax in number
) AS
BEGIN
     if ptimetype = 0 then
    open rs for select * from (select to_char(trunc(start_time),'dd-MM-yyyy') as date_hour,
        count(distinct call_id) as TONG_SO_CUOC,
        count(distinct case when joined = 0 then call_id end) as TONG_CUOC_ROT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12) then call_id end) as ROT_DO_HT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12)
        and duration >= pdur2 then call_id end) as ROT_DO_HT_SAU_N,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        then call_id end) as ROT_DO_KH,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        and duration >= pdur3 then call_id end) as ROT_DO_KH_SAU_N,
        count(distinct case when joined = 0 and (in_reason in (2,5, 12) and a.agent_id is not null) then call_id end) as ROT_DO_DTV,
        count(distinct case when joined > 0 then call_id end) as GAP_DTV,
        count(distinct case when joined > 0 and waiting_time >= pdur1 then call_id end) as GAP_DTV_SAU_N
       from callinfo a where a.start_time between fromDate and toDate
       --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
       and nvl(auto_transfer,0) not in (2,3)  -- LamNV10 sua R8247
        and a.ROUTING_TIME IS NULL
        and (listLine is null or listline = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
        and (pcustlevel = -1 or customer_level = pcustLevel)
        group by trunc(start_time)
        order by date_hour)
        WHERE rownum <= pmax;
  else
      open rs for select * from (select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour,
        count(distinct call_id) as TONG_SO_CUOC,
        count(distinct case when joined = 0 then call_id end) as TONG_CUOC_ROT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12) then call_id end) as ROT_DO_HT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12)
        and duration >= pdur2 then call_id end) as ROT_DO_HT_SAU_N,
         count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        then call_id end) as ROT_DO_KH,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
          and duration >= pdur3 then call_id end) as ROT_DO_KH_SAU_N,
       count(distinct case when joined = 0 and (in_reason in (2,5, 12) and a.agent_id is not null) then call_id end) as ROT_DO_DTV,
        count(distinct case when joined > 0 then call_id end) as GAP_DTV,
        count(distinct case when joined > 0 and waiting_time >= pdur1 then call_id end) as GAP_DTV_SAU_N
       from callinfo a where a.start_time between fromDate and toDate
       --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
       and nvl(auto_transfer,0) not in (2,3)  -- LamNV10 sua R8247
        and a.ROUTING_TIME IS NULL
        and (listLine is null or listline = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
        and (pcustlevel = -1 or customer_level = pcustLevel)
        group by TRUNC(a.start_time,'hh24')
        order by date_hour)
       WHERE rownum <= pmax;
  end if;
END PROC_GETMISSNOTMISSLINESUM;


/*
-- vannt18 comment do invalid
--------------------------------------------------------
--  DDL for Procedure PROC_GETSIZETABLESPACE
--------------------------------------------------------


  PROCEDURE "PROC_GETSIZETABLESPACE" IS
-- Luu log kich thuoc bi chiem cua tablespace
    cursor rs is
        select b.tablespace_name name,  tbs_size SizeMb, a.free_space FreeMb
        from
        (select tablespace_name, round(sum(bytes)/1024/1024 ,2) as free_space
        from dba_free_space group by tablespace_name) a,
        (select tablespace_name, sum(bytes)/1024/1024 as tbs_size
        from dba_data_files group by tablespace_name
        UNION
        select tablespace_name, sum(bytes)/1024/1024 tbs_size
        from dba_temp_files
        group by tablespace_name ) b
        where a.tablespace_name(+)=b.tablespace_name;


  c rs%ROWTYPE;
    date_now  DATE;
BEGIN

    SELECT SYSDATE

    INTO date_now

    FROM DUAL;


    OPEN rs;

    LOOP

    FETCH rs INTO c;

    EXIT WHEN rs%NOTFOUND;

    INSERT INTO  TABLESPACE_SIZE_LOG VALUES(c.name,c.SizeMb,c.FreeMb,date_now);

    END LOOP;

-- Free cursor used by the query.

    CLOSE rs;


END PROC_GETSIZETABLESPACE;
*/


--------------------------------------------------------
--  DDL for Procedure PROC_GETSYSTEMTOTALCALL
--------------------------------------------------------


  PROCEDURE "PROC_GETSYSTEMTOTALCALL" (
-- thong ke tong thong tin he thong
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcallType in number,
  preportType in number,
  pmax in number
) AS
BEGIN
  if preporttype = 0 then
    open rs for select to_char(TRUNC(a.start_time),'dd/mm/yyyy') date_hour,
    count(distinct a.call_id) as total,
    count(distinct case when a.joined > 0 then a.call_id end) total_connected,
    count(distinct case when a.joined = 0 then a.call_id end) total_missed,
    count(distinct a.caller) total_caller,
    count(distinct case when a.joined > 0 and a.customer_level > 0 then a.call_id end) total_vip_answer,
    count(distinct case when a.joined = 0 and a.customer_level > 0 then a.call_id end) total_vip_miss,
    count(distinct case when a.joined > 0 and a.customer_level = 0 then a.call_id end) total_novip_answer,
    count(distinct case when a.joined = 0 and a.customer_level = 0 then a.call_id end) total_novip_miss
    from callinfo a where a.start_time between fromDate and toDate
    --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
    and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247

    and (listLine is null or listline = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and call_type = pcalltype
--    and rownum <= pmax
    group by TRUNC(a.start_time)
    order by date_hour desc;
  else
    open rs for select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') date_hour,
    count(distinct a.call_id) as total,
    count(distinct case when a.joined > 0 then a.call_id end) total_connected,
    count(distinct case when a.joined = 0 then a.call_id end) total_missed,
    count(distinct a.caller) total_caller,
    count(distinct case when a.joined > 0 and a.customer_level > 0 then a.call_id end) total_vip_answer,
    count(distinct case when a.joined = 0 and a.customer_level > 0 then a.call_id end) total_vip_miss,
    count(distinct case when a.joined > 0 and a.customer_level = 0 then a.call_id end) total_novip_answer,
    count(distinct case when a.joined = 0 and a.customer_level = 0 then a.call_id end) total_novip_miss
    from callinfo a where a.start_time between fromDate and toDate
    --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
    and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    and (listLine is null or listline = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and call_type = pcalltype
--    and rownum <= pmax
    group by TRUNC(a.start_time,'hh24')
    order by date_hour desc;
  end if;
END PROC_GETSYSTEMTOTALCALL;

--------------------------------------------------------
--  DDL for Procedure PROC_GETWAITINGTIME
--------------------------------------------------------


  PROCEDURE "PROC_GETWAITINGTIME" (
 -- thong ke thoi gian cho va gap trung binh
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pmax in number
) AS
BEGIN
  if ptimetype = 0 then
    open rs for select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour,
    count(distinct a.call_id) as totalCalls,
    count(distinct a.caller) as totalCallers,
    round(max(a.acd_time)) as maxTime,
    round(min(a.acd_time)) as minTime,
    round(avg (a.acd_time)) as avgTime,
    round(max(a.waiting_time)) as maxWaitTime,
    round(min(a.waiting_time)) as minWaitTime,
    round(avg (a.waiting_time)) as avgWaitTime
    from callinfo a where a.start_time between fromDate and toDate

    and a.joined > 0
    and (listLine is null or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (pcustlevel = -1 or customer_level = pcustLevel)
    group by trunc(a.start_time)
    order by date_hour desc;
  else
    open rs for select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour,
    count(distinct a.call_id) as totalCalls,
    count(distinct a.caller) as totalCallers,
    round(max(a.acd_time)) as maxTime,
    round(min(a.acd_time)) as minTime,
    round(avg (a.acd_time)) as avgTime,
    round(max(a.waiting_time)) as maxWaitTime,
    round(min(a.waiting_time)) as minWaitTime,
    round(avg (a.waiting_time)) as avgWaitTime
    from callinfo a where a.start_time between fromDate and toDate

    and a.joined > 0
    and (listLine is null or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (pcustlevel = -1 or customer_level = pcustLevel)
    group by TRUNC(a.start_time,'hh24')
    order by date_hour desc;
  end if;
END PROC_GETWAITINGTIME;



--------------------------------------------------------
--  DDL for Procedure PROC_SCAN_TO_CALL_OUT
--------------------------------------------------------


  PROCEDURE "PROC_SCAN_TO_CALL_OUT" (numout out number,num in number)
--loc danh sach khach hang goi ra
IS
  mx_dt number := 15*24*60*60;
  number_rec number := 0;
  TYPE cur_typ IS REF CURSOR;
  caller_rs cur_typ;
--  luu so thue bao
  v_caller VARCHAR2(50);
  CURSOR filter_rs
  IS
--  lay ra cac bo dieu kien loc cua nhung lich goi ra thoa man
--  lay ra dieu kien loc cho phep, thoi gian tu ngay trong dieu kien loc khong duoc chenh lech voi thoi diem hien tai 15 ngay
  select * from callout_customer_filter where callout_schedule_id in (
    select callout_schedule_id from callout_schedule where ((option_type = 0 and to_date >= sysdate) or option_type = 1)) and (round(sysdate - from_date)*24*60*60) < mx_dt;
    filter_rec filter_rs%rowtype;
BEGIN
  numout := 0;
-- duyet qua bo dieu kien loc tuong ung voi nhung lich goi ra duoc phep
  FOR filter_rec IN filter_rs
  LOOP
-- lay ra danh sach khach hang theo dieu kien loc
-- select * () where rownum <= x voi cac cau lenh co group by neu khong ket qua se khong dung
    OPEN caller_rs for select * from (select caller from callinfo where start_time between filter_rec.from_date and filter_rec.to_date and start_time >= filter_rec.from_date and start_time <= filter_rec.to_date
    and called = filter_rec.line and duration >= filter_rec.time_of_call
    group by caller having count(*) >= filter_rec.number_call) where rownum <= 1000;
--    duyet qua cac caller quet duoc de cap nhat vao bang callout_customer
      LOOP
        FETCH caller_rs
          INTO v_caller;
--          kiem tra xem khach hang da duoc cap nhat vao callout_customer trong thoi gian goi ra chua
--          select count(callout_schedule_id) into number_rec from callout_customer where caller = v_caller and act_time > filter_rec.from_date and act_time < filter_rec.to_date;
          select count(*) into number_rec from callout_customer where caller = v_caller and callout_schedule_id = filter_rec.callout_schedule_id and line = filter_rec.line;
          if number_rec = 0
            then
            --            chua ton tai thi them vao
              insert into callout_customer(callout_customer_id, callout_schedule_id, status, line, total_call, active, caller, act_time,actor)
              values (callout_customer_seq.nextval, filter_rec.callout_schedule_id,1, filter_rec.line, 0 , 1 , v_caller,sysdate,'system');
              numout := numout + 1;
          end if;
        EXIT WHEN caller_rs%NOTFOUND;
      END LOOP;
--      het 1 dieu kien loc
      commit;
  CLOSE caller_rs;
  END LOOP;
END;


--------------------------------------------------------
--  DDL for Procedure PROC_SCAN_TO_LOCK
--------------------------------------------------------


PROCEDURE "PROC_SCAN_TO_LOCK" (num out number)
--Author: duongtb
IS

  limit_rec number := 1000;
  TYPE t_call_total IS TABLE OF NUMBER;
  TYPE t_caller IS TABLE OF callinfo.caller%TYPE;
  number_rec number := 0;
  TYPE cur_typ IS REF CURSOR;
  caller_rs cur_typ;
--  khai bao con tro luat
  rule_rs cur_typ;
--  luu so thue bao
  v_caller t_caller;
--  luu tong so cuoc goi
  v_call_total t_call_total;
  sysdt date := to_date(to_char(sysdate, 'dd/MM/yyyy'),'dd/MM/yyyy');
  limit_date date := sysdt;
  d_in_month number := to_number(to_char(sysdate,'DD'));
  d_in_week number := to_number(to_char(sysdate,'D'));
  t_max_dur number := 0;
  t_max_num number := 0;
  t_line_id VARCHAR2(50);
  t_count number := 0;
  CURSOR filter_rs
    IS
  --  lay ra cac bo dieu kien loc mac dinh theo kenh
    select * from line_param;
      filter_rec filter_rs%rowtype;
BEGIN
-- duyet qua bo dieu kien loc mac dinh theo kenh
  FOR filter_rec IN filter_rs
  LOOP
      t_line_id := filter_rec.line_id;
      t_max_dur := filter_rec.max_duration_call;
      t_max_num := filter_rec.max_num_call;
--  duyet qua tat ca cac kenh, xu ly uu tien luat theo tung kenh
    select count(*) into t_count from rule_exception where working_start_time <= sysdt and working_stop_time >= sysdt
    and ((rule_type_id = 0 and mod(round(sysdt - working_start_time), day_cycle_usage) = 0)
      or (rule_type_id = 1 and (monday = d_in_week or tuesday = d_in_week or wednesday = d_in_week or thursday = d_in_week or friday= d_in_week or saturday= d_in_week or sunday= d_in_week))
      or (rule_type_id = 2 and day_usage = d_in_month)
    )
    and line_id = t_line_id
    order by rule_type_id asc, insert_time desc;

    if t_count > 0 then
           select line_id,max_duration_call, max_num_call into t_line_id, t_max_dur, t_max_num from (select line_id, max_duration_call, max_num_call from rule_exception where working_start_time <= sysdt and working_stop_time >= sysdt
            and ((rule_type_id = 0 and mod(round(sysdt - working_start_time), day_cycle_usage) = 0)
              or (rule_type_id = 1 and (monday = d_in_week or tuesday = d_in_week or wednesday = d_in_week or thursday = d_in_week or friday= d_in_week or saturday= d_in_week or sunday= d_in_week))
              or (rule_type_id = 2 and day_usage = d_in_month)
            )
            and line_id = t_line_id
            order by rule_type_id asc, insert_time desc) where rownum <= 1;
    end if;
    DBMS_OUTPUT.PUT_LINE('to_day = ' || d_in_month);
    DBMS_OUTPUT.PUT_LINE('to_day in week = ' || d_in_week);
    DBMS_OUTPUT.PUT_LINE('t_line_id = ' || t_line_id);
    DBMS_OUTPUT.PUT_LINE('t_max_dur = ' || t_max_dur);
    DBMS_OUTPUT.PUT_LINE('t_max_num = ' || t_max_num);
--  ket thuc xu ly uu tien luat
-- lay ra danh sach khach hang theo dieu kien loc
    OPEN caller_rs for select caller, count(*) as call_total from callinfo where start_time >= limit_date
    and called = t_line_id
--and duration >= t_max_dur
    --ThanhNN17: cap nhat tinh nang chan blacklist
    and acd_time >= t_max_dur

    group by caller having count(*) >= t_max_num;
--    duyet qua cac caller quet duoc de cap nhat
      LOOP
        FETCH caller_rs bulk collect
          INTO v_caller, v_call_total limit limit_rec;
             EXIT WHEN v_caller.COUNT = 0;
              FOR i IN v_caller.FIRST .. v_caller.LAST
                 LOOP
--  kiem tra xem khach hang da duoc cap nhat vao BlackList theo kenh
                      select count(*) into number_rec from black_list where caller = v_caller(i) and line_id = t_line_id;
                      DBMS_OUTPUT.PUT_LINE('num_rec = ' || number_rec);
                    if number_rec > 0 then
                        select count(*) into number_rec from black_list where caller = v_caller(i) and line_id = t_line_id and status = 0;
                        if number_rec > 0 then
                          update black_list set status = 1,lock_level=1,total_call = v_call_total(i), last_lock_time = sysdate, last_lock_actor='System', insert_time=sysdate, is_sent=0, is_actual_change=1, is_request_unlock=0
                          where caller = v_caller(i) and line_id = t_line_id;
                        end if;
                    else
                        insert into black_list(black_list_id, caller, status, sms_status, lock_level, total_call,line_id,last_lock_time, last_lock_actor, insert_time,is_sent, is_actual_change, is_request_unlock)
                        values(blacklist_seq.nextval,v_caller(i), 1, 0, 1, v_call_total(i), t_line_id, sysdate,'System',sysdate,0,1,0);
                    end if;
                    num := num + 1;
                 END LOOP;


--
        EXIT WHEN caller_rs%NOTFOUND;
      END LOOP;
--  het 1 dieu kien loc
--  xu ly xong 1 kenh
      commit;
  CLOSE caller_rs;
  END LOOP;

END;


--------------------------------------------------------
--  DDL for Procedure PROC_SCAN_TO_OPEN
--------------------------------------------------------


  PROCEDURE "PROC_SCAN_TO_OPEN" (num out number) AS
--- Author :duongtb
  lock_duration number := 48*60*60;
  TYPE cursor_type IS REF CURSOR;
  rs_cur cursor_type;
  in_caller black_list.caller% TYPE;
  in_called black_list.line_id% TYPE;
  TYPE t_caller IS TABLE OF black_list.caller% TYPE;
  TYPE t_called IS TABLE OF black_list.line_id% TYPE;
  v_caller t_caller;
  v_called t_called;
   limit_rec number := 1000;
BEGIN
  num := 0;
  select param_value into lock_duration from param WHERE param_code='LOCK_DURATION';
-- chuyen sang s
  lock_duration := lock_duration*60;
   open
----      rs_cur for select caller, line_id from black_list where status = 1 and is_request_unlock = 1 and lock_level = 1 and (sysdate - insert_time)*24*60*60 >= lock_duration;
      rs_cur for select caller, line_id from black_list where status = 1 and lock_level = 1 and (sysdate - insert_time)*24*60*60 >= lock_duration;
--        LOOP
--              FETCH rs_cur INTO in_caller, in_called;
--                  EXIT WHEN rs_cur%NOTFOUND;
--                    update black_list set status = 0, last_unlock_time = sysdate, last_unlock_actor = 'System' , insert_time = sysdate where caller = in_caller and line_id = in_called;
--                    num := num + 1;
--        END LOOP;
        ----
         LOOP
            FETCH rs_cur bulk collect
              INTO v_caller, v_called limit limit_rec;
              EXIT WHEN v_caller.COUNT = 0;
              FOR i IN v_caller.FIRST .. v_caller.LAST
                 LOOP
                      update black_list set status = 0, last_unlock_time = sysdate, last_unlock_actor = 'System' , insert_time = sysdate where caller = v_caller(i) and line_id = v_called(i);
                      num := num + 1;
                      if mod(num, 20) = 0 then
                        commit;
                      end if;
                 end loop;
           EXIT WHEN rs_cur%NOTFOUND;
           END LOOP;
        ---
   close rs_cur;
 commit;
END PROC_SCAN_TO_OPEN;



--------------------------------------------------------
--  DDL for Procedure PROC_STATUSTICCALRATE
--------------------------------------------------------


  PROCEDURE "PROC_STATUSTICCALRATE" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date
  )as

BEGIN
  open rs for
         select SUBSTR(start_time,11,19) as time,
                count(distinct case when call_type = 0 then call_id end) as totalCallIn,
                count(distinct case when call_type = 0 and joined > 0 then call_id end) as totalMeetAgent,
                count(distinct case when call_type = 0 and joined = 0 and in_reason=5 then call_id end) as totalMissedCallByCus,
                count(distinct case when call_type = 0 and joined = 0 and in_reason=1 then call_id end) as totalMissedCallByAgent,
                round(avg(waiting_time)) as averageWaitTime,
                round(avg(duration)) as averageTaskTime
          from callinfo
          where call_type = 0
          and start_time >= fromDate
          and start_time <= toDate
          order by START_TIME DESC;
END "PROC_STATUSTICCALRATE";



--------------------------------------------------------
--  DDL for Procedure PROC_UBLACKLIST_AFTERSENT
--------------------------------------------------------


  PROCEDURE "PROC_UBLACKLIST_AFTERSENT" (in_caller in VARCHAR2,in_called in VARCHAR2) AS
-- cap nhat khach hang bi chan sau khi gui sang BCCS

today_to_milis number :=(sysdate - TO_DATE('01/01/1970 00:00:00','DD/MM/YYYY HH24:MI:SS'))*24*60*60*1000;
twoday_to_milis number := 172800000;
oneday_to_milis number := 86400000; -- 24*60*60*1000
ago_2day_milis number := today_to_milis - twoday_to_milis;
ago_2day date := TO_DATE('01/01/1970 00:00:00','DD/MM/YYYY HH24:MI:SS') + (ago_2day_milis /oneday_to_milis);
BEGIN
   update black_list set is_sent = 1, bccs_sent_time=sysdate
          where caller = in_caller and line_id = in_called and insert_time >= ago_2day;
   COMMIT;
END PROC_UBLACKLIST_AFTERSENT;


--------------------------------------------------------
--  DDL for Procedure PROC_UBLACKLIST_ISREQUNLOCK
--------------------------------------------------------


  PROCEDURE "PROC_UBLACKLIST_ISREQUNLOCK" (in_caller in VARCHAR2,in_called in VARCHAR2,userName in VARCHAR2, inlaskUnLockTime in DATE) AS
-- update trang thai yeu cau mo khoa tu bccs
BEGIN
   update black_list set is_request_unlock = 1, last_unlock_actor= username, last_lock_time= inlaskunlocktime
          where caller = in_caller and line_id = in_called;
   COMMIT;
END PROC_UBLACKLIST_ISREQUNLOCK;


--------------------------------------------------------
--  DDL for Procedure PROC_UBLACKLIST_SENTSMS
--------------------------------------------------------


  PROCEDURE "PROC_UBLACKLIST_SENTSMS" (in_caller in VARCHAR2, in_called in VARCHAR2) AS
-- update trang thai gui sms
BEGIN
   update black_list set sms_status = 1, sms_sent_time=sysdate
          where sms_status=0 and lock_level = 1 and caller = in_caller and line_id = in_called;
   COMMIT;
END PROC_UBLACKLIST_SENTSMS;

/*
-- vannt18 comment do invalid
--------------------------------------------------------
--  DDL for Procedure SYNVSALOC
--------------------------------------------------------


  PROCEDURE "SYNVSALOC" (num out number, LEN IN NUMBER) IS
  ERR_MSG VARCHAR2(1000);
  STRSQL VARCHAR2(50);
BEGIN
  num := 0;
  STRSQL := 'truncate table vsa_location';
  EXECUTE IMMEDIATE STRSQL;
  insert into vsa_location select * from vsa3.location;
  commit;
EXCEPTION
  WHEN OTHERS THEN
   ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
   INSERT_LOG('ERROR ', 'Error is:' || ERR_MSG, SYSDATE, ERR_MSG);
END;
--------------------------------------------------------
--  DDL for Procedure SYNVSALOC
--------------------------------------------------------


  PROCEDURE "SYNVSAGROUP" (num out number, LEN IN NUMBER) IS
  ERR_MSG VARCHAR2(1000);
  STRSQL VARCHAR2(50);
BEGIN
  num := 0;
  STRSQL := 'truncate table vsa_group';
  EXECUTE IMMEDIATE STRSQL;
 insert into vsa_group (group_id,group_code,group_name,parent_id) select location_id, location_code,location_name, parent_id
 from vsa3.location;
  commit;
EXCEPTION
  WHEN OTHERS THEN
   ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
   INSERT_LOG('ERROR ', 'Error is:' || ERR_MSG, SYSDATE, ERR_MSG);
END;
--------------------------------------------------------
--  DDL for Procedure SYNVSALOC
--------------------------------------------------------


  PROCEDURE "SYNVSAUSER" (num out number, LEN IN NUMBER) IS
  ERR_MSG VARCHAR2(1000);
  STRSQL VARCHAR2(50);
BEGIN
  num := 0;
  STRSQL := 'truncate table vsa_users';
  EXECUTE IMMEDIATE STRSQL;
  insert into vsa_users(user_id, user_name,status,full_name,location_id,dept_id,group_id)
select user_id, user_name,status,full_name,location_id,dept_id,location_id
from vsa3.users;
  commit;
EXCEPTION
  WHEN OTHERS THEN
   ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
   INSERT_LOG('ERROR ', 'Error is:' || ERR_MSG, SYSDATE, ERR_MSG);
END;

*/
--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETACTIONOFAGENT
--------------------------------------------------------


  PROCEDURE "TESTPROC_GETACTIONOFAGENT" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listGroupId in VARCHAR2,
  agentName in VARCHAR2,
  listLine in VARCHAR2,
  listAction in VARCHAR2,
  ptype in number,
  pcallid in VARCHAR2,
  pcaller in VARCHAR2,
  poriAddr in VARCHAR2,
  pmidAgent in VARCHAR2,
  pmax in number
) AS
BEGIN
if ptype = 0 then
    -- Thong ke tong hop
    open rs for select * from (select a.agent_id,b.trans_type_name, sum(1) as solan
    from trans_info a, trans_type b  where
    a.invoke_start_time between fromDate and toDate
    and a.trans_type = b.trans_type_code
    --and a.call_start_time between fromDate and toDate
    and a.invoke_start_time between fromDate and toDate
    and agent_id in (select user_name from vsa_users where group_id in (
        select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
        connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
    and (agentName is null or agentName = '' or lower(a.agent_id) like '%' || agentName ||'%' escape '\')
    and (listLine is null or listLine = '' or called in (
        select regexp_substr(listLine,'[^,]+', 1, level) from dual
        connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (listAction is null or listAction = '' or a.trans_type in (
        select regexp_substr(listAction,'[^,]+', 1, level) from dual
        connect by regexp_substr(listAction, '[^,]+', 1, level) is not null ))
    group by a.agent_id, b.trans_type_name order by a.agent_id);

  else
    -- Thong ke chi tiet
    open rs for select a.call_id,a.caller,a.called,a.ori_addr,a.agent_id,a.dest_addr,
    to_char(a.call_start_time,'dd/mm/yyyy hh24:mi:ss') as call_start_time,
    to_char(a.call_end_time,'dd/mm/yyyy hh24:mi:ss'),
    to_char(a.invoke_start_time,'dd/mm/yyyy hh24:mi:ss'),
    to_char(a.invoke_end_time,'dd/mm/yyyy hh24:mi:ss'),
    b.trans_type_name from trans_info a, trans_type b
    where a.invoke_start_time between fromDate and toDate
    and a.trans_type = b.trans_type_code
    and agent_id in (select user_name from vsa_users where group_id in (
        select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
        connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
    and (agentName is null or agentName = '' or lower(a.agent_id) like '%' || agentName ||'%' escape '\')
    and (listLine is null or listLine = '' or called in (
        select regexp_substr(listLine,'[^,]+', 1, level) from dual
        connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%')
    and (pcallid is null or pcallid = '' or lower(call_id) = pcallid)
    and (pmidAgent is null or pmidAgent = '' or lower(agent_id)= pmidAgent)
    and (poriAddr is null or poriAddr = '' or lower(ori_addr)= poriAddr)
    and (listAction is null or listAction = '' or trans_type in (
          select regexp_substr(listAction,'[^,]+', 1, level) from dual
          connect by regexp_substr(listAction, '[^,]+', 1, level) is not null ))
    and rownum <= pmax
    order by a.invoke_start_time;

  end if;
END testPROC_GETACTIONOFAGENT;

-----------



--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETAGENTJOBSTATUS
--------------------------------------------------------


--  PROCEDURE "TESTPROC_GETAGENTJOBSTATUS" (
---- thong ke thoi gian trang thai
--  rs in out rs_types.rs_cursor,
--  fromDate in DATE,
--  toDate in DATE,
--  agentIdIn in VARCHAR2,
--  pstatus in NUMBER,
--  poptionType in NUMBER,
--  pdur1 in NUMBER,
--  pdur2 in NUMBER,
--  pdur3 in NUMBER,
--  pdur4 in NUMBER,
--  listGroupId in VARCHAR2,
--  pmax in NUMBER
--) AS
--BEGIN
--  if poptiontype = 0 then
--     open rs for select * from (select a.agent_id, sum(case when a.duration >= pdur1 and a.duration <pdur2 then 1 else 0 end) as ringt1t2,
--     sum(case when a.duration >= pdur2 and a.duration < pdur3 then 1 else 0 end) as ringt2t3,
--     sum(case when a.duration >= pdur3 and a.duration < pdur4 then 1 else 0 end) as ringt3t4,
--     sum(case when a.duration >= pdur4 then 1 else 0 end) as ringt4,
--     sum(duration) as total_ring_time,count(status) as total, b.status_name
--     from agent a,agent_status b
--     where a.START_TIME between FROMDATE and TODATE
--     and a.STATUS = B.STATUS_CODE
--     and b.status_type != 1
--     and (PSTATUS = -1 or a.status = pstatus)
--     and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
--      and agent_id in (select user_name from vsa_users where group_id in (
--      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
--      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
--     group by a.agent_id,b.status_name
--     order by a.agent_id,b.status_name)
--     where rownum <= pmax;
--   else
--      open rs for select * from (select a.agent_id, a.status, to_char(a.start_time,'dd-MM-yyyy hh24:mi:ss'),
--      a.duration,to_char(a.stop_time,'dd-MM-yyyy hh24:mi:ss'),b.status_name
--      from agent a, agent_status b
--       where a.start_time between fromDate and toDate
--      and a.status = b.status_code
--      and b.status_type = 1
--      and (pstatus = -1 or a.status = pstatus)
--      and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
--       and agent_id in (select user_name from vsa_users where group_id in (
--      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
--      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
--      order by a.agent_id,a.start_time)
--      where rownum <= pmax;
--   end if;
--END testPROC_GETAGENTJOBSTATUS;

    PROCEDURE "TESTPROC_GETAGENTJOBSTATUS" (
-- thong ke thoi gian trang thai
  rs in out rs_types.rs_cursor,
  fromDate in DATE,
  toDate in DATE,
  agentIdIn in VARCHAR2,
  pstatus in NUMBER,
  poptionType in NUMBER,
  pdur1 in NUMBER,
  pdur2 in NUMBER,
  pdur3 in NUMBER,
  pdur4 in NUMBER,
  listGroupId in VARCHAR2,
  listLine in VARCHAR2,
  pmax in NUMBER
) AS
BEGIN
  if poptiontype = 0 then
     open rs for select * from (select a.agent_id, sum(case when a.duration >= pdur1 and a.duration <pdur2 then 1 else 0 end) as ringt1t2,
     sum(case when a.duration >= pdur2 and a.duration < pdur3 then 1 else 0 end) as ringt2t3,
     sum(case when a.duration >= pdur3 and a.duration < pdur4 then 1 else 0 end) as ringt3t4,
     sum(case when a.duration >= pdur4 then 1 else 0 end) as ringt4,
     sum(duration) as total_ring_time,count(status) as total, b.status_name
     from agent a,agent_status b
     where a.START_TIME between FROMDATE and TODATE
     and a.STATUS = B.STATUS_CODE
     and b.status_type != 1
     and (PSTATUS = -1 or a.status = pstatus)
     and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
      and agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
     group by a.agent_id,b.status_name
     order by a.agent_id,b.status_name)
     where rownum <= pmax;
   elsif poptiontype = 1 then
      open rs for select * from (select a.agent_id, a.status, to_char(a.start_time,'dd-MM-yyyy hh24:mi:ss'),
      a.duration,to_char(a.stop_time,'dd-MM-yyyy hh24:mi:ss'),b.status_name
      from agent a, agent_status b
       where a.start_time between fromDate and toDate
      and a.status = b.status_code
      and b.status_type = 1
      and (pstatus = -1 or a.status = pstatus)
      and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
       and agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
      order by a.agent_id,a.start_time)
      where rownum <= pmax;
   else
   open rs for select * from (
   select agent_id, sum(hold_time) as holdtime, sum(hold_num) as holdnum,
       (sum(answer_time) - sum(hold_time)) as talktime, count(*) as talknum, called
      from call a
      where start_time between fromDate and toDate
      and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
      and (answer_time >  0)
      and agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
      and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
      group by agent_id, called
      order by a.agent_id, called
   )
   where rownum <= pmax;
   end if;
END testPROC_GETAGENTJOBSTATUS;




--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETAGENTSTATUSDUR
--------------------------------------------------------


  PROCEDURE "TESTPROC_GETAGENTSTATUSDUR" (
-- thong ke thoi gian trang thai
  rs in out rs_types.rs_cursor,
  fromDate in DATE,
  toDate in DATE,
  agentIdIn in VARCHAR2,
  pstatus in NUMBER,
  listGroupId in VARCHAR2,
  pmax in NUMBER
) AS
BEGIN
  open rs for SELECT a.agent_id, SUM((CASE WHEN a.status = 0 THEN a.duration ELSE 0 END )) as logout,
    SUM((CASE WHEN a.status = 1 THEN a.duration ELSE 0 END )) as login,
    SUM((CASE WHEN a.status = 2 THEN a.duration ELSE 0 END )) as no_acd,
    SUM((CASE WHEN a.status = 3 THEN a.duration ELSE 0 END )) as acd,
--    SUM((CASE WHEN a.status = 3 THEN case when a.start_time < fromdate then round((a.stop_time - fromdate)*24*60*60) else case when a.stop_time > todate then round((toDate - a.start_time)*24*60*60) else a.duration end end  ELSE 0 END )) as acd,
    SUM((CASE WHEN a.status = 4 THEN a.duration ELSE 0 END )) as meeting,
    SUM((CASE WHEN a.status = 5 THEN a.duration ELSE 0 END )) as typing,
    SUM((CASE WHEN a.status = 6 THEN a.duration ELSE 0 END )) as at_lunch,
    SUM((case when a.STATUS = 7 then a.DURATION else 0 end )) as GO_OUT,
    round(SUM((CASE WHEN a.status = 16 THEN a.duration ELSE 0 END ))/60 + 0.499) as NoAnswer,
    SUM((CASE WHEN a.status = 17 THEN a.duration ELSE 0 END )) as available_no_acd,
    SUM((case when a.STATUS = 10 then a.DURATION else 0 end )) as RINGING,
    SUM((case when a.STATUS = 11 then a.DURATION else 0 end )) as ANSWERING,
    SUM((case when a.STATUS = 12 then 1 else 0 end )) as dial_no_answer,
    SUM((case when a.STATUS = 18 then a.DURATION else 0 end )) as available_callout

    FROM agent a WHERE
    a.start_time between fromDate and toDate
    and (pstatus =-1 or a.status = pstatus)
    and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
    and agent_id in (select user_name from vsa_users where group_id in (
    select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
    connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
    GROUP BY a.agent_id ORDER BY acd desc;


END testPROC_GETAGENTSTATUSDUR;



--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETANSWERCALLDETAILS
--------------------------------------------------------


  PROCEDURE "TESTPROC_GETANSWERCALLDETAILS" (
 -- thong ke so cuoc tra loi cua Agent
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  TODATE in date,
  PAGENTID in VARCHAR2,
  limitTime in number,
  pcaller in VARCHAR2,
  listLine in VARCHAR2,
  pcallType in NUMBER,
  pcallid in VARCHAR2,
  PDEVICEID in varchar2,
  listGroupId in VARCHAR2,
  pmax in NUMBER

) IS
  row_count number;
begin
  row_count := pmax;
  open rs for select agent_id, to_char(call_start_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(ring_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(connect_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(end_time,'yyyy-MM-dd hh24:mi:ss'),
    ROUND(ANSWER_TIME) as conference_time,
    URL,CALLER,CALLED,CALL_ID,CALL_TYPE,DEVICE_ID
  from call where START_TIME between FROMDATE and TODATE
    and answer_time >= limittime and connect_time is not null
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller ||'%' escape '\')
    and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (PCALLTYPE = -1 or CALL_TYPE = PCALLTYPE)
    and (PAGENTID is null or PAGENTID = '' or LOWER(AGENT_ID) like '%'||PAGENTID||'%' escape '\')
    and (PCALLID is null or PCALLID = '' or LOWER(CALL_ID) like '%'||PCALLID||'%' escape '\')
    and (PDEVICEID is null or PDEVICEID = '' or LOWER(DEVICE_ID) like '%'||PDEVICEID||'%' escape '\')
    and agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
    and rownum <= row_count
    order by start_time desc;
--    DBMS_OUTPUT.PUT_LINE('RS = ' || rs%ROWCOUNT);
end testproc_getAnswerCallDetails;



--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETDETAILCALLAGENT
--------------------------------------------------------


  PROCEDURE "TESTPROC_GETDETAILCALLAGENT"
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDate in Date,             -- thoi gian bat dau thong ke --> 2
  TODATE in date,               -- thoi gian ket thuc thong ke --> 3
  AGENTID in varchar2,             -- id nguoi nhan cuoc goi --> 4
  LISTLINE in varchar2,
  LIMITTIME in number,
  listGROUPID in varchar2,
  PCALLTYPE in number,
  PMAX in number                -- so luong ban ghi toi da duoc export --> 14
) as
begin
    open rs for select a.call_id,
--                       b.acc_code,          -- ma tai khoan
                       a.caller,            -- so dien thoai
                       a.called,            -- kenh
                       to_char(a.call_start_time, 'DD/MM/YYYY hh24:mi:ss'),   -- thoi gian bat dau cuoc goi
                       to_char(a.ring_time, 'DD/MM/YYYY hh24:mi:ss'),         -- thoi gian do chuong
                       to_char(a.connect_time, 'DD/MM/YYYY hh24:mi:ss'),      -- thoi diem nhac may
                       a.agent_id,          -- ma agent
                       to_char(a.end_time, 'DD/MM/YYYY hh24:mi:ss'),          -- thoi diem ket thuc
                       a.ANSWER_TIME        -- thoi luong dam thoai cua agent voi kh
                from call a
--                , call_acc b
                where a.start_time between fromDate and toDate
                and AGENT_ID = AGENTID
--                and a.CALL_ID = B.CALL_ID
                and (LISTLINE is null or LISTLINE = '' or CALLED in (
                select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
                connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))

                and agent_id in (select user_name from vsa_users where group_id in (
                    select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
                    connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
                and (PCALLTYPE is null or PCALLTYPE = -1 or a.CALL_TYPE = PCALLTYPE)
                and ANSWER_TIME>=LIMITTIME
                and rownum <= pmax;
END testPROC_GETDETAILCALLAGENT;
---------



--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETSTATUSCHANGE
--------------------------------------------------------


  PROCEDURE "TESTPROC_GETSTATUSCHANGE" (
-- THONG KE SO LAN THAY DOI TRANG THAI
  RS in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,
  pAgentId in VARCHAR2,
  pstatus in number,
  pduration in number,
  PCOUNT in number,
  listGroupId in VARCHAR2,
  pmax in number
) AS
BEGIN

      open rs for select * from

        (select a.agent_id,a.status, b.status_name,  sum(1) as status_changes,
         count(case when a.duration >= pduration then a.status end),
         round(sum(duration)/60 + 0.499) as total from agent a, agent_status b
         where b.status_type = 1 and a.status = b.status_code
         and a.start_time between fromDate and toDate
         and (PAGENTID is null or PAGENTID = '' or LOWER(AGENT_ID) like '%'||PAGENTID||'%' escape '\')
           and agent_id in (select user_name from vsa_users where group_id in (
          select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
          connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
         and (pstatus = -1 or a.status = pstatus)
         group by a.agent_id, a.status, b.status_name having count(*) >= pcount
         order by agent_id, status_changes)
     where rownum <= pmax;
END testPROC_GETSTATUSCHANGE;



--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETSUBCALLEDTHANN
--------------------------------------------------------


  PROCEDURE "TESTPROC_GETSUBCALLEDTHANN" -- vos_vietnb
-- thong ke cuoc goi lon hon n lan
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  listGroupId in VARCHAR2,      -- danh sach kenh --> 4
  listCalledIn in VARCHAR2,       -- danh sach kenh --> 5
  callerIn in VARCHAR2,           -- so dien thoai --> 6
  customerLevelIn in VARCHAR2,    -- loai khach hang --> 7
  ptypeIn in number,              -- loai bao cao --> 8
  ptotalCallIn in number,         -- tong so cuoc goi --> 9
  pjoinedIn in VARCHAR2,          -- dieu kien --> 10
  callIdIn in VARCHAR2,           -- ma cuoc goi --> 11
  agentIdIn in VARCHAR2,            -- ma nhan vien --> 12
  acdTimeIn in VARCHAR2,          -- thoi gian dam thoai --> 13
  waitingTimeIn in VARCHAR2,      -- thoi gian cho --> 14
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 15
) AS
--CURSOR uname_rs
--    IS
------  lay ra danh sach uname thuoc nhom nguoi dung quan ly
--    select user_name from vsa_users where group_id in (
--      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
--      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null );
--  uname_rec uname_rs%rowtype;
--  listUname VARCHAR2 (32760) := 'DEFAULT';

BEGIN
--  lay ra danh sach uname dang string seperated comma
--  FOR uname_rec IN uname_rs
--  loop
--      listUname:=listUname || ',' || uname_rec.user_name;
--  end loop;

    if ptypeIn = 1 then
    -- chi tiet
        open rs for select a.call_id,
               a.caller,
               a.CALLED,
               to_char(a.start_time,'dd/MM/yyyy hh24:mi:ss'),
               a.waiting_time,
               to_char(a.first_ring_time,'dd/MM/yyyy hh24:mi:ss'),
               to_char(a.first_connect_time,'dd/MM/yyyy hh24:mi:ss'),
               a.agent_id,
               to_char(a.end_time,'dd/MM/yyyy hh24:mi:ss'),
               a.duration, b.description
        from CALLINFO a, end_code b
        where a.START_TIME between FROMDATEIN and TODATEIN
        and a.in_reason = b.end_code_id(+)

        and (listCalledIn is null or listCalledIn = '' or lower(a.called) in (
          select regexp_substr(listCalledIn,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(LISTCALLEDIN, '[^,]+', 1, level) is not null ))
        and (pjoinedIn = -1 or a.joined = pjoinedIn or (pjoinedIn > 0 and a.joined > 0))
        and(customerLevelIn = -1 or a.customer_level = customerLevelIn)
        and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
        and (callerIn is null or callerIn = '' or a.caller like '%'||callerIn||'%' escape '\')
        and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%' escape '\')
        and a.acd_time >= acdTimeIn
        and a.waiting_time >= waitingTimeIn
        --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
        and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
--        and assertgroup('' || a.agent_id,listUname) > 0
--        and assertgroup('' || a.agent_id,listGroupId) > 0
       and a.agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
        and rownum <= PMAXIN
        order by a.start_time desc;
    else
    -- tong hop
        open rs for select * from ( select * from
        (
            select a.caller as sdt,  sum(1) as solangoi
            from callinfo a
            where start_time between fromDateIn and toDateIn
            and (listCalledIn is null or listCalledIn = '' or lower(a.called) in (
              select regexp_substr(listCalledIn,'[^,]+', 1, level) from dual
              connect by regexp_substr(listCalledIn, '[^,]+', 1, level) is not null ))
            and (pjoinedIn = -1 or joined = pjoinedIn or (pjoinedIn > 0 and joined > 0))
            and(customerLevelIn = -1 or a.customer_level = customerLevelIn)
            and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
            and (callerIn is null or callerIn = '' or a.caller like '%'||callerIn||'%' escape '\')
            and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%' escape '\')
            and a.acd_time >= acdTimeIn
            and a.waiting_time >= waitingTimeIn
            --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
            and nvl(auto_transfer,0) not in (2,3) --LamNV10 sua R8247
--            and assertgroup('' || a.agent_id,listUname) > 0
--                and assertgroup3('' || a.agent_id,listGroupId) > 0
and a.agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
            group by caller
        ) where solangoi >= ptotalCallIn order by sdt) where rownum <= pmaxIn;
    end if;
END testPROC_GETSUBCALLEDTHANN;



--------------------------------------------------------
--  DDL for Procedure TESTPROC_GETVIP
--------------------------------------------------------


  PROCEDURE "TESTPROC_GETVIP" (
  -- thong ke tac dong cua Agent
   rs in out rs_types.rs_cursor,
  fromDate in VARCHAR2,
  toDate in VARCHAR2,
  VIPID in VARCHAR2,
  RANKID in NUMBER,
  pstatus in number,
  pmax in number
) AS
ifrom date := sysdate;
ito date := sysdate;
BEGIN
if fromDate is not null
then
  ifrom := to_date(fromDate, 'dd/MM/yyyy hh24:mi:ss');
  ito := to_date(toDate, 'dd/MM/yyyy hh24:mi:ss');
end if;
if toDate is not null
then
  ito := to_date(toDate, 'dd/MM/yyyy hh24:mi:ss');
end if;
  open rs for select v.vip_id,v.status,v.sms_status,v.actor,
  to_char(v.insert_time ,'dd/MM/yyyy hh24:mi:ss'),
  r.rank_name,v.rank_id,v.id,v.line
  from vip v left outer join rank r on v.rank_id = r.rank_id
  where (fromDate is null or fromDate = '' or v.insert_time >= ifrom)
  and (toDate is null or toDate = '' or v.insert_time <= ito)
  and (vipid is null or vipid = '' or v.vip_id like '%' || vipid ||'%' )
  and (rankid is null or rankid = -1 or v.rank_id = rankid)
  and (pstatus is null or pstatus = -1 or v.status = pstatus)
  and rownum <= 500;
END TESTPROC_GETVIP;



--------------------------------------------------------
--  DDL for Procedure TESTPROC_GET_CALL_PER_AGENT
--------------------------------------------------------


  PROCEDURE "TESTPROC_GET_CALL_PER_AGENT" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,
  LISTLINE in varchar2,
  PCALLTYPE in number,
  customerLevelIn in number,
  PAGENTID in varchar2,
  LIMITTIME in number,
  listGroupId in VARCHAR2,
  POPERATOR in VARCHAR2,
  PMAX in number
) as
  V_C_TOTAL number := 0;
  V_MC_TOTAL number := 0;
  v_at_total number := 0;
begin

commit;
      open RS for select * from(
          select AGENT_ID
          ,SUM(case when ANSWER_TIME > 0 then 1 else 0 end) CMET
          ,SUM(case when ANSWER_TIME = 0 then 1 else 0 end) CMISS
          ,ROUND(AVG(AGENT_WAITING_TIME)) AVG_WAITTIME
          ,ROUND(max(AGENT_WAITING_TIME)) MAX_WAITTIME
          ,ROUND(AVG(ANSWER_TIME)) AVG_ANSWERTIME
          ,ROUND(max(ANSWER_TIME)) MAX_ANSWERTIME
          ,round(SUM(ANSWER_TIME)/60 + 0.499) TT_ANSWERTIME
          ,COUNT(case when a.END_CODE in (2, 4, 5) then a.CALL_ID end) TOTALCALLENDBYAGENT
          from call a
          where a.START_TIME BETWEEN FROMDATE and todate
          and (listLine is null or listLine = '' or called in (
              select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
              connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
          and (pcalltype is null or pcalltype = -1 or a.call_type = pcalltype)
          and (PAGENTID is null or PAGENTID = '' or LOWER(AGENT_ID) like '%'||PAGENTID||'%' escape '\')
          and agent_id in (select user_name from vsa_users where group_id in (
              select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
              connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
          and ((POPERATOR = 'ht' and ANSWER_TIME>LIMITTIME) or (POPERATOR = 'lt' and ANSWER_TIME<LIMITTIME) or (POPERATOR = 'eq' and ANSWER_TIME=LIMITTIME))
          and(customerLevelIn is null or customerLevelIn = -1 or a.customer_level = customerLevelIn)
          and agent_id is not null
          group by AGENT_ID
          order by agent_id)
          where rownum <= pmax;
END testPROC_GET_CALL_PER_AGENT;

---------



--------------------------------------------------------
--  DDL for Procedure TEST_AGENT_SCHEDULE
--------------------------------------------------------


  PROCEDURE "TEST_AGENT_SCHEDULE" (
  -- Tim kiem lich trung
  rs in out rs_types.rs_cursor,
  agentUsername in VARCHAR2,
  fromDate in Date,
  toDate in Date,
  pmax in number
)
AS
BEGIN
  open rs for select agent_id, schedule_id from  agent_schedule
    where  start_time > fromDate and end_time < toDate
    and rownum <=pmax;
END TEST_AGENT_SCHEDULE;


--------------------------------------------------------
--  DDL for Procedure TEST_GETAGENTCHATLOG
--------------------------------------------------------


  PROCEDURE "TEST_GETAGENTCHATLOG" (
-- thong ke chat
  rs in out rs_types.rs_cursor,
  fromDate in NUMBER,
  toDate in NUMBER,
  listSender in VARCHAR2,
  listReceiver in VARCHAR2,
  pmax in number
) AS
BEGIN
  open rs for select time,  sender, receiver, message from chat_message
  where time between fromDate and toDate
   and (listSender is null or listSender = '' or lower(sender) in (
      select regexp_substr(listSender,'[^,]+', 1, level) from dual
      connect by regexp_substr(listSender, '[^,]+', 1, level) is not null ))
   and (listReceiver is null or listReceiver = '' or lower(receiver) in (
      select regexp_substr(listReceiver,'[^,]+', 1, level) from dual
      connect by regexp_substr(listReceiver, '[^,]+', 1, level) is not null ))
         and rownum <= pmax
  order by chat_conference_id, time asc;
END test_GETAGENTCHATLOG;



--------------------------------------------------------
--  DDL for Procedure TEST_GETCALLDISCONNECTSTATUS
--------------------------------------------------------


  PROCEDURE "TEST_GETCALLDISCONNECTSTATUS" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcallType in number,
  poptionType in number,
  pcallId in VARCHAR2,
  listGroupId in VARCHAR2,
  listAgent in VARCHAR2,
  pcaller in VARCHAR2,
  pmax in number
) AS

type t_row is record (agent_id VARCHAR2(50)
--        , caller VARCHAR2(50), start_time VARCHAR2(50),
--        waiting_time number, acd_time number, description VARCHAR2(50), call_id VARCHAR2(50), called VARCHAR2(50),
--        first_connect_time VARCHAR2(50)
        );
v_rec t_row;
--CURSOR uname_rs
--    IS
--  --  lay ra danh sach uname thuoc nhom nguoi dung quan ly
--    select user_name from vsa_users where group_id in (
--      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
--      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null );
--  uname_rec uname_rs%rowtype;
--  listUname VARCHAR2(2000):= 'DEFAULT';
BEGIN

INSERT_LOG('INFO', 'LGroupId:', SYSDATE, listGroupId);

  -- lay ra danh sach uname dang string seperated comma
--  FOR uname_rec IN uname_rs
--  loop
--      listUname:=listUname || ',' || uname_rec.user_name;
--  end loop;
--INSERT_LOG('INFO', 'LUname:', SYSDATE, listUname);
  if poptiontype = 1 then
    open rs for select a.agent_id
    , a.caller, to_char(a.start_time,'dd-MM-yyyy hh24:mi:ss') start_time,
        a.waiting_time, a.acd_time, b.description, a.call_id, a.called,
        to_char(a.first_connect_time,'dd-MM-yyyy hh24:mi:ss')
        from callinfo a, end_code b where a.start_time between fromDate and toDate and a.in_reason=b.end_code_id(+)
        and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
        --and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
        and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
        and (listAgent is null or listAgent = '' or lower(agent_id) like '%'||listAgent||'%' escape '\')
        and (pcallId is null or pcallId = '' or lower(call_id) like '%'||pcallId||'%' escape '\')
        and (pcalltype = -1 or call_type = pcalltype)
        and (pcaller is null or pcaller = '' or caller like '%' || pcaller ||'%' escape '\')
--        and assertgroup('' || a.agent_id,listUname) > 0
        and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
and a.agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
        and rownum <= pmax
        order by a.start_time;
-- print test
--        loop
--          fetch rs into v_rec;
--          exit when rs%notfound;
--          DBMS_OUTPUT.PUT_LINE('agent_id = ' || v_rec.agent_id);
--        end loop;
  else
   open rs for select b.*, c.description
   from (select in_reason, called, count(call_id) as sumCall, count(distinct caller) as sumSub
      from callinfo  where start_time between fromDate and toDate
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      and (pcalltype = -1 or call_type = pcalltype)
--      and assertgroup('' || agent_id,listUname) > 0
and agent_id in (select user_name from vsa_users where group_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))
      group by in_reason, called) b, end_code c
   where b.in_reason = c.end_code_id (+) order by b.in_reason;
   end if;
END test_GETCALLDISCONNECTSTATUS;



--------------------------------------------------------
--  DDL for Procedure TEST_GETCALLERMISSANDNOTMISS
--------------------------------------------------------


  PROCEDURE "TEST_GETCALLERMISSANDNOTMISS" (
 -- thong ke khach hang rot va gap nhan vien
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pjoined in number,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    open rs for select * from (select distinct a.caller from callinfo a
    where a.start_time between fromDate and toDate
    and (a.called = pcalled)
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%' escape '\')
    and (pcustlevel = -1 or a.customer_level = pcustLevel)
     and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0))
    and a.waiting_time >= pwaitTime
   -- and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
     and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    order by a.caller) where rownum <= pmax;
  else
   -- tich chon thong ke cuoc goi cuoi
    open rs for select ci.caller from callinfo ci, (select caller, max(start_time) as max_start_time
    from callinfo a where a.start_time between fromDate and toDate
    and a.called = pcalled
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%' escape '\')
    and (pcustlevel = -1 or a.customer_level = pcustLevel) group by caller) b  where ci.caller = b.caller
    and ci.start_time = b.max_start_time
    and ci.start_time between fromDate and toDate
    and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0))
    and ci.waiting_time >= pwaitTime
   -- and nvl(auto_transfer,0) != 2 --AnhNT206 sua R8130
    and nvl(auto_transfer,0) not in (2,3) -- LamNV10 sua R8247
    and rownum <= pmax;
  end if;
END test_GETCALLERMISSANDNOTMISS;
--------



--------------------------------------------------------
--  DDL for Procedure TEST_GETIVRBYTIMES
--------------------------------------------------------


  PROCEDURE "TEST_GETIVRBYTIMES" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listline in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  fromN in number,
  toN in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    -- THEO SO LAN: TINH TONG SO CUOC GOI = SO LAN * TONG SO THUE BAO
    open rs for select * from (select byN, count(byN), called
    from (select a.called, count(a.call_id) as byN
        from dtmf_log a where a.start_time  between fromDate and toDate
         and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
        group by a.called, a.caller)
    where byN between fromN and toN  group by called, byN
    order by called desc, byN asc)
    where rownum <= pmax;
  else
     -- THEO THUE BAO
     open rs for select * from (select caller, sumCall, sumDuration
     from (select a.caller, count(a.call_id) as sumCall, sum(a.duration) as sumDuration
     from dtmf_log a
     where a.start_time between fromDate and toDate
             and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
     and (pcaller is null or pcaller = '' or a.caller like '%' || pcaller || '%' escape '\')
     group by a.caller)
     where sumCall between fromN and toN
     order by sumCall asc, sumDuration asc)
     where rownum <= pmax;
  end if;
END test_GETIVRBYTIMES;
---------



--------------------------------------------------------
--  DDL for Procedure TEST_GETIVRDETAIL
--------------------------------------------------------


  PROCEDURE "TEST_GETIVRDETAIL" (
 -- THONG KE CHI TIET CUOC GOI KENH IVR
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  pcaller in number,
  pmax in number
) AS
BEGIN

    open rs for select called,caller,to_char(start_time,'dd/MM/yyyy hh24:mi:ss') as startTime,
    to_char(end_time,'dd/MM/yyyy hh24:mi:ss') as stopTime,
    duration as seconds,
    round(duration/60 + 0.499) as minutes, dtmf
    from callinfo
    where start_time between fromDate and toDate
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
    and (pcustlevel = -1 or customer_level = pcustLevel)
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%' escape '\')
    and rownum <= pmax;
END test_GETIVRDETAIL;
-------------



--------------------------------------------------------
--  DDL for Procedure TEST_GETIVRTOTALCALLBYDUR
--------------------------------------------------------


  PROCEDURE "TEST_GETIVRTOTALCALLBYDUR" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  pdur1 in number,
  pdur2 in number,
  pdur3 in number,
  pdur4 in number,
  ptimeType in number,
  pmax in number
) AS
BEGIN
  if ptimetype = 0 then
    open rs for select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour,
    count(a.call_id) as totalcall,count(distinct a.caller) as totalcaller,
    count(case when duration >=pdur1 and duration <pdur2 then a.call_id end) as ivrt1t2,
    count(case when duration >=pdur2 and duration <pdur3 then a.call_id end) as ivrt2t3,
    count(case when duration >=pdur3 and duration <pdur4 then a.call_id end) as ivrt3t4,
    count(case when duration >=pdur4 then a.call_id end) as ivrt4t5,
    count(a.call_id) as chingheivr,
    sum(0) as toacd,
   sum(0) as notmiss,
   sum(0) as miss
    from callinfo a where a.start_time between fromDate and toDate
    and a.called_type != 1
    and (pcustlevel =-1 or a.customer_level = pcustlevel)
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
    group by trunc(a.start_time)
    order by date_hour desc
   -- where rownum <= pmax
    ;
  else
        open rs for select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour,
    count(a.call_id),count(distinct a.caller),
    count(case when duration >=pdur1 and duration <pdur2 then a.call_id end) as ivrt1t2,
    count(case when duration >=pdur2 and duration <pdur3 then a.call_id end) as ivrt2t3,
    count(case when duration >=pdur3 and duration <pdur4 then a.call_id end) as ivrt3t4,
    count(case when duration >=pdur4 then a.call_id end) as ivrt4t5,
    count(a.call_id) as chingheivr,
  sum(0) as toacd,
   sum(0) as notmiss,
    sum(0) as miss
    from callinfo a where a.start_time between fromDate and toDate
    and a.called_type != 1
    and (pcustlevel =-1 or a.customer_level = pcustlevel)
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
    group by TRUNC(a.start_time,'hh24')
    order by date_hour desc;
  end if;
END test_GETIVRTOTALCALLBYDUR;
---------
PROCEDURE PROC_REPORTSURVEYPARTICIPANT (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  poptionType in number, -- 0: SMS, 1: USSD, 2: IVR
  listDtmf in VARCHAR2,
  agentId in VARCHAR2,
  pLine in VARCHAR2,
  pCaller in VARCHAR2,
  pmax in number
) AS
BEGIN
  if poptiontype = 2 then
    open rs for select c.caller caller, c.start_time startTime, c.called called, c.dtmf dtmf, d.agent_id agentId from
      (select * from dtmf_log a where a.dtmf_log_id = (select max(b.dtmf_log_id) from dtmf_log b where a.call_id = b.call_id
      and (listDtmf is null or listDtmf = '' or node_code in (select REGEXP_SUBSTR(listDtmf,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listDtmf, '[^,]+', 1, level) is not null)))) c join callinfo d on c.call_id = d.call_id where d.transfer_called is not null
      and c.start_time between fromdate and todate
      and (agentId is null or agentId = '' or LOWER(d.agent_id) like '%'||agentId||'%' escape '\')
      and (pLine is null or pLine = '' or pLine = '-1' or c.called = pLine)
      and (pCaller is null or pCaller = '' or LOWER(c.caller) like '%'||pCaller||'%' escape '\')
      and rownum <=pmax
      order by c.start_time desc;
  else
    if (listDtmf = '' or listDtmf is null)  then
      open rs for select b.caller caller, b.start_time startTime, b.line called, b.survey_code dtmf, c.agent_id agentId, b.survey_campaign_name surveyCampaignName from
      (select sl.call_id,sl.start_time,sl.line,sl.survey_code,sc.survey_campaign_name,sl.caller,sl.survey_type
      from survey_log sl inner join survey_tree st on sl.survey_tree_id = st.survey_tree_id
      inner join survey_campaign sc ON st.survey_campaign_id = sc.survey_campaign_id
      where sl.start_time between fromdate and todate
        and sl.survey_code in (select survey_code from survey_tree a where survey_type = poptiontype)) b
        join (SELECT call_id, LISTAGG (agent_id, ', ') within group (order by callinfo_id) as agent_id
        FROM callinfo d
        WHERE d.start_time between fromdate and todate and d.called_type != 3 group by call_id) c on b.call_id = c.call_id
        where (agentId is null or agentId = '' or LOWER(c.agent_id) like '%'||agentId||'%' escape '\')
        and (pLine is null or pLine = '' or pLine = '-1' or b.line = pLine)
        and (pCaller is null or pCaller = '' or LOWER(b.caller) like '%'||pCaller||'%' escape '\')
        and  b.survey_type = poptiontype
        and rownum <=pmax
        order by b.start_time desc;
    else
      open rs for select b.caller caller, b.start_time startTime, b.line called, b.survey_code dtmf, c.agent_id agentId, b.survey_campaign_name surveyCampaignName
      from
      (select sl.call_id,sl.start_time,sl.line,sl.survey_code,sc.survey_campaign_name,sl.caller,sl.survey_type
      from survey_log sl inner join survey_tree st on sl.survey_tree_id = st.survey_tree_id
      inner join survey_campaign sc ON st.survey_campaign_id = sc.survey_campaign_id
      where sl.start_time between fromdate and todate and
       sl.survey_code in (select survey_code
                          from survey_tree a
                          where (1=1) and survey_type = poptiontype
                          start with to_char(a.survey_tree_id) in
          (select REGEXP_SUBSTR(
          listDtmf,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listDtmf, '[^,]+', 1, level) is not null)
          connect by prior a.survey_tree_id = a.parent_id)) b
          join (SELECT call_id, LISTAGG (agent_id, ', ') within group (order by callinfo_id) as agent_id
          FROM callinfo d
          WHERE d.start_time between fromdate and todate and d.called_type != 3 group by call_id) c on b.call_id = c.call_id
          where (agentId is null or agentId = '' or LOWER(c.agent_id) like '%'||agentId||'%' escape '\')
        and (pLine is null or pLine = '' or pLine = '-1' or b.line = pLine)
        and (pCaller is null or pCaller = '' or LOWER(b.caller) like '%'||pCaller||'%' escape '\')
        and  survey_type = poptiontype
        and rownum <=pmax
        order by b.start_time desc;
    end if;
  end if;
END PROC_REPORTSURVEYPARTICIPANT;

-------------

PROCEDURE "PROC_TOTALTRANSTOSURVEYIVRBYAG" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  agentId in VARCHAR2,
  listLine in VARCHAR2,
  pmax in number
) AS
BEGIN
  open rs for select agent_id, sum(1) totalCall, transfer_called
    from callinfo a WHERE start_time between fromdate and todate
    and transfer_called is not null
    and (listLine is null or listLine = '' or transfer_called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
      connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
    and (agentId is null or agentId = '' or LOWER(agent_id) like '%'||agentId||'%' escape '\')
    group by transfer_called, agent_id
    ORDER BY agent_id;
END PROC_TOTALTRANSTOSURVEYIVRBYAG;


PROCEDURE "PROC_REPORTIVRHISTORY" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  pDtmf in VARCHAR2,
  pDtmfContent in VARCHAR2,
  pmax in number
) AS
BEGIN
  open rs for select node_code, old_path, new_path, old_node_content, new_node_content,
    to_char(old_action_time,'dd/MM/yyyy hh24:mi:ss') as oldTime,
    to_char(new_action_time,'dd/MM/yyyy hh24:mi:ss') as newTime, acting, actor, description
    from ivr_tree_log where new_action_time between fromdate and todate
    and (pDtmf is null or pDtmf = '' or LOWER(new_path) like '%'||pDtmf||'%' escape '\')
    and (pDtmfContent is null or pDtmfContent = '' or LOWER(new_node_content) like '%'||pDtmfContent||'%' escape '\');
END PROC_REPORTIVRHISTORY;

--------------

PROCEDURE "PROC_TOTALTRANSTOSURVEYIVR2" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  optionType in VARCHAR2,
  listLine in VARCHAR2,
  pmax in number
) AS
BEGIN
  if optionType = '0' then
--    open rs for select a.transfer_called, count(distinct a.call_id) totalCall,
--      count(distinct case when b.number_of_visits > 0 then b.call_id end) totalDTMFCall
--      from callinfo a, dtmf_log b WHERE a.start_time between fromdate and todate
--      and b.start_time between fromdate and todate
--      and a.transfer_called is not null
--      and (listLine is null or listLine = '' or a.transfer_called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
--        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
--      and (listLine is null or listLine = '' or b.called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
--        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
--      and a.call_id = b.call_id(+)
--      group by a.transfer_called;
      open rs for
      select a.transfer_called,a.totalCall, b.totalDTMFCall from
      (select a.transfer_called, sum(1) totalCall
      from callinfo a WHERE a.start_time between fromdate and todate
      and a.transfer_called is not null
      and (listLine is null or listLine = '' or a.transfer_called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by a.transfer_called
      ) a,
      (select called, count(distinct case when number_of_visits > 0 then call_id end) totalDTMFCall
      from dtmf_log
      where start_time between fromdate and todate
      and (listLine is null or listLine = '' or called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by called
      ) b where a.transfer_called = b.called(+);
  else
    open rs for
    select b.* from
    (select a.transfer_called, sum(1) totalCall
      from callinfo a WHERE a.start_time between fromdate and todate
      and a.transfer_called is not null
      and (listLine is null or listLine = '' or a.transfer_called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by a.transfer_called
      ) a,

    (select a.called, a.dtmf, b.service_name, sum(a.number_of_visits) as sumCustomer
      from dtmf_log a, ivr_service b
      where start_time between fromdate and todate
      and a.node_code = b.service_id and a.called=b.line_code
      and (listLine is null or listLine = '' or a.called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by a.dtmf, b.service_name, a.called
      ) b where a.transfer_called=b.called
      order by b.dtmf, b.service_name;
  end if;
END PROC_TOTALTRANSTOSURVEYIVR2;

PROCEDURE "PROC_TOTALTRANSTOSURVEYIVR" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  optionType in VARCHAR2,
  listLine in VARCHAR2,
  pmax in number
) AS
BEGIN
  if optionType = '0' then
--    open rs for select a.transfer_called, count(distinct a.call_id) totalCall,
--      count(distinct case when b.number_of_visits > 0 then b.call_id end) totalDTMFCall
--      from callinfo a, dtmf_log b WHERE a.start_time between fromdate and todate
--      and b.start_time between fromdate and todate
--      and a.transfer_called is not null
--      and (listLine is null or listLine = '' or a.transfer_called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
--        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
--      and (listLine is null or listLine = '' or b.called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
--        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
--      and a.call_id = b.call_id(+)
--      group by a.transfer_called;
      open rs for
      select a.transfer_called,a.totalCall, b.totalDTMFCall from
      (select a.transfer_called, sum(1) totalCall
      from callinfo a WHERE a.start_time between fromdate and todate
      and a.transfer_called is not null
      and (listLine is null or listLine = '' or a.transfer_called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by a.transfer_called
      ) a,
      (select called, count(distinct case when number_of_visits > 0 then call_id end) totalDTMFCall
      from dtmf_log
      where start_time between fromdate and todate
      and (listLine is null or listLine = '' or called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by called
      ) b where a.transfer_called = b.called(+);
  else
    open rs for
    select b.* from
    (select a.transfer_called, sum(1) totalCall
      from callinfo a WHERE a.start_time between fromdate and todate
      and a.transfer_called is not null
      and (listLine is null or listLine = '' or a.transfer_called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by a.transfer_called
      ) a,

    (select a.called, a.dtmf, b.ivr_name, sum(a.number_of_visits) as sumCustomer
      from dtmf_log a, ivr_tree b
      where start_time between fromdate and todate
      and a.dtmf=b.dtmf and a.called=b.root_node
      and (listLine is null or listLine = '' or a.called in (select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      group by a.dtmf, b.ivr_name, a.called
      ) b where a.transfer_called=b.called
      order by b.dtmf, b.ivr_name;
  end if;
END PROC_TOTALTRANSTOSURVEYIVR;

PROCEDURE PROC_TOTALTRANSTOSURVEYSMSUSSD (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  optionType in VARCHAR2, -- 0: tong hop, 1: chi tiet
  listCalled in VARCHAR2,
  surveyType in number,
  pmax in number
) AS
BEGIN
  if optionType = '1' then
  -- thong ke chi tiet
    open rs for select a.line line, c.survey_campaign_name, a.survey_code dtmfSMSUSSD, a.description dtmfContent,
      (select count(*) from survey_log b where b.survey_code like a.survey_code || '%'
      and a.line = b.line
      and b.start_time between fromdate and todate
      and a.survey_type = b.survey_type
      --and (a.survey_tree_id = b.survey_tree_id or b.survey_tree_id is null)
      and (a.survey_tree_id = b.survey_tree_id)
      ) sumCustomer from survey_tree a, survey_campaign c
      where (listCalled is null or listCalled = '' or a.line in (select REGEXP_SUBSTR(listCalled,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listCalled, '[^,]+', 1, level) is not null))
      and a.survey_code is not null and a.survey_type = surveyType
      and a.survey_campaign_id = c.survey_campaign_id
      and rownum <=pmax;
  else
  -- thong ke tong hop
    open rs for select a.called line, count(distinct a.call_id) sumCallToACD,
      count(distinct case when b.line is not null and b.survey_type = surveyType then a.call_id end) sumCallSentToCus,
      count(distinct case when b.survey_code is not null and b.survey_type = surveyType then b.call_id end) sumCallRespondFromCus,
      count(distinct case when b.survey_code is null and b.survey_type = surveyType then b.call_id end) sumCallNotRespondFromCus
      from callinfo a LEFT JOIN survey_log b ON a.call_id = b.call_id and a.called = b.line
      where a.start_time between fromdate and todate
      and (listCalled is null or listCalled = '' or a.called in (select REGEXP_SUBSTR(listCalled,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listCalled, '[^,]+', 1, level) is not null))
      group by a.called;
  end if;
END PROC_TOTALTRANSTOSURVEYSMSUSSD;

PROCEDURE "PROC_STATISTICTOTALCALLEDVIP" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  poptionType in VARCHAR2,
  custLevel in number,
  listLine in VARCHAR2,
  pmax in number
) AS
BEGIN
  if poptiontype = '0' then
    open rs for select to_char(trunc(start_time),'dd/MM/yyyy') as date_hour,
      sum(1) as totalCallVip,
      sum(case when joined > 0 then 1 else 0 end) as totalMeetAgent,
      sum(case when joined > 0 and line_overflow = 0 then 1 else 0 end) as totalMeetAgentVIP,
      sum(case when joined > 0 and line_overflow = 1 then 1 else 0 end) as totalMeetAgentNormal,
      sum(case when joined = 0 and line_overflow = 1 then 1 else 0 end) as totalMissInNormalLine,
      sum(case when line_overflow = 1 then 1 else 0 end) as totalCallOverflow
      from callinfo where start_time between fromdate and todate
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      and (custLevel = -1 or customer_level = custLevel) and customer_level != 0
      group by to_char(trunc(start_time),'dd/MM/yyyy')
      order by date_hour;
  else
    open rs for select to_char(TRUNC(start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour,
      sum(1) as totalCallVip,
      sum(case when joined > 0 then 1 else 0 end) as totalMeetAgent,
      sum(case when joined > 0 and line_overflow = 0 then 1 else 0 end) as totalMeetAgentVIP,
      sum(case when joined > 0 and line_overflow = 1 then 1 else 0 end) as totalMeetAgentNormal,
      sum(case when joined = 0 and line_overflow = 1 then 1 else 0 end) as totalMissInNormalLine,
      sum(case when line_overflow = 1 then 1 else 0 end) as totalCallOverflow
      from callinfo where start_time between fromdate and todate
          and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
      and (custLevel = -1 or customer_level = custLevel) and customer_level != 0
      group by to_char(TRUNC(start_time,'hh24'),'dd/mm/yyyy hh24:mi')
      order by date_hour;
   end if;
END PROC_STATISTICTOTALCALLEDVIP;

 PROCEDURE "PROC_REPORTCALLOUTERROR" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  optionType in VARCHAR2, -- 0: tong hop, 1: chi tiet
  listCalled in VARCHAR2,
  callId in VARCHAR2,
  agentId in VARCHAR2,
  pCaller in VARCHAR2,
  pmax in number
) AS
BEGIN
  if optionType = '1' then
  -- thong ke chi tiet
    open rs for select call_id callId, agent_id agentId, caller caller, called called, start_time startTime, end_time endTime, outcall_error_code outcallErrorCode
      from callinfo where start_time between fromdate and todate
      and outcall_error_code is not null
      and (listCalled is null or listCalled = '' or called in (select REGEXP_SUBSTR(listCalled,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listCalled, '[^,]+', 1, level) is not null))
      and (callId is null or callId = '' or LOWER(call_id) like '%'||callId||'%' escape '\')
      and (agentId is null or agentId = '' or LOWER(agent_id) like '%'||agentId||'%' escape '\')
      and (pCaller is null or pCaller = '' or LOWER(caller) like '%'||pCaller||'%' escape '\')
      and rownum <=pmax
      order by start_time desc;
  else
  -- thong ke tong hop
    open rs for select outcall_error_code outcallErrorCode, called called, count(call_id) totalCall
      from callinfo where start_time between fromdate and todate
      and outcall_error_code is not null
      and (listCalled is null or listCalled = '' or called in (select REGEXP_SUBSTR(listCalled,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listCalled, '[^,]+', 1, level) is not null))
      group by outcall_error_code, called order by outcall_error_code asc;
  end if;
END PROC_REPORTCALLOUTERROR;

PROCEDURE "PROC_GET_INTELLIGENT_ROUTING"
-- thong ke cuoc goi dinh tuyen
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  line in VARCHAR2,       -- danh sach queue --> 3
  routingTypeIn in number,              -- loai bao cao --> 4
  areaIn in VARCHAR2,           -- Khu vuc -> 5
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 6
) AS
BEGIN
  if routingTypeIn = 0 then
    open rs for select a.call_id,
                  a.caller,
                  a. called,
                  to_char(a.start_time,'dd/MM/yyyy hh24:mi:ss'),
                  to_char(a.first_ring_time,'dd/MM/yyyy hh24:mi:ss'),
                  to_char(a.first_connect_time,'dd/MM/yyyy hh24:mi:ss'),
                  a.agent_id,
                  a.duration, b.description
    from CALLINFO a, end_code b
    where a.START_TIME between FROMDATEIN and TODATEIN
      and a.in_reason = b.end_code_id
      and a.caller like '%\_%' escape '\'
      and a.called = line
      and (areaIn is null or areaIn = '' or lower(substr(a.caller, 0, 2)) in (
          select regexp_substr(areaIn,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(areaIn, '[^,]+', 1, level) is not null ))
      and rownum <= PMAXIN
    order by a.start_time desc;
  else
    open rs for select a.call_id,
                  a.caller,
                  a. called,
                  to_char(a.start_time,'dd/MM/yyyy hh24:mi:ss'),
                  to_char(a.routing_time,'dd/MM/yyyy hh24:mi:ss'),
                  a.routing_to
    from CALLINFO a
    where a.START_TIME between FROMDATEIN and TODATEIN
      and a.dial_error like '%19%'
      and a.called = line
      and (areaIn is null or areaIn = '' or lower(a.ROUTING_TO) in (
          select regexp_substr(areaIn,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(areaIn, '[^,]+', 1, level) is not null ))
      and rownum <= PMAXIN
    order by a.start_time desc;
  end if;
END PROC_GET_INTELLIGENT_ROUTING;
procedure "TESTPROC_GETAGENTCALLDETAILS" (
 -- thong ke so cuoc tra loi cua Agent
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  TODATE in date,
  PAGENTID in VARCHAR2,
  limitTime in number,
  pcaller in VARCHAR2,
  listLine in VARCHAR2,
  pcallType in NUMBER,
  pcallid in VARCHAR2,
  pmax in NUMBER

) IS
  row_count number;
begin
  row_count := pmax;
  open rs for select agent_id, to_char(call_start_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(ring_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(connect_time,'yyyy-MM-dd hh24:mi:ss'),
    to_char(end_time,'yyyy-MM-dd hh24:mi:ss'),
    ROUND(ANSWER_TIME) as conference_time,
    URL,CALLER,CALLED,CALL_ID,CALL_TYPE,DEVICE_ID
  from call where START_TIME between FROMDATE and TODATE
    and answer_time >= limittime and connect_time is not null
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller ||'%' escape '\')
    and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and (PCALLTYPE = -1 or CALL_TYPE = PCALLTYPE)
    and (PAGENTID is null or PAGENTID = '' or LOWER(AGENT_ID) = PAGENTID)
    and (PCALLID is null or PCALLID = '' or LOWER(CALL_ID) like '%'||PCALLID||'%' escape '\')
    and rownum <= row_count
    order by start_time desc;
--    DBMS_OUTPUT.PUT_LINE('RS = ' || rs%ROWCOUNT);
end testproc_getagentcalldetails;
PROCEDURE PROC_REPORTAGENTGROUPDETAIL (
   rs in out rs_types.rs_cursor,
  agentGroupId in number,
  pVsaUser in VARCHAR2,
  listLine in VARCHAR2,
  pFromDate in Date,
  pToDate in Date,
  pmax in number
) AS
BEGIN
      open rs for
      select to_char(TRUNC (c.start_time), 'dd/MM/yyyy') startTime,
           c.agent_id,
           c.called,
           ag.agent_group_name,
           COUNT ( distinct c.call_id ) soluong
        from call c, acd.agent_group ag
        where c.agent_group_id = ag.agent_group_id
        and (pFromDate is null or pToDate is null or c.start_time between pFromDate and pToDate)
        and (listLine is null or listLine = '' or c.called in (select REGEXP_SUBSTR(listLine,'[^,]+', 1, level) from DUAL
        connect by REGEXP_SUBSTR(listLine, '[^,]+', 1, level) is not null ))
        and (agentGroupId is null or agentGroupId = -1 or ag.agent_group_id = agentGroupId)
       and (pVsaUser is null or pVsaUser = '' or LOWER(c.agent_id) like '%'||pVsaUser||'%' escape '\')
       and c.joined > 0
       and rownum <= pmax
        GROUP BY   TRUNC (c.start_time), c.agent_id, c.called, ag.agent_group_id, ag.agent_group_name
        ORDER BY startTime desc;

END PROC_REPORTAGENTGROUPDETAIL; -- Procedure
/*
PROCEDURE "PROC_REPORTIVRVAS" (-- thong ke thue bao dang ky dich vu vas qua IVR
                                      rs           IN OUT rs_types.rs_cursor,
                                      fromDate     IN     DATE,
                                      toDate       IN     DATE,
                                      serviceType   IN     NUMBER,
                                      pmsisdn      IN     VARCHAR2,
                                      pReportType IN NUMBER,
                                      pResult IN NUMBER,
                                      pmax         IN     NUMBER)
IS
    row_count   NUMBER;
BEGIN
    row_count := pmax;
if(pReportType = 0) then
    OPEN rs FOR
          SELECT   service_id,
                   SUM (1),
                   SUM (CASE WHEN result_code = '1' THEN 1 ELSE 0 END),
                   SUM (CASE WHEN (result_code != '1' and result_code != 'VAS_TIMEOUT') THEN 1 ELSE 0 END),
                   SUM (
                       CASE WHEN result_code = 'VAS_TIMEOUT' THEN 1 ELSE 0 END)
            FROM   ivr_callws_log
           WHERE   (1 = 1) AND (date_time BETWEEN fromDate AND toDate)
                   AND (   serviceType IS NULL
                        OR serviceType = '-1'
                        OR service_id = serviceType)
        GROUP BY   service_id
        order by service_id;
else
 OPEN rs FOR
          SELECT   msisdn,
                   service_id,
                   result_code,
                   TO_CHAR (date_time, 'dd/mm/yyyy hh24:mi')
            FROM   ivr_callws_log
           WHERE   (1 = 1) AND (date_time BETWEEN fromDate AND toDate)
                   AND (   serviceType IS NULL
                        OR serviceType = '-1'
                        OR service_id = serviceType)
                   AND (   pResult IS NULL
                        OR pResult = '-1'
                        OR (pResult = '0' and result_code = '1')
                        OR (pResult = '1' and result_code != '1'))
                   AND ( pmsisdn IS NULL
                        OR pmsisdn = ''
                        OR msisdn LIKE '%' || pmsisdn || '%' ESCAPE '\')
                   AND ROWNUM <= row_count
        ORDER BY   date_time DESC;
end if;
--    DBMS_OUTPUT.PUT_LINE('RS = ' || rs%ROWCOUNT);
END proc_reportivrvas;
*/
PROCEDURE "PROC_REPORTIVRVAS" (-- thong ke lich su tac dong cau hinh queue
                                     rs           IN OUT rs_types.rs_cursor,
                                      fromDate     IN     DATE,
                                      toDate       IN     DATE,
                                      serviceType   IN     NUMBER,
                                      pmsisdn      IN     VARCHAR2,
                                      pReportType IN NUMBER,
                                      pResult IN NUMBER,
                                      pmax         IN     NUMBER)
IS
    row_count   NUMBER;
BEGIN
    row_count := pmax;
if(pReportType = 0) then
    OPEN rs FOR
          SELECT   service_id,
                   SUM (1),
                   SUM (CASE WHEN result_code = '1' THEN 1 ELSE 0 END),
                   SUM (CASE WHEN (result_code != '1' and result_code != 'VAS_TIMEOUT') THEN 1 ELSE 0 END),
                   SUM (
                       CASE WHEN result_code = 'VAS_TIMEOUT' THEN 1 ELSE 0 END)
            FROM   ivr_callws_log
           WHERE   (1 = 1) AND (date_time BETWEEN fromDate AND toDate)
                   AND (   serviceType IS NULL
                        OR serviceType = '-1'
                        OR service_id = serviceType)
        GROUP BY   service_id
        order by service_id;
else
 OPEN rs FOR
          SELECT   a.msisdn,
                   a.service_id,
                   NVL(a.result_code,'ERROR') result_code,
                   TO_CHAR (date_time, 'dd/mm/yyyy hh24:mi'),
                   b.error_name
            FROM   ivr_callws_log a left join ivr_ws_result b
            on a.result_code = b.error_code
           WHERE   (1 = 1) AND (a.date_time BETWEEN fromDate AND toDate)
                   AND (   serviceType IS NULL
                        OR serviceType = '-1'
                        OR a.service_id = serviceType)
                   AND (   pResult IS NULL
                        OR pResult = '-1'
                        OR (pResult = '0' and a.result_code = '1')
                        OR (pResult = '1' and a.result_code != '1'))
                   AND ( pmsisdn IS NULL
                        OR pmsisdn = ''
                        OR msisdn LIKE '%' || pmsisdn || '%' ESCAPE '\')
                   AND ROWNUM <= row_count
        ORDER BY   a.date_time DESC;
end if;
--    DBMS_OUTPUT.PUT_LINE('RS = ' || rs%ROWCOUNT);
END proc_reportivrvas;


PROCEDURE "PROC_REPORTCATALOGLOG" (
 -- thong ke lich su tac dong cau hinh queue
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in date,
  item in number,
  actor in VARCHAR2,
  pmax in NUMBER

) IS
  row_count number;
begin
  row_count := pmax;
  open rs for select to_char(a.DATE_TIME, 'dd/mm/yyyy hh24:mi:ss'), a.ACTION_TYPE, a.USER_ACT, a.IP, b.TABLE_NAME, b.OLD_VALUE, b.NEW_VALUE, b.FIELD_NAME,a.ID_CATALOG, a.ITEM_CODE
  from ITEM_ACTION_LOG a
  inner join ITEM_ACTION_LOG_DETAIL b
  on b.ACTION_ID = a.ACTION_ID
  where (1=1)
  and (a.DATE_TIME between fromDate and toDate)
  and (b.DATE_TIME between fromDate and toDate)
  and (item is null or item = '-1' or a.ITEM_CODE = item)
  and (actor is null or actor = '' or lower(a.USER_ACT) like '%'|| lower (actor)||'%' escape '\')
  and rownum <= row_count
  order by a.DATE_TIME desc;
--    DBMS_OUTPUT.PUT_LINE('RS = ' || rs%ROWCOUNT);
end PROC_REPORTCATALOGLOG;


/*
-- R8247: Cac bao cao transfer sang nhom chuyen gia
procedure "PROC_GETCALLERTRANGROUPDETAIL" (
--THONG KE CHI TIET KHACH HANG
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listGroup in varchar2,
  pcaller in VARCHAR2,
  pmax in number
) AS
BEGIN
    open rs for select * from  (select caller, count(distinct call_id) total,
    count(distinct case when answer_time > 0 then call_id end) total_meet,
    count(distinct call_id) - count(distinct case when answer_time > 0 then call_id end)  total_miss
    from professors
    where  start_time between fromDate and toDate
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%' escape '\')
    and (listGroup is null or listGroup = '' or to_char(group_professor_id) in (
          select regexp_substr(listGroup,'[^,]+', 1, level) from dual
          connect by regexp_substr(listGroup, '[^,]+', 1, level) is not null ))
    group by caller)
    where rownum <=pmax;
end PROC_GETCALLERTRANGROUPDETAIL;

PROCEDURE "TESTPROC_GET_CALL_PER_PROFES" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,
  listGroup in varchar2,
  phoneProfes in varchar2,
  LIMITTIME in number,
  POPERATOR in VARCHAR2,
  PMAX in number
) as
  V_C_TOTAL number := 0;
  V_MC_TOTAL number := 0;
  v_at_total number := 0;
begin

commit;
      open RS for select * from(
          select phone_professor
          ,SUM(case when ANSWER_TIME > 0 then 1 else 0 end) CMET
          ,SUM(case when ANSWER_TIME = 0 then 1 else 0 end) CMISS
          ,ROUND(AVG(WAITING_TIME)) AVG_WAITTIME
          ,ROUND(max(WAITING_TIME)) MAX_WAITTIME
          ,ROUND(AVG(ANSWER_TIME)) AVG_ANSWERTIME
          ,ROUND(max(ANSWER_TIME)) MAX_ANSWERTIME
          ,round(SUM(ANSWER_TIME)/60 + 0.499) TT_ANSWERTIME
          ,count (distinct case when answer_time > 0 and end_call_by = 0 then call_id end) as byProFes
          from professors a
          where a.START_TIME BETWEEN FROMDATE and todate
          and (listGroup is null or listGroup = '' or to_char(group_professor_id) in (
              select REGEXP_SUBSTR(listGroup,'[^,]+', 1, level) from DUAL
              connect by REGEXP_SUBSTR(listGroup, '[^,]+', 1, level) is not null ))
          and (phoneProfes is null or phoneProfes = '' or phone_professor like '%'||phoneProfes||'%' escape '\')
          and ((POPERATOR = 'ht' and ANSWER_TIME>LIMITTIME) or (POPERATOR = 'lt' and ANSWER_TIME<LIMITTIME) or (POPERATOR = 'eq' and ANSWER_TIME=LIMITTIME))
          and phone_professor is not null
          group by phone_professor
          order by phone_professor)
          where rownum <= pmax;
END TESTPROC_GET_CALL_PER_PROFES;

PROCEDURE "TESTPROC_GETDETAILCALLPROFES"
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDate in Date,             -- thoi gian bat dau thong ke --> 2
  TODATE in date,               -- thoi gian ket thuc thong ke --> 3
  phoneProfes in varchar2,
  LISTGROUP in varchar2,
  LIMITTIME in number,
  POPERATOR in VARCHAR2,
  PMAX in number                -- so luong ban ghi toi da duoc export --> 14
) as
begin
    open rs for select a.call_id,
--                       b.acc_code,          -- ma tai khoan
                       a.caller,            -- so dien thoai
                       b.group_professor_name,
                       to_char(a.start_time, 'DD/MM/YYYY hh24:mi:ss'),   -- thoi gian bat dau cuoc goi
                       to_char(a.ring_time, 'DD/MM/YYYY hh24:mi:ss'),         -- thoi gian do chuong
                       to_char(a.connect_time, 'DD/MM/YYYY hh24:mi:ss'),      -- thoi diem nhac may
                       a.phone_professor,
                       to_char(a.end_time, 'DD/MM/YYYY hh24:mi:ss'),          -- thoi diem ket thuc
                       a.ANSWER_TIME
                from professors a join acd_full.group_professor b on a.group_professor_id = b.group_professor_id
                where a.start_time between fromDate and toDate
                and (phoneProfes is null or phoneProfes = '' or a.phone_professor like '%'||phoneProfes||'%' escape '\')
                and (LISTGROUP is null or LISTGROUP = '' or to_char(a.group_professor_id) in (
                select REGEXP_SUBSTR(LISTGROUP,'[^,]+', 1, level) from DUAL
                connect by REGEXP_SUBSTR(LISTGROUP, '[^,]+', 1, level) is not null ))
                and ((POPERATOR = 'ht' and ANSWER_TIME>LIMITTIME) or (POPERATOR = 'lt' and ANSWER_TIME<LIMITTIME) or (POPERATOR = 'eq' and ANSWER_TIME=LIMITTIME))
                and rownum <= pmax;
END TESTPROC_GETDETAILCALLPROFES;

PROCEDURE "TESTPROC_GETSUBGROUPPROFTHANN"
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  listGroupId in VARCHAR2,
  callerIn in VARCHAR2,           -- so dien thoai khach hang --> 6
  ptypeIn in number,              -- loai bao cao --> 8
  ptotalCallIn in number,         -- tong so cuoc goi --> 9
  callIdIn in VARCHAR2,           -- ma cuoc goi --> 11
  profePhone in VARCHAR2,
  acdTimeIn in VARCHAR2,          -- thoi gian dam thoai --> 13
  waitingTimeIn in VARCHAR2,      -- thoi gian cho --> 14
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 15
) AS

BEGIN
    if ptypeIn = 1 then
    -- chi tiet
        open rs for select a.call_id,
               a.caller,
               gp.GROUP_PROFESSOR_NAME,
               to_char(a.start_time,'dd/MM/yyyy hh24:mi:ss'),
               a.waiting_time,
               to_char(a.ring_time,'dd/MM/yyyy hh24:mi:ss'),
               to_char(a.connect_time,'dd/MM/yyyy hh24:mi:ss'),
               a.phone_professor,
               to_char(a.end_time,'dd/MM/yyyy hh24:mi:ss'),
               a.duration,
                (case when a.end_call_by = 0 then 'Do Chuy?n gia' else 'Do Kh?ch h?ng' end)
        from professors a join acd_full.group_professor gp on a.group_professor_id = gp.group_professor_id
        where a.START_TIME between FROMDATEIN and TODATEIN
        and (listGroupId is null or listGroupId = '' or to_char(a.group_professor_id) in (
          select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(listGroupId, '[^,]+', 1, level) is not null ))
        and (profePhone is null or profePhone = '' or lower(a.phone_professor) like '%'||profePhone||'%')
        and (callerIn is null or callerIn = '' or lower(a.caller) like '%'||callerIn||'%')
        and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%')
        and a.answer_time >= acdTimeIn
        and nvl(a.waiting_time,0) >= waitingTimeIn
        and rownum <= PMAXIN
        order by a.start_time;
    else
    -- tong hop
        open rs for select * from ( select * from
        (
            select a.caller as sodienthoai, count(distinct a.call_id) as solangoi
            from professors a
            where a.START_TIME between FROMDATEIN and TODATEIN
        and (listGroupId is null or listGroupId = '' or to_char(a.group_professor_id) in (
          select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(listGroupId, '[^,]+', 1, level) is not null ))
        and (profePhone is null or profePhone = '' or lower(a.phone_professor) like '%'||profePhone||'%')
        and (callerIn is null or callerIn = '' or lower(a.caller) like '%'||callerIn||'%')
        and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%')
        and a.answer_time >= acdTimeIn
        and nvl(a.waiting_time,0) >= waitingTimeIn
        and rownum <= PMAXIN
        group by caller
        ) where solangoi >= ptotalCallIn order by solangoi) where rownum <= pmaxIn;
    end if;
END TESTPROC_GETSUBGROUPPROFTHANN;

PROCEDURE proc_getgeneralinfocalltopro (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listGroup in VARCHAR2,
  ptimeType in number,
  pdur1 in number,
  pdur2 in number,
  pmax in number
) AS
BEGIN
   if ptimetype = 0 then
      open rs for select
          date_hour,
          sum(case when totalTime >= 0 then 1 else 0 end) total,
          sum(case when totalTime = 0 then 1 else 0 end) totalMis,
          sum(case when totalTime = 0 and status = 0 then 1 else 0 end) misspro,
          sum(case when totalTime = 0 and status = 1 then 1 else 0 end) misscus,
          sum(case when totalTime = 0 and status = 1 and totaldur >= pdur1 then 1 else 0 end) misscusNs,
          sum (case when totalTime > 0 then 1 else 0 end) meet,
          sum (case when totalTime > 0  and totalwait >= pdur2 then 1 else 0 end) meetNs
          from
          (
          select
          to_char(trunc(start_time),'dd-MM-yyyy') date_hour,
          sum(answer_time) totalTime, sum(end_call_by) status,
          sum(waiting_time) totalwait,
          sum(duration) totaldur
          from professors
          where start_time between fromDate and toDate
          and (listGroup is null or listGroup = '' or to_char(group_professor_id) in (
          select regexp_substr(listGroup,'[^,]+', 1, level) from dual
          connect by regexp_substr(listGroup, '[^,]+', 1, level) is not null ))
          group by call_id, trunc(start_time)
          )
          group by date_hour
          order by date_hour;
  else
          open rs for select
          date_hour,
          sum(case when totalTime >= 0 then 1 else 0 end) total,
          sum(case when totalTime = 0 then 1 else 0 end) totalMis,
          sum(case when totalTime = 0 and status = 0 then 1 else 0 end) misspro,
          sum(case when totalTime = 0 and status = 1 then 1 else 0 end) misscus,
          sum(case when totalTime = 0 and status = 1 and totaldur >= pdur1 then 1 else 0 end) misscusNs,
          sum (case when totalTime > 0 then 1 else 0 end) meet,
          sum (case when totalTime > 0  and totalwait >= pdur2 then 1 else 0 end) meetNs
          from
          (
          select
          to_char(TRUNC(start_time,'hh24'),'dd/mm/yyyy hh24:mi') date_hour,
          sum(answer_time) totalTime, sum(end_call_by) status,
          sum(waiting_time) totalwait,
          sum(duration) totaldur
          from professors
          where start_time between fromDate and toDate
          and (listGroup is null or listGroup = '' or to_char(group_professor_id) in (
          select regexp_substr(listGroup,'[^,]+', 1, level) from dual
          connect by regexp_substr(listGroup, '[^,]+', 1, level) is not null ))
          group by call_id, trunc(start_time,'hh24')
          )
          group by date_hour
          order by date_hour;
  end if;
END PROC_GETGENERALINFOCALLTOPRO;

*/
end ipcc_report;
/

