create PROCEDURE "DEL_DATA_CHAT" (tbl_name IN VARCHAR2,
                                             DAY_NUM  IN NUMBER)  IS
  ERR_MSG       VARCHAR2(1000);
  v_sql         VARCHAR2(500);
  STSQL         VARCHAR2(100);
  v_date            number;
  v_left_point number;
  v_partition_name  user_tab_partitions.partition_name%TYPE;
  v_high_value      user_tab_partitions.high_value%TYPE;
  CURSOR c1 IS select PARTITION_NAME, HIGH_VALUE
               from user_tab_partitions where table_name = tbl_name;
-- duongtb:15/03/2013
BEGIN
--  STSQL := 'Alter session set nls_date_format = ''yyyy-mm-dd hh24:mi:ss''';
--
--  EXECUTE IMMEDIATE STSQL;
  v_left_point := round((sysdate - DAY_NUM - to_date('01-JAN-1970','DD-MON-YYYY'))  * 24 * 60 * 60 * 1000);
  
  OPEN c1;
    LOOP
      FETCH c1 INTO v_partition_name, v_high_value;
      EXIT WHEN c1%NOTFOUND;
      v_date := to_number(SUBSTR(v_high_value,0));
      
      IF v_date < v_left_point then
--       INSERT_LOG('INFO', 'Begin delete partition', SYSDATE, STSQL);
--        v_sql := 'Alter table ' || tbl_name || ' drop partition ' || v_partition_name || ' update global indexes';
--        DBMS_OUTPUT.PUT_LINE(v_sql);
------        execute immediate v_sql;
--        EXECUTESQL(v_sql); 
        INSERT_LOG('FINISH','Deleted partition ' || v_partition_name,SYSDATE,v_sql);
      END IF;
    END LOOP;
    
  CLOSE c1;
EXCEPTION
  WHEN TIMEOUT_ON_RESOURCE THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('TIMEOUT_ON_RESOURCE ','Cannot delete partition ' || v_partition_name || 'Error is:' || 
ERR_MSG,SYSDATE,v_sql);
      ROLLBACK;
  WHEN STORAGE_ERROR THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('STORAGE_ERROR ','Cannot delete partition ' || v_partition_name || 'Error is:' || ERR_MSG,SYSDATE,v_sql);
      ROLLBACK;
  WHEN OTHERS THEN
      ERR_MSG := SUBSTR(SQLERRM, 1, 1000);
      INSERT_LOG('ERROR ','Cannot delete partition ' || v_partition_name || 'Error is:' || ERR_MSG,SYSDATE,v_sql);
    ROLLBACK;
END del_data_chat;

/

