create PROCEDURE insert_chat_stat (num out number,fromdate in date) 
--Author: duongtb
IS
  ERR_MSG VARCHAR2(1000);
  STRSQL VARCHAR2(50);
BEGIN
--  STRSQL := 'truncate table tf_chat_stat';
--  EXECUTE IMMEDIATE STRSQL;
 delete from tf_chat_stat where midate >= fromdate;
 commit;

--script tong hop nhat ky login/logout vao bang tf_agent_filo tu bang agent

insert into tf_chat_stat
(PRD_ID
,TIME_RANGE_ID
,MIDATE
,QUEUE_ID
,CALL_TYPE
,SERVICE_ID
,OFFERRED_CALLS
,ACD_CALLS
,MISSED_CALLS
,HOLD_CALLS
,CALLERS
,BLOCK_CALLS
,OVERFLOW_CALLS
,TRANSFER_CALLS
,ACW_CALLS
,ABN_CALLS
,DISC_CALLS
,ABN_RING_CALLS
,LOCALDIS_CALLS
,PICKUP_CALLS
,MAX_WAIT_TIME
,MAX_HANDLE_TIME
,HANDLE_TIME
,ACD_TIME
,HOLD_TIME
,WAIT_TIME
,ACW_TIME
,SLVL_ACD
,SLVL_ABN
,ABN_TIME
,MIN_WAIT_TIME
,MIN_HANDLE_TIME
,MIN_HOLD_TIME
,MAX_HOLD_TIME


)
select to_number(to_char(a.start_time, 'yyyymmdd')) prd_id
, nvl(b.time_range_id, -1) time_range_id
, trunc(a.start_time) midate
, a.first_queue queue_id
, case when a.type = 2 then 50 when a.type = 1 then 52 else 51 end  call_type
, a.service_id
, count(*) offerred_calls
, sum(case when answer_duration > 0 then 1 else 0 end) acd_calls
, sum(case when answer_duration = 0 or answer_duration is null then 1 else 0 end) missed_calls
, sum(case when hold_time>0 then 1 else 0 end) hold_calls
, count(distinct creator_visitor_id) callers
, sum(case when c.visitor_id is not null and (a.answer_duration = 0 or a.answer_duration is null) then 1 else 0 end) block_calls
, sum(case when overflow = 1 then 1 else 0 end) overflow_calls
, sum(case when is_transfer = 1 then 1 else 0 end) transfer_calls
, sum(case when acw_time > 0 then 1 else 0 end) ACW_CALLS
, sum(case when (answer_duration = 0 or answer_duration is null) and CUSTOMER_WAIT_DURATION <= 60 then 1 else 0 end) abn_calls
, sum(case when answer_duration = 0 or answer_duration is null and END_REASON = 3 then 1 else 0 end )  DISC_CALLS
,sum(case when CUSTOMER_WAIT_DURATION > 0 and status = 11 then 1 else 0 end) ABN_RING_CALLS
, sum(case when answer_duration = 0 or answer_duration is null and END_REASON = 2 then 1 else 0 end )  LOCALDIS_CALLS
, sum(case when answer_duration > 0 then 1 else 0 end) pickup_calls
, max(customer_wait_duration) max_wait_time
, max(nvl(answer_duration, 0)+nvl(hold_time, 0)) max_handle_time
, sum(nvl(answer_duration, 0)+nvl(hold_time, 0)) handle_time
, sum(time) acd_time
, sum(hold_time) hold_time
, sum(customer_wait_duration) wait_time
, sum(acw_time) acw_time
, sum(case when customer_wait_duration <= 60 and answer_duration > 0 then 1 else 0 end) slvl_acd
, sum(case when customer_wait_duration <= 60 and (answer_duration = 0 or answer_duration is null) then 1 else 0 end) slvl_abn
, sum(case when answer_duration = 0 or answer_duration is null then customer_wait_duration else 0 end) abn_time
, min(customer_wait_duration) min_wait_time
, min(nvl(answer_duration, 0)+nvl(hold_time, 0)) min_handle_time
, min(hold_time) min_hold_time
, max(hold_time) max_hold_time


from ipcc_chat_mb.conversation a, td_time_range b
, ipcc_chat_mb.banned_customer c 
where a.creator_visitor_id = c.visitor_id(+)
and a.start_time >= fromdate
and to_number(to_char(a.start_time, 'hh24'))*60 + to_number(to_char(a.start_time, 'mi')) >= b.start_value
and to_number(to_char(a.start_time, 'hh24'))*60 + to_number(to_char(a.start_time, 'mi')) <= b.end_value
group by to_number(to_char(a.start_time, 'yyyymmdd')), nvl(b.time_range_id, -1), 
trunc(a.start_time), a.first_queue, a.type, a.service_id
;

  --- commit all
  commit;
EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'INSERT_CHAT_STAT' || ERR_MSG,

  SYSDATE,

  '');
END INSERT_CHAT_STAT;

/

