create PROCEDURE insert_kpi (num out number ,fromdate in date) 
--Author: hoangbh1
IS
  ERR_MSG VARCHAR2(1000);
  STRSQL VARCHAR2(50);
  datekpi number;
BEGIN
--  STRSQL := 'truncate table tf_agent_filo';
--  EXECUTE IMMEDIATE STRSQL;
-- datekpi := 20140714;
 delete from kpi_entry where midate >= fromdate;
 commit;

--script insert chi so thuc te kpi cua object ghi nhan tren he thong 
--quality <= 0 and b.direction = 0 then 1 else 0 end quality --(actual - target) <= 0  -->dat
--quality >= 0 and b.direction = 1 then 1 else 0 end quality --(actual - target) >= 0  -->dat

------------------------------ KPI agent ----------------------------------
-- kpi So gio lam viec cua agent
insert into kpi_entry(prd_id, midate, kpi_obj_id, actual, disparity, quality)
select a.prd_id, a.midate
, c.kpi_obj_id 
, a.work_time actual 
, (a.work_time - b.target) DISPARITY
, CASE when (a.work_time - b.target) >= 0 and b.direction = 1 then 1 else 0 end quality --actual - target >= 0  -->dat
from (
  select prd_id, midate , agent_id, round(STAFF_TIME/ 3600, 2) work_time 
  from tf_agent_filo
  where midate >= fromdate
  and agent_id in (select obj_id from kpi_obj where kpi_id = 91)
  order by PRD_ID
) a
, (select target, direction from kpi where kpi_id = 91) b
, (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 91) c
where a.agent_id = c.obj_id

UNION ALL
--kpi so cuoc goi tiep nhan cua agent
select a.prd_id, a.midate
, c.kpi_obj_id 
, a.acd_calls actual
, (a.acd_calls - b.target) DISPARITY
, CASE when (a.acd_calls - b.target) >= 0 and b.direction = 1 then 1 else 0 end quality -- actual - target >= 0  -->dat
from (
  select prd_id, midate ,agent_id,sum(acd_calls) acd_calls 
  from TF_AGENT_QUEUE_STAT
  where midate >= fromdate
  and agent_id in (select obj_id from kpi_obj where kpi_id = 92)
  group by prd_id, midate, agent_id
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 92) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 92) c
where a.agent_id = c.obj_id 

UNION ALL
--kpi so cuoc goi chuyen cua agent
select a.prd_id, a.midate
, c.kpi_obj_id 
, a.transferred_calls actual
, (a.transferred_calls - b.target) DISPARITY
, CASE when (a.transferred_calls - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --actual - target <= 0  -->dat
from (
  select prd_id, midate , agent_id, sum(TRANSFERRED_CALLS) transferred_calls
  from TF_AGENT_QUEUE_STAT
  where midate >= fromdate
  and agent_id in (select obj_id from kpi_obj where kpi_id = 93)
  group by prd_id, midate, agent_id
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 93) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 93) c
where a.agent_id = c.obj_id  

UNION ALL
--kpi so cuoc goi rot cua agent
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.missed_calls actual
, (a.missed_calls - b.target) DISPARITY
, CASE when (a.missed_calls - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --actual - target <= 0  -->dat
from (
  select prd_id, midate , agent_id, sum(LOCALDIS_CALLS) missed_calls
  from TF_AGENT_QUEUE_STAT
  where midate >= fromdate
  and agent_id in (select obj_id from kpi_obj where kpi_id = 94)
  group by prd_id, midate, agent_id
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 94) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 94) c
where a.agent_id = c.obj_id 

UNION ALL
--kpi thoi gian xu ly cuoc goi trung binh cua agent
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.avg_handle_time actual
, (a.avg_handle_time - b.target) DISPARITY
, CASE when (a.avg_handle_time - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --actual - target <= 0  -->dat
from (
  select prd_id, midate , agent_id, case when sum(acd_calls) <> 0 then round(sum(HANDLE_TIME) / sum(acd_calls)) else 0 end  avg_handle_time
  from TF_AGENT_QUEUE_STAT
  where midate >= fromdate
  and agent_id in (select obj_id from kpi_obj where kpi_id = 95)
  group by prd_id, midate, agent_id
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 95) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 95) c
where a.agent_id = c.obj_id 

UNION ALL
--kpi lan nhap thong tin loi cua agent
--So lan sua thong tin = so ban ghi trong bang process_request voi action_code = CORRECTION
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.total actual
, (a.total - b.target) DISPARITY
, CASE when (a.total - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --actual - target <= 0  -->dat
from (
    select to_char(trunc(PROCESS_DATE),'yyyyMMdd') PRD_ID , trunc(PROCESS_DATE) midate ,USER_NAME agent_id , count(*) total
    from cc_owner.process_request 
    where to_char(trunc(PROCESS_DATE),'yyyyMMdd') >= fromdate
    and ACTION_CODE = 'CORRECTION'
    group by USER_NAME, to_char(trunc(PROCESS_DATE),'yyyyMMdd'), trunc(PROCESS_DATE)
    ) a,
  (select target, direction from kpi where kpi_id = 181) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 181) c
where a.agent_id = c.obj_id 
  
  UNION ALL
--kpi lan nhap thong tin cua agent
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.total actual
, (a.total - b.target) DISPARITY
, CASE when (a.total - b.target) >= 0 and b.direction = 1 then 1 else 0 end quality --(actual - target) >= 0  -->dat
from (
    select to_char(trunc(create_date),'yyyyMMdd') prd_id, trunc(create_date) midate, user_agent agent_id,  count(*) total
    from cc_owner.request 
    where status = 1
    and to_char(trunc(create_date),'yyyyMMdd') >= fromdate
    group by user_agent, to_char(trunc(create_date),'yyyyMMdd'), trunc(create_date)
  ) a,
  (select target, direction from kpi where kpi_id = 182) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 182) c
where a.agent_id = c.obj_id   
  
UNION ALL
--ti le xu ly khieu nai dung han
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.rate actual
, (a.rate - b.target) DISPARITY
, CASE when (a.rate - b.target) >= 0 and b.direction = 1 then 1 else 0 end quality --(actual - target) >= 0  -->dat
from (
    select prd_id, midate , called obj, round(process/total, 2)*100 rate 
    from ( 
      select to_char(trunc(CREATE_DATE),'yyyyMMdd') prd_id , trunc(create_date) midate, b.called
      ,count(distinct request_id) total
      ,sum(case when (response_date <= response_limit_date) then 1 else 0 end) process
      from cc_owner.request a, (select call_id , called from callinfo) b
      where a.BUSINESS_ID = 5--in (select BUSINESS.BUSINESS_ID from BUSINESS where BUSINESS.PARENT_ID = 3)
      and a.call_id = b.call_id
      and to_char(trunc(CREATE_DATE),'yyyyMMdd') >= fromdate
      group by to_char(trunc(CREATE_DATE),'yyyyMMdd'), trunc(create_date), b.called
      order by prd_id 
    )) a,
  (select target, direction from kpi where kpi_id = 186) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 186) c
  where a.obj = c.obj_id

UNION ALL
--ti le xu ly khieu nai qua han luy ke
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.rate actual
, (a.rate - b.target) DISPARITY
, CASE when (a.rate - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --(actual - target) <= 0  -->dat
from (
    select prd_id, midate , called obj, round(not_process/total, 2)*100 rate 
    from ( 
      select to_char(trunc(CREATE_DATE),'yyyyMMdd') prd_id ,trunc(create_date) midate ,  b.called
      ,count(distinct request_id) total
      ,sum(case when (response_date is null or response_date > response_limit_date) then 1 else 0 end) not_process
      from cc_owner.request a, (select call_id , called from callinfo) b
      where a.BUSINESS_ID = 5--in (select BUSINESS.BUSINESS_ID from BUSINESS where BUSINESS.PARENT_ID = 3)
      and a.call_id = b.call_id 
      and to_char(trunc(CREATE_DATE),'yyyyMMdd') >= fromdate
      group by to_char(trunc(CREATE_DATE),'yyyyMMdd'), trunc(create_date), b.called
      order by prd_id 
    )) a,
  (select target, direction from kpi where kpi_id = 187) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 187) c
  where a.obj = c.obj_id
  
  
  
-----------------##########------------- KPI system---------------#############-------------------
UNION ALL
--kpi so cuoc goi vao he thong
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.OFFERRED_CALLS actual
, (a.OFFERRED_CALLS - b.target) DISPARITY
, CASE when (a.OFFERRED_CALLS - b.target) >= 0 and b.direction = 1 then 1 else 0 end quality -- actual - target >= 0  -->dat
from (
  select prd_id, midate , called, sum(OFFERRED_CALLS) OFFERRED_CALLS
  from TF_QUEUE_STAT
  where midate >= fromdate
  and called in (select obj_id from kpi_obj where kpi_id = 82)
  group by prd_id, midate, called
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 82) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 82) c
where a.called = c.obj_id  

UNION ALL
--kpi S? cu?c g?p ???c Agent
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.ACD_CALLS actual
, (a.ACD_CALLS - b.target) DISPARITY
, CASE when (a.ACD_CALLS - b.target) >= 0 and b.direction = 1 then 1 else 0 end quality -- actual - target >= 0  -->dat
from (
  select prd_id, midate , called, sum(ACD_CALLS) ACD_CALLS
  from TF_QUEUE_STAT
  where midate >= fromdate
  and called in (select obj_id from kpi_obj where kpi_id = 83)
  group by prd_id, midate, called
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 83) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 83) c
where a.called = c.obj_id

UNION ALL
--kpi S? cu?c rot 
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.MISSED_CALLS actual
, (a.MISSED_CALLS - b.target) DISPARITY
, CASE when (a.MISSED_CALLS - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --actual - target <= 0  -->dat
from (
  select prd_id, midate , called, sum(MISSED_CALLS) MISSED_CALLS
  from TF_QUEUE_STAT
  where midate >= fromdate
  and called in (select obj_id from kpi_obj where kpi_id = 88)
  group by prd_id, midate, called
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 88) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 88) c
where a.called = c.obj_id

UNION ALL
--ti le ket noi thanh cong voi agent trong thoi gian quy dinh (20s)
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.rate_connect actual
, (a.rate_connect - b.target) DISPARITY
, CASE when (a.rate_connect - b.target) >= 0 and b.direction = 1 then 1 else 0 end quality --actual - target >= 0  -->dat
from (
  select prd_id, midate , called, round((sum(SLVL_ACD)/ sum(acd_calls)) * 100) rate_connect
  from TF_QUEUE_STAT
  where midate >= fromdate
  and called in (select obj_id from kpi_obj where kpi_id = 89)
  and acd_calls > 0
  group by prd_id, midate, called
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 89) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 89) c
where a.called = c.obj_id

UNION ALL
--thoi gian cho trung binh cua tat ca cac cuoc goi
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.avg_wait_time actual
, (a.avg_wait_time - b.target) DISPARITY
, CASE when (a.avg_wait_time - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --actual - target <= 0  -->dat
from (
  select prd_id, midate , called, round(sum(wait_time)/sum(offerred_calls)) avg_wait_time
  from TF_QUEUE_STAT
  where midate >= fromdate
  and called in (select obj_id from kpi_obj where kpi_id = 96)
  group by prd_id, midate, called
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 96) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 96) c
where a.called = c.obj_id

UNION ALL
--thoi gian xu ly cuoc goi trung binh
select a.prd_id, a.midate
, c.kpi_obj_id --, b.target
, a.avg_handle_time actual
, (a.avg_handle_time - b.target) DISPARITY
, CASE when (a.avg_handle_time - b.target) <= 0 and b.direction = 0 then 1 else 0 end quality --actual - target <= 0  -->dat
from (
  select prd_id, midate , called, round((sum(handle_time)/ sum(acd_calls))) avg_handle_time
  from TF_QUEUE_STAT
  where midate >= fromdate
  and called in (select obj_id from kpi_obj where kpi_id = 97)
  and acd_calls > 0
  group by prd_id, midate, called
  order by PRD_ID) a,
  (select target, direction from kpi where kpi_id = 97) b, 
  (select kpi_obj_id, obj_id from kpi_obj where kpi_id = 97) c
where a.called = c.obj_id
;
  --- commit all
  commit;
EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'INSERT_AGENT_FILO' || ERR_MSG,

  SYSDATE,

  '');
END INSERT_KPI;

/

