create PROCEDURE insert_mail_stat (num out number,fromdate in date) 
--Author: hoangbh1
IS
  ERR_MSG VARCHAR2(1000);
  STRSQL VARCHAR2(50);
BEGIN
--  STRSQL := 'truncate table tf_email_stat';
--  EXECUTE IMMEDIATE STRSQL;
 delete from tf_email_stat where MIDATE >= fromdate;
 commit;

--script tong hop email vao bang tf_email_stat tu bang email_receive
insert into  TF_EMAIL_STAT( 
PRD_ID
,TIME_RANGE_ID
,MIDATE
,MAIL_GROUP
,CALL_TYPE
,OFFERRED_CALLS
,ACD_CALLS
,MISSED_CALLS
,CALLED
,CALLERS
,HANDLE_TIME
,MAX_HANDLE_TIME
,MIN_HANDLE_TIME
,WAIT_TIME
,MAX_WAIT_TIME
,MIN_WAIT_TIME
,REPLY_TIME
,MAX_REPLY_TIME
,MIN_REPLY_TIME
,SKILL_ID
)
select to_number(to_char(trunc(a.EMAIL_RECEIVE_DATE),'yyyyMMdd')) PRD_ID
,nvl(c.time_range_id, -1) TIME_RANGE_ID
,trunc(a.EMAIL_RECEIVE_DATE) MIDATE
, a.service_group MAIL_GROUP
, d.system CALL_TYPE
,sum(case when a.EMAIL_ID is not null then 1 else 0 end ) OFFERRED_CALLS -- tong so mail
,sum(case when a.AGENT_PROCESS is not null then 1 else 0 end) ACD_CALLS
,sum(case when a.AGENT_PROCESS is null then 1 else 0 end) MISSED_CALLS -- so mail khong toi agent
,count(email_to) CALLED
,count(distinct a.EMAIL_FROM) CALLERS
,sum(handle_dura) HANDLE_TIME
,max(handle_dura) MAX_HANDLE_TIME
,min(handle_dura) MIN_HANDLE_TIME
,sum(wait_time) WAIT_TIME
,max(wait_time) MAX_WAIT_TIME
,min(wait_time) MIN_WAIT_TIME
,sum(reply_time) REPLY_TIME
,max(reply_time) MAX_REPLY_TIME
,min(reply_time) MIN_REPLY_TIME
,d.skill_id
from (
  select EMAIL_RECEIVE_ID email_id, EMAIL_RECEIVE_DATE, AGENT_PROCESS, EMAIL_FROM, email_to, service_group
  from ipcc_email_mb.email_receive) a, 
  (select email_id
  , sum(case when command in(3) then duration else 0 end ) handle_dura
  , sum(case when command in(0,1,2) then duration else 0 end ) wait_time
  , sum(case when command in(4,5,6) then duration else 0 end ) reply_time
  from ipcc_email_mb.EMAIL_RECEIVE_LOG
  group by email_id
  order by EMAIL_ID) b, TD_TIME_RANGE c, IPCC_EMAIL_MB.EMAIL_ACCOUNT d
where a.email_id = b.email_id
and a.service_group = d.service_group(+)
and a.EMAIL_RECEIVE_DATE >= fromdate
and to_number(to_char(a.EMAIL_RECEIVE_DATE, 'hh24'))*60 + to_number(to_char(a.EMAIL_RECEIVE_DATE, 'mi')) >= c.start_value(+)
and to_number(to_char(a.EMAIL_RECEIVE_DATE, 'hh24'))*60 + to_number(to_char(a.EMAIL_RECEIVE_DATE, 'mi')) <= c.end_value(+)
group by to_number(to_char(trunc(a.EMAIL_RECEIVE_DATE),'yyyyMMdd'))
,nvl(c.time_range_id, -1)
,trunc(a.EMAIL_RECEIVE_DATE)
,a.service_group
,d.system 
,SKILL_ID
order by prd_id
;
  --- commit all
  commit;
EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'INSERT_MAIL_STAT' || ERR_MSG,

  SYSDATE,

  '');
END INSERT_MAIL_STAT;

/

