create PROCEDURE insert_voice_stat (num out number,fromdate in date)
--Author: thangld2
IS
  ERR_MSG VARCHAR2(1000);
  STRSQL VARCHAR2(50);
BEGIN
--  STRSQL := 'truncate table tf_voice_stat';
--  EXECUTE IMMEDIATE STRSQL;
 delete from tf_voice_stat where prd_id >= to_number(to_char(trunc(fromdate),'yyyyMMdd'));
 commit;

--script tong hop voice vao bang tf_voice_stat tu bang tf_queue_stat, tf_email_stat, tf_chat_stat
INSERT
INTO tf_voice_stat
  (
    PRD_ID,
    SKILL_ID,
    CALL_TYPE,
    OFFERRED_CALLS,
    CALLERS,
    ACD_CALLS,
    OVERFLOW_CALLS,
    ACW_CALLS,
    TRANSFER_CALLS,
    TALK_TIME,
    HANDLE_TIME,
    HOLD_TIME,
    WAIT_TIME,
    MISSED_CALLS
  )
SELECT PRD_ID,
  NVL(SKILL_ID,  -1) SKILL_ID,
  NVL(CALL_TYPE, -1) CALL_TYPE,
  NVL(OFFERRED_CALLS, 0) OFFERRED_CALLS,
  NVL(CALLERS, 0)CALLERS,
  NVL(ACD_CALLS, 0) ACD_CALLS,
  NVL(OVERFLOW_CALLS, 0) OVERFLOW_CALLS,
  0 ACW_CALLS,
  NVL(TRANSFER_CALLS, 0) TRANSFER_CALLS,
  NVL(TALK_TIME, 0) TALK_TIME,
  NVL(HANDLE_TIME, 0) HANDLE_TIME,
  NVL(HOLD_TIME, 0) HOLD_TIME,
  NVL(WAIT_TIME, 0) WAIT_TIME,
  NVL(MISSED_CALLS, 0) MISSED_CALLS
FROM tf_queue_stat
where prd_id >= to_number(to_char(trunc(fromdate),'yyyyMMdd'))
UNION ALL
SELECT PRD_ID,
  NVL(SKILL_ID,  -1) SKILL_ID,
  NVL(CALL_TYPE, -1) CALL_TYPE,
  NVL(OFFERRED_CALLS, 0) OFFERRED_CALLS,
  NVL(CALLERS, 0) CALLERS,
  NVL(ACD_CALLS, 0) ACD_CALLS,
  NVL(OVERFLOW_CALLS, 0) OVERFLOW_CALLS,
  NVL(ACW_CALLS, 0) ACW_CALLS,
  NVL(TRANSFER_CALLS, 0) TRANSFER_CALLS,
  NVL(TALK_TIME, 0) TALK_TIME,
  NVL(HANDLE_TIME, 0) HANDLE_TIME,
  NVL(HOLD_TIME, 0) HOLD_TIME,
  NVL(WAIT_TIME, 0) WAIT_TIME,
  NVL(MISSED_CALLS, 0) MISSED_CALLS
FROM tf_email_stat
where prd_id >= to_number(to_char(trunc(fromdate),'yyyyMMdd'))
UNION ALL
SELECT PRD_ID,
  NVL(SKILL_ID,  -1) SKILL_ID,
  NVL(CALL_TYPE, -1) CALL_TYPE,
  NVL(OFFERRED_CALLS, 0) OFFERRED_CALLS,
  NVL(CALLERS, 0)  CALLERS,
  NVL(ACD_CALLS, 0) ACD_CALLS,
  NVL(OVERFLOW_CALLS, 0) OVERFLOW_CALLS,
  NVL(ACW_CALLS, 0) ACW_CALLS,
  NVL(TRANSFER_CALLS, 0) TRANSFER_CALLS,
  NVL(TALK_TIME, 0) TALK_TIME,
  NVL(HANDLE_TIME, 0) HANDLE_TIME,
  NVL(HOLD_TIME, 0) HOLD_TIME,
  NVL(WAIT_TIME, 0) WAIT_TIME,
  NVL(MISSED_CALLS, 0) MISSED_CALLS
FROM tf_chat_stat
where prd_id >= to_number(to_char(trunc(fromdate),'yyyyMMdd'))
--lay thong tin voice mail
UNION ALL
SELECT PRD_ID,
  NVL(SKILL_ID,  -1) SKILL_ID,
  NVL(CALL_TYPE, -1) CALL_TYPE,
  NVL(OFFERRED_CALLS, 0) OFFERRED_CALLS,
  NVL(CALLER, 0) CALLERS,
  NVL(ACD_CALLS, 0) ACD_CALLS,
  NVL(OVERFLOW_CALLS, 0) OVERFLOW_CALLS,
  NVL(ACW_CALLS, 0) ACW_CALLS,
  0 TRANSFER_CALLS,
  0 TALK_TIME,
  NVL(HANDLE_TIME, 0) HANDLE_TIME,
  0 HOLD_TIME,
  0 WAIT_TIME,
  NVL(MISSED_CALLS, 0) MISSED_CALLS
FROM tf_voicemail_stat
where PRD_ID >= to_number(to_char(trunc(fromdate),'yyyyMMdd'))
;
  --- commit all
  commit;
EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'INSERT_VOICE_STAT' || ERR_MSG,

  SYSDATE,

  '');
END INSERT_VOICE_STAT;

/

