create PROCEDURE "PARTITION_CHAT_MESSAGE" (TABLE_NAME IN VARCHAR, PREFIX IN VARCHAR, LENGTH IN NUMBER) IS

  ERR_MSG VARCHAR2(1000);

  STRSQL VARCHAR2(2000);

  WNEWPARTITION VARCHAR2(28);

  WVALUELESSTHAN NUMBER;

  STSQL VARCHAR2(500);
  
  WMONPARTITION VARCHAR(10);
  
  WTABLESPACE VARCHAR(100);

BEGIN
  WTABLESPACE:='IPCC_CHAT';
  STSQL := 'Alter session set nls_date_format = ''dd/mm/yyyy''';

  EXECUTE IMMEDIATE STSQL;

  INSERT_LOG('INFO', 'Begin create partition', SYSDATE, STSQL);  

  --Dat ten parttion	 
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH, 'yyyymmdd')

  INTO WNEWPARTITION

  FROM DUAL;
  
  --Khoang gia tri phan chia partition
  SELECT (TRUNC(SYSDATE)+LENGTH +1-TO_DATE('01011970','DDMMYYYY')) *60*60*24*1000 
  INTO WVALUELESSTHAN
  from DUAL;

  --Cau lenh thuc hien danh partition
  STRSQL := 'Alter table ' || TABLE_NAME || ' ADD PARTITION ' || PREFIX ||

  WNEWPARTITION || ' values less than ('|| WVALUELESSTHAN || ') tablespace '|| WTABLESPACE;

  EXECUTESQL(STRSQL);

  INSERT_LOG('FINISH',

  'Created partition ' || WNEWPARTITION,

  SYSDATE,

  STRSQL);

  RETURN;

EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'Cannot create partition ' || WNEWPARTITION || '

  Error is:' || ERR_MSG,

  SYSDATE,

  STRSQL);

END;

/

