create PROCEDURE "PARTITION_CREATE_TABLE" (TABLE_NAME IN VARCHAR, PREFIX IN VARCHAR, LENGTH IN NUMBER) IS

  ERR_MSG VARCHAR2(1000);

  STRSQL VARCHAR2(2000);

  WNEWPARTITION VARCHAR2(28);

  WVALUELESSTHAN VARCHAR2(28);

  STSQL VARCHAR2(500);
  
  WMONPARTITION VARCHAR(10);
  
  WTABLESPACE VARCHAR(100);

BEGIN

  STSQL := 'Alter session set nls_date_format = ''dd/mm/yyyy''';

  EXECUTE IMMEDIATE STSQL;

  INSERT_LOG('INFO', 'Begin create partition', SYSDATE, STSQL);
  
  --Lay month cua partition
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH, 'MM')

  INTO WMONPARTITION

  FROM DUAL;
  
  --Lua chon tablespace cho partition
  if '01' <= WMONPARTITION AND WMONPARTITION <= '03' THEN
     WTABLESPACE:='IPCC_DATA2012_I';  
  
  elsif '04' <= WMONPARTITION AND WMONPARTITION <= '06' THEN
     WTABLESPACE:='IPCC_DATA2012_II';	
  
  elsif '07' <= WMONPARTITION AND WMONPARTITION <= '09' THEN
     WTABLESPACE:='IPCC_DATA2012_III';
	 
  elsif '10' <= WMONPARTITION AND WMONPARTITION <= '12' THEN
     WTABLESPACE:='IPCC_DATA2012_IV';     
  else
     WTABLESPACE:='IPCC_CCMS';
    
  end if; 
	 
  --Dat ten parttion	 
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH, 'yyyymmdd')

  INTO WNEWPARTITION

  FROM DUAL;
  
  --Khoang gia tri phan chia partition
  SELECT TO_CHAR(TRUNC(SYSDATE) + LENGTH+ 1, 'dd/mm/yyyy')

  INTO WVALUELESSTHAN

  FROM DUAL;

  --Cau lenh thuc hien danh partition
  STRSQL := 'Alter table ' || TABLE_NAME || ' ADD PARTITION ' || PREFIX ||

  WNEWPARTITION || ' values less than (TO_DATE(''' ||

  TO_CHAR(WVALUELESSTHAN) ||

  ''' ,''dd/mm/yyyy'')) tablespace '|| WTABLESPACE;

  EXECUTESQL(STRSQL);

  INSERT_LOG('FINISH',

  'Created partition ' || WNEWPARTITION,

  SYSDATE,

  STRSQL);

  RETURN;

EXCEPTION

  WHEN OTHERS THEN

  ERR_MSG := SUBSTR(SQLERRM, 1, 1000);

  INSERT_LOG('ERROR ',

  'Cannot create partition ' || WNEWPARTITION || '

  Error is:' || ERR_MSG,

  SYSDATE,

  STRSQL);

END;

/

