create PROCEDURE "PROC_AGENTINQUEUE" (
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  listQueue in VARCHAR2,       -- danh sach queue --> 5
  agentIdIn in VARCHAR2,            -- ten nhan vien --> 12
  pmaxIn in number 
) AS 
BEGIN
   open rs for select a.agent_id, b.queue_id ,to_char(a.start_time,'dd-MM-yyyy hh24:mi') 
      from agent a join acd.queue_agent b on a.device_id = b.agent_id 
      where a.status = 1 
      and a.START_TIME between FROMDATEIN and TODATEIN
      and (listQueue is null or listQueue = '' or lower(b.queue_id) in (
              select regexp_substr(listQueue,'[^,]+', 1, level) from dual
              connect by regexp_substr(listQueue, '[^,]+', 1, level) is not null ))
      and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%' escape '\')
      and rownum <= PMAXIN
      order by a.start_time desc;
END proc_agentinqueue;

/

