create PROCEDURE "PROC_DOSEARCH2_WS" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date,   
  pagentid in varchar2,
  pcaller in varchar2,
  pminduration in number,
  pmaxduration in number,
  prn in number,
  prownum in number  
) AS
begin         
     open RS for 
          select agent_id, startd, ring, connectd, endt, conference_time, url, caller, called  from (  
          select agent_id                
          , to_char(start_time,'yyyy-MM-dd hh24:mi:ss') as startd
          ,to_char(ring_time,'yyyy-MM-dd hh24:mi:ss') as ring
          ,to_char(connect_time,'yyyy-MM-dd hh24:mi:ss') as connectd
          ,to_char(end_time,'yyyy-MM-dd hh24:mi:ss') as endt 
          ,answer_time as conference_time, url, caller, called
          ,row_number() over (partition by agent_id order by dbms_random.value) rn                      
          from call 
          where START_TIME BETWEEN fromdate and todate
        --  and answer_time > 0
          and call_type = 0 
       
         and (agent_id in (select REGEXP_SUBSTR(pagentid,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(pagentid, '[^,]+', 1, level) is not null )) 
          --and (pcaller is null or pcaller = '' or caller like '%'||pcaller||'%')
          and caller like '%'||pcaller||'%'
          and answer_time between pminduration and pmaxduration)
          where rn<=prn 
          and rownum<=prownum          
 ;
END PROC_DOSEARCH2_WS;

/

