create PROCEDURE "PROC_GETAVGWAITINGTIME" (
-- thong ke thoi gian cho trung binh
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pjoined in number,
  pmax in number
) AS
BEGIN
  if ptimetype = 0 then
    open rs for select to_char(trunc(start_time,'hh24'),'dd-MM-yyyy hh24:mi:ss') as date_hour,  
    count(distinct call_id) total_call, 
    round(max(case when first_connect_time is null then duration else waiting_time end)) time_max, 
    round(min(case when first_connect_time is null then duration else waiting_time end)) time_min, 
    round(avg(case when first_connect_time is null then duration else waiting_time end)) time_av 
    from callinfo where start_time between fromDate and toDate 
   -- and insert_time between fromDate and toDate 
    and (pcustlevel = -1 or customer_level = pcustLevel) 
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))  
    and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0)) 
    -- add is_missing: missing (0) or not (1) to simplify this query
    group by trunc(start_time,'hh24'); 
  else
    open rs for select to_char(trunc(start_time),'dd-MM-yyyy') as date_hour,  
    count(distinct call_id) total_call, 
    round(max(case when first_connect_time is null then duration else waiting_time end)) time_max, 
    round(min(case when first_connect_time is null then duration else waiting_time end)) time_min, 
    round(avg(case when first_connect_time is null then duration else waiting_time end)) time_av 
    from callinfo where start_time between fromDate and toDate 
   -- and insert_time between fromDate and toDate 
    and (pcustlevel = -1 or customer_level = pcustLevel) 
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))  
    and (pjoined = -1 or joined = pjoined or (pjoined > 0 and joined > 0)) 
    group by trunc(start_time);
  end if;
END PROC_GETAVGWAITINGTIME;

/

