create PROCEDURE "PROC_GETCALLBYFIRSTNUMBER" (
 --THONG KE THEO DAU SO KHACH HANG
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pcallType in number,
  ptype in number,
  listShortCode in VARCHAR2,
  pwaitTime in number,
  pduration in number,
  pmax in number
) AS
BEGIN
    open rs for select b.short_code_id,a.called,count(*) as num_call,
    count(DISTINCT a.caller) as num_caller, 
    round(avg(a.duration)) as avgTime, 
    count( case when a.acd_time < 10 then a.call_id end) as haveNoDemand, 
    count( case when a.acd_time >= 10 then a.call_id end) as haveDemand, 
    round(avg(case when a.acd_time < 10 then a.duration end)) as timeNoDemand, 
    round(avg(case when a.acd_time >= 10 then a.duration end)) as timeHaveDemand, 
    b.short_code_name from callinfo a, short_code b 
    where a.start_time between fromDate and toDate 
    and substr(a.caller,1, length(b.short_code_id)) = b.short_code_id 
    and a.call_type = 0 and a.called_type = 1
    and (listLine is null or listLine = '' or called in (
      select regexp_substr(listLine,'[^,]+', 1, level) from dual
      connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    and (listshortcode is null or listshortcode = '' or b.short_code_id in (
      select regexp_substr(listShortCode,'[^,]+', 1, level) from dual
      connect by regexp_substr(listShortCode, '[^,]+', 1, level) is not null ))
    and a.start_time between fromDate and toDate 
    group by b.short_code_id ,a.called,b.short_code_name;
END PROC_GETCALLBYFIRSTNUMBER;

/

