create PROCEDURE "PROC_GETCALLBYHH" (
 -- thong ke theo thoi gian nghe (kenh IVR)
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    -- theo gio
    open rs for select to_char(trunc(a.start_time,'hh24'),'dd-MM-yyyy hh24:mi:ss') as date_hour, 
    a.called , count(a.call_id) as totalCalls , 
    count(DISTINCT a.caller) as totalCallers, 
    sum(duration) as totalTimes ,  
    max(duration) as maxTime,
    min(duration) as minTime,  
    trunc(avg (duration),3) as avgTime  
     from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate 
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    group by trunc(a.start_time,'hh24'), a.called; 
  else
  -- theo ngay
    open rs for select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour, 
    a.called , count(a.call_id) as totalCalls , 
    count(DISTINCT a.caller) as totalCallers, 
     sum(duration) as totalTimes ,  
    max(duration) as maxTime,
    min(duration) as minTime,  
    trunc(avg (duration),3) as avgTime  
     from callinfo a where a.start_time between fromDate and toDate
 --   and  a.insert_time between fromDate and toDate 
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    group by trunc(a.start_time);  
  end if;
END PROC_GETCALLBYHH;

/

