create PROCEDURE "PROC_GETCALLERDETAIL" (
--THONG KE CHI TIET KHACH HANG
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  pwaitTime in number,
  pduration in number,
  pmax in number
) AS
BEGIN
    open rs for select * from  (select caller, count(distinct call_id) total,
    count(distinct case when joined >=1 then call_id end) total_meet, 
    count(distinct case when (joined = 0 or joined is null) then call_id end) total_miss 
    from callinfo 
    where  start_time between fromDate and toDate
    and (pcustlevel = -1 or customer_level = pcustLevel)
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%' escape '\') 
    and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and dial_error not like '%19%'
    group by caller) 
    where rownum <=pmax;
END PROC_GETCALLERDETAIL;

/

