create PROCEDURE "PROC_GETCALLHISTORY" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  pcalled in VARCHAR2,
  pcaller in VARCHAR2,
  pcustLevel in number,
  ptype in number,
  pcallid in VARCHAR2,
  poriAddr in VARCHAR2,
  pmidAgent in VARCHAR2,
  plistTransType in VARCHAR2,
  pmax in number
) AS
BEGIN
  if ptype = 0 then
    -- thong ke theo nguoi tac dong
    
    open rs for select a.mid_agent, count(case when a.trans_type=1 then a.call_id end ), 
    count(case when a.trans_type=3 then a.call_id end ), 
    count(case when a.trans_type=5 then a.call_id end ), 
    count(case when a.trans_type=2 then a.call_id end ), 
    count(case when a.trans_type=9 then a.call_id end ),
    count(case when a.trans_type=8 then a.call_id end )  
    from trans_info a where a.insert_time  between fromDate and toDate and  a.invoke_start_time between fromDate and toDate 
    and a.called = pcalled 
    and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%')   
    and (pcallid is null or pcallid = '' or lower(call_id) = pcallid)  
    and (pmidAgent is null or pmidAgent = '' or lower(mid_agent)= pmidAgent)  
    and (poriAddr is null or poriAddr = '' or lower(ori_addr)= poriAddr)
    and (plistTransType is null or plistTransType = '' or trans_type in (
          select regexp_substr(plistTransType,'[^,]+', 1, level) from dual
          connect by regexp_substr(plistTransType, '[^,]+', 1, level) is not null ))  
    group by a.mid_agent; 
  else
     -- thong ke theo nguoi bi tac dong
     if ptype = 1 then
       open rs for select a.ori_addr, count(case when a.trans_type=1 then a.call_id end ), 
       count(case when a.trans_type=3 then a.call_id end ), 
       count(case when a.trans_type=5 then a.call_id end ), 
       count(case when a.trans_type=2 then a.call_id end ), 
       count(case when a.trans_type=9 then a.call_id end ), 
       count(case when a.trans_type=8 then a.call_id end )  
       from trans_info a where a.insert_time  between fromDate and toDate and a.invoke_start_time between fromDate and toDate 
        and a.called = pcalled 
        and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%')   
        and (pcallid is null or pcallid = '' or lower(call_id) = pcallid)  
        and (pmidAgent is null or pmidAgent = '' or lower(mid_agent)= pmidAgent)  
        and (poriAddr is null or poriAddr = '' or lower(ori_addr)= poriAddr)
        and (plistTransType is null or plistTransType = '' or trans_type in (
              select regexp_substr(plistTransType,'[^,]+', 1, level) from dual
              connect by regexp_substr(plistTransType, '[^,]+', 1, level) is not null ))   
       group by a.ori_addr; 
     else 
       open rs for select a.call_id,a.caller,a.called,a.ori_addr,a.mid_agent,a.dest_addr, 
       to_char(a.call_start_time,'dd/mm/yyyy hh24:mi:ss') as call_start_time, 
       to_char(a.call_end_time,'dd/mm/yyyy hh24:mi:ss'), 
       to_char(a.invoke_start_time,'dd/mm/yyyy hh24:mi:ss'), 
       to_char(a.invoke_end_time,'dd/mm/yyyy hh24:mi:ss'),
       b.trans_type_name from trans_info a, trans_type b 
       where a.trans_type = b.trans_type_code 
       and a.insert_time  between fromDate and toDate and a.invoke_start_time between fromDate and toDate 
        and a.called = pcalled 
        and (pcaller is null or pcaller = '' or caller like '%' || pcaller || '%')   
        and (pcallid is null or pcallid = '' or lower(call_id) = pcallid)  
        and (pmidAgent is null or pmidAgent = '' or lower(mid_agent)= pmidAgent)  
        and (poriAddr is null or poriAddr = '' or lower(ori_addr)= poriAddr)
        and (plistTransType is null or plistTransType = '' or trans_type in (
              select regexp_substr(plistTransType,'[^,]+', 1, level) from dual
              connect by regexp_substr(plistTransType, '[^,]+', 1, level) is not null )) 
       order by a.call_start_time; 
     end if;
  end if;
END PROC_GETCALLHISTORY;

/

