create PROCEDURE "PROC_GETDTMFSTATISTIC" (
 -- THONG KE TONG HOP PHIM BAM
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcustLevel in number,
  pcaller in VARCHAR2,
  pdtmf in VARCHAR2,
  pcontent in VARCHAR2,
  pwaitTime in number,
  pmax in number
) AS
BEGIN
     open rs for select a.dtmf, b.ivr_code,count(a.call_id) as numCall, 
     sum(a.duration) as totalTime,  trunc(avg(a.duration)/60,3) as avgTime , 
     round(max(a.duration)/60 + 0.499) as maxTime ,  
     round(min(a.duration)/60 + 0.499) as minTime, 
     sum(number_of_visits) from dtmf_log a, ivr_tree b 
     where a.dtmf=b.dtmf and a.called=b.root_node 
     and a.start_time between fromDate and toDate 
     and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))  
     and (pdtmf is null or pdtmf = '' or a.dtmf like '%' || pdtmf || '%')
     and (pcontent is null or pcontent = '' or b.ivr_code like '%' || pcontent || '%')
     group by a.dtmf, b.ivr_code;
END PROC_GETDTMFSTATISTIC;

/

