create PROCEDURE "PROC_GETDTMFSTATISTICBYSERVICE" (
 -- THONG KE TONG HOP PHIM BAM THEO DICH VU
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,   
  listService in VARCHAR2,
  listLine in VARCHAR2,
  pcustLevel in number,
  pmax in number
) AS
BEGIN
     open rs for select * from (select a.dtmf, c.service_name, count(a.call_id) as numCall, 
     round(sum(a.duration)/60 + 0.499) as totalTime,  trunc(avg(a.duration)/60,3) as avgTime , 
     round(max(a.duration)/60 + 0.499) as maxTime ,  
     round(min(a.duration)/60 + 0.499) as minTime, 
     sum(number_of_visits) from dtmf_log a,  ivr_service c
     where a.node_code = c.service_id and a.called = c.line_code
     and a.start_time between fromDate and toDate 
     and (listLine is null or listLine = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))  
     and (listService is null or listService = '' or c.service_id in (
          select regexp_substr(listService,'[^,]+', 1, level) from dual
          connect by regexp_substr(listService, '[^,]+', 1, level) is not null
          ))
    and (pcustLevel = -1 or pcustLevel = a.customer_level)
     and c.serive_status = 1
     group by a.dtmf, c.service_name
     order by a.dtmf)
     where rownum <= pmax;
END PROC_GETDTMFSTATISTICBYSERVICE;

/

