create PROCEDURE "PROC_GETLISTENONLINEHISTORY" (
  Rs In Out Rs_Types.Rs_Cursor,
  Fromdate In Timestamp,
  Todate In Timestamp,
  Calltype In Number,
  Agentids In Varchar2,
  Listqueue In Varchar2,
  Callers In Varchar2,
  Listenagentid In Varchar2,
  Rn In Number
) As
Begin
 Open Rs For
 Select A.Agent_Id,A.Agent_Ip_Phone,A.Caller,B.Description Queue_Name,A.Call_Start_Time,
 Round((A.Call_End_Time - A.Call_Start_Time)*24*60*60,0) Call_Duration,
 A.Invoke_Start_Time,
 Round((A.Invoke_End_Time - A.Invoke_Start_Time)*24*60*60,0) Invoke_Duration,
 A.Invoker,'Inbound' Call_Type
 From Call_Spy A,ACD.Queues B
 Where A.Call_Start_Time Between Fromdate And Todate
 And A.Queue_Id = B.Queue_Id
 And (Agentids Is Null Or Agentids = '' Or A.Agent_Id Like '%'||Agentids||'%' Or A.Agent_Id In (
          Select Regexp_Substr(Agentids,'[^,]+', 1, Level) From Dual
          Connect By Regexp_Substr(Agentids, '[^,]+', 1, Level) Is Not Null ))
 And (Listqueue Is Null Or Listqueue = '' Or To_char(A.Queue_Id) In (
        Select Regexp_Substr(Listqueue,'[^,]+', 1, Level) From Dual
        Connect By Regexp_Substr(Listqueue, '[^,]+', 1, Level) Is Not Null ))
 And (Callers Is Null Or Callers = '' Or A.Caller In (
          Select Regexp_Substr(Callers,'[^,]+', 1, Level) From Dual
          Connect By Regexp_Substr(Callers, '[^,]+', 1, Level) Is Not Null ))
 And (Listenagentid Is Null Or Listenagentid = '' Or A.Invoker Like '%'||Listenagentid||'%' Or A.Invoker In (
          Select Regexp_Substr(Listenagentid,'[^,]+', 1, Level) From Dual
          Connect By Regexp_Substr(Listenagentid, '[^,]+', 1, Level) Is Not Null ))
And Rownum <= Rn
Order By Call_Start_Time Desc
 ;
END PROC_GETLISTENONLINEHISTORY;

/

