create PROCEDURE "PROC_GETMISSNOTMISSLINESUM" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pdur1 in number,
  pdur2 in number,
  pdur3 in number,
  pmax in number
) AS
BEGIN
   if ptimetype = 0 then
    open rs for select * from (select to_char(trunc(start_time),'dd-MM-yyyy') as date_hour,
        count(distinct call_id) as TONG_SO_CUOC,
        count(distinct case when joined = 0 then call_id end) as TONG_CUOC_ROT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12) then call_id end) as ROT_DO_HT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12)
        and duration >= pdur2 then call_id end) as ROT_DO_HT_SAU_N,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        then call_id end) as ROT_DO_KH,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        and duration >= pdur3 then call_id end) as ROT_DO_KH_SAU_N,
        count(distinct case when joined = 0 and (in_reason in (2,5, 12) and a.agent_id is not null) then call_id end) as ROT_DO_DTV,
        count(distinct case when joined > 0 then call_id end) as GAP_DTV,
        count(distinct case when joined > 0 and waiting_time >= pdur1 then call_id end) as GAP_DTV_SAU_N
       from callinfo a where a.start_time between fromDate and toDate
        and a.dial_error not like '%19%'
        and (listLine is null or listline = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
        and (pcustlevel = -1 or customer_level = pcustLevel)
        group by trunc(start_time)
        order by date_hour)
        WHERE rownum <= pmax;
  else
      open rs for select * from (select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour,
        count(distinct call_id) as TONG_SO_CUOC,
        count(distinct case when joined = 0 then call_id end) as TONG_CUOC_ROT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12) then call_id end) as ROT_DO_HT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12)
        and duration >= pdur2 then call_id end) as ROT_DO_HT_SAU_N,
         count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        then call_id end) as ROT_DO_KH,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
          and duration >= pdur3 then call_id end) as ROT_DO_KH_SAU_N,
       count(distinct case when joined = 0 and (in_reason in (2,5, 12) and a.agent_id is not null) then call_id end) as ROT_DO_DTV,
        count(distinct case when joined > 0 then call_id end) as GAP_DTV,
        count(distinct case when joined > 0 and waiting_time >= pdur1 then call_id end) as GAP_DTV_SAU_N
       from callinfo a where a.start_time between fromDate and toDate
        and a.dial_error not like '%19%'
        and (listLine is null or listline = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
        and (pcustlevel = -1 or customer_level = pcustLevel)
        group by TRUNC(a.start_time,'hh24')
        order by date_hour)
       WHERE rownum <= pmax;
  end if;
END PROC_GETMISSNOTMISSLINESUM;

/

