create PROCEDURE "PROC_GETSTATUSCHANGE" (
-- THONG KE SO LAN THAY DOI TRANG THAI
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listAgent in VARCHAR2,
  pstatus in number,
  pduration in number,
  pcount in number,
  pmax in number
) AS
BEGIN
     open rs for select a.agent_id, b.status_name, count(a.status) as status_changes, 
     count(case when a.duration >= pduration then a.status end),
     round(sum(duration)/60) as total from agent a, agent_status b 
     where b.status_type = 1 and a.status = b.status_code 
    -- and a.insert_time between fromDate and toDate 
     and a.start_time between fromDate and toDate 
     and (listAgent is null or listAgent = '' or lower(agent_id) in (
      select regexp_substr(listAgent,'[^,]+', 1, level) from dual
      connect by regexp_substr(listAgent, '[^,]+', 1, level) is not null ))  
     and (pstatus = -1 or a.status = pstatus)
     group by a.agent_id, b.status_name having count(*) >= pcount 
     order by agent_id, status_changes;
END PROC_GETSTATUSCHANGE;

/

