create PROCEDURE "PROC_GETSYSTEMTOTALCALL" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcallType in number,
  preportType in number,
  pmax in number
) AS
BEGIN
  if preporttype = 0 then
    open rs for select to_char(TRUNC(a.start_time),'dd/mm/yyyy') date_hour,  
    count(distinct a.call_id) as total, 
    count(distinct case when a.joined > 0 then a.call_id end) total_connected, 
    count(distinct case when a.joined = 0 then a.call_id end) total_missed, 
    count(distinct a.caller) total_caller, 
    count(distinct case when a.joined > 0 and a.customer_level > 0 then a.call_id end) total_vip_answer, 
    count(distinct case when a.joined = 0 and a.customer_level > 0 then a.call_id end) total_vip_miss, 
    count(distinct case when a.joined > 0 and a.customer_level = 0 then a.call_id end) total_novip_answer, 
    count(distinct case when a.joined = 0 and a.customer_level = 0 then a.call_id end) total_novip_miss 
    from callinfo a where a.start_time between fromDate and toDate  
  --  and  a.insert_time between fromDate and toDate
    and (listLine is null or listline = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    and call_type = pcalltype
--    and rownum <= pmax      
    group by TRUNC(a.start_time) 
    order by date_hour;
  else
    open rs for select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') date_hour,  
    count(distinct a.call_id) as total, 
    count(distinct case when a.joined > 0 then a.call_id end) total_connected, 
    count(distinct case when a.joined = 0 then a.call_id end) total_missed, 
    count(distinct a.caller) total_caller, 
    count(distinct case when a.joined > 0 and a.customer_level > 0 then a.call_id end) total_vip_answer, 
    count(distinct case when a.joined = 0 and a.customer_level > 0 then a.call_id end) total_vip_miss, 
    count(distinct case when a.joined > 0 and a.customer_level = 0 then a.call_id end) total_novip_answer, 
    count(distinct case when a.joined = 0 and a.customer_level = 0 then a.call_id end) total_novip_miss 
    from callinfo a where a.start_time between fromDate and toDate  
  --  and  a.insert_time between fromDate and toDate 
    and (listLine is null or listline = '' or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
    and call_type = pcalltype
--    and rownum <= pmax      
    group by TRUNC(a.start_time,'hh24') 
    order by date_hour;
  end if;
END PROC_GETSYSTEMTOTALCALL;

/

