create PROCEDURE "PROC_GETWAITINGTIME" (
 -- thong ke thoi gian cho va gap trung binh
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pmax in number
) AS
BEGIN
  if ptimetype = 0 then
    open rs for select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour, 
    count(distinct a.call_id) as totalCalls, 
    count(distinct a.caller) as totalCallers, 
    round(max(a.acd_time)) as maxTime, 
    round(min(a.acd_time)) as minTime, 
    round(avg (a.acd_time)) as avgTime, 
    round(max(a.waiting_time)) as maxWaitTime, 
    round(min(a.waiting_time)) as minWaitTime, 
    round(avg (a.waiting_time)) as avgWaitTime 
    from callinfo a where a.start_time between fromDate and toDate  
  --  and  a.insert_time between fromDate and toDate
    and a.joined > 0 
    and (listLine is null or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    and (pcustlevel = -1 or customer_level = pcustLevel)
    group by trunc(a.start_time)
    order by date_hour;
  else
    open rs for select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour, 
    count(distinct a.call_id) as totalCalls, 
    count(distinct a.caller) as totalCallers, 
    round(max(a.acd_time)) as maxTime, 
    round(min(a.acd_time)) as minTime, 
    round(avg (a.acd_time)) as avgTime, 
    round(max(a.waiting_time)) as maxWaitTime, 
    round(min(a.waiting_time)) as minWaitTime, 
    round(avg (a.waiting_time)) as avgWaitTime 
    from callinfo a where a.start_time between fromDate and toDate  
  --  and  a.insert_time between fromDate and toDate 
    and a.joined > 0 
    and (listLine is null or called in (
          select regexp_substr(listLine,'[^,]+', 1, level) from dual
          connect by regexp_substr(listLine, '[^,]+', 1, level) is not null )) 
    and (pcustlevel = -1 or customer_level = pcustLevel)
    group by TRUNC(a.start_time,'hh24') 
    order by date_hour;
  end if;
END PROC_GETWAITINGTIME;

/

