create PROCEDURE "PROC_GET_INTELLIGENT_ROUTING" 
-- thong ke cuoc goi dinh tuyen
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  line in VARCHAR2,       -- danh sach queue --> 3
  routingTypeIn in number,              -- loai bao cao --> 4
  areaIn in VARCHAR2,           -- Khu vuc -> 5 
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 6
) AS
BEGIN
  if routingTypeIn = 0 then
    open rs for select a.call_id, 
                  a.caller, 
                  a. called, 
                  to_char(a.start_time,'dd/MM/yyyy hh24:mi:ss'),
                  to_char(a.first_ring_time,'dd/MM/yyyy hh24:mi:ss'),
                  to_char(a.first_connect_time,'dd/MM/yyyy hh24:mi:ss'),
                  a.agent_id,
                  a.duration, b.description
    from CALLINFO a, end_code b 
    where a.START_TIME between FROMDATEIN and TODATEIN
      and a.in_reason = b.end_code_id
      and a.caller like '%\_%' escape '\'
      and a.called = line
      and (areaIn is null or areaIn = '' or lower(substr(a.caller, 0, 2)) in (
          select regexp_substr(areaIn,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(areaIn, '[^,]+', 1, level) is not null ))
      and rownum <= PMAXIN
    order by a.start_time desc;
  else
    open rs for select a.call_id, 
                  a.caller, 
                  a. called, 
                  to_char(a.start_time,'dd/MM/yyyy hh24:mi:ss'),
                  to_char(a.routing_time,'dd/MM/yyyy hh24:mi:ss'),
                  a.routing_to
    from CALLINFO a 
    where a.START_TIME between FROMDATEIN and TODATEIN
      and a.dial_error like '%19%'
      and a.called = line
      and (areaIn is null or areaIn = '' or lower(a.ROUTING_TO) in (
          select regexp_substr(areaIn,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(areaIn, '[^,]+', 1, level) is not null ))
      and rownum <= PMAXIN
    order by a.start_time desc;
  end if;
END PROC_GET_INTELLIGENT_ROUTING;

/

