create PROCEDURE "PROC_REPORTSURVEYPARTICIPANT2" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  poptionType in number, -- 0: SMS, 1: USSD, 2: IVR
  listDtmf in VARCHAR2,
  agentId in VARCHAR2,
  pLine in VARCHAR2,
  pCaller in VARCHAR2,
  pmax in number
) AS
BEGIN
  if poptiontype = 2 then
    open rs for select c.caller caller, c.start_time startTime, c.called called, c.dtmf dtmf, d.agent_id agentId from 
      (select * from dtmf_log a where a.dtmf_log_id = (select max(b.dtmf_log_id) from dtmf_log b where a.call_id = b.call_id 
      and (listDtmf is null or listDtmf = '' or dtmf in (select REGEXP_SUBSTR(listDtmf,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listDtmf, '[^,]+', 1, level) is not null)))) c join callinfo d on c.call_id = d.call_id where d.transfer_called is not null
      and c.start_time between fromdate and todate
      and (agentId is null or agentId = '' or LOWER(d.agent_id) like '%'||agentId||'%' escape '\')
      and (pLine is null or pLine = '' or pLine = '-1' or c.called = pLine)
      and (pCaller is null or pCaller = '' or LOWER(c.caller) like '%'||pCaller||'%' escape '\')
      and rownum <=pmax
      order by c.start_time desc;
  else
    if (listDtmf = '' or listDtmf is null)  then
      open rs for select b.caller caller, b.start_time startTime, b.line called, b.survey_code dtmf, c.agent_id agentId from (select * from survey_log where start_time between fromdate and todate
        and survey_code in (select survey_code from survey_tree a where survey_type = poptiontype)) b join callinfo c on b.call_id = c.call_id where c.transfer_called is null 
        and c.start_time between fromdate and todate
        and (agentId is null or agentId = '' or LOWER(c.agent_id) like '%'||agentId||'%' escape '\')
        and (pLine is null or pLine = '' or pLine = '-1' or b.line = pLine)
        and (pCaller is null or pCaller = '' or LOWER(b.caller) like '%'||pCaller||'%' escape '\')
        and rownum <=pmax
        order by b.start_time desc;
    else
      open rs for select b.caller caller, b.start_time startTime, b.line called, b.survey_code dtmf, c.agent_id agentId from (select * from survey_log where 
        start_time between fromdate and todate and 
        survey_code in (select survey_code from survey_tree a where (1=1) and survey_type = poptiontype start with to_char(a.survey_tree_id) in
          (select REGEXP_SUBSTR(listDtmf,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listDtmf, '[^,]+', 1, level) is not null)
          connect by prior a.survey_tree_id = a.parent_id)) b join callinfo c on b.call_id = c.call_id where c.transfer_called is null 
        and c.start_time between fromdate and todate
        and (agentId is null or agentId = '' or LOWER(c.agent_id) like '%'||agentId||'%' escape '\')
        and (pLine is null or pLine = '' or pLine = '-1' or b.line = pLine)
        and (pCaller is null or pCaller = '' or LOWER(b.caller) like '%'||pCaller||'%' escape '\')
        and rownum <=pmax
        order by b.start_time desc;
    end if;
  end if;
END PROC_REPORTSURVEYPARTICIPANT2;

/

