create PROCEDURE "PROC_STATISTICTOTALCALLEDVIP" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  poptionType in VARCHAR2,
  custLevel in number,
  listLine in VARCHAR2,
  pmax in number
) AS
BEGIN
  if poptiontype = '0' then
    open rs for select to_char(trunc(start_time),'dd/MM/yyyy') as date_hour, 
sum(1) as totalCallVip, 
sum(case when joined > 0 then 1 else 0 end) as totalMeetAgent, 
sum(case when joined > 0 and line_overflow = 0 then 1 else 0 end) as totalMeetAgentVIP, 
sum(case when joined > 0 and line_overflow = 1 then 1 else 0 end) as totalMeetAgentNormal, 
sum(case when joined = 0 and line_overflow = 1 then 1 else 0 end) as totalMissInNormalLine, 
sum(case when line_overflow = 1 then 1 else 0 end) as totalCallOverflow 
from callinfo where start_time between fromdate and todate
     and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null )) 
     and (custLevel = -1 or customer_level = custLevel) 
     group by to_char(trunc(start_time),'dd/MM/yyyy')
     order by date_hour;
  else
   open rs for select to_char(TRUNC(start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour, 
sum(1) as totalCallVip, 
sum(case when joined > 0 then 1 else 0 end) as totalMeetAgent, 
sum(case when joined > 0 and line_overflow = 0 then 1 else 0 end) as totalMeetAgentVIP, 
sum(case when joined > 0 and line_overflow = 1 then 1 else 0 end) as totalMeetAgentNormal, 
sum(case when joined = 0 and line_overflow = 1 then 1 else 0 end) as totalMissInNormalLine, 
sum(case when line_overflow = 1 then 1 else 0 end) as totalCallOverflow 
from callinfo where start_time between fromdate and todate
     and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null )) 
     and (custLevel = -1 or customer_level = custLevel) 
     group by to_char(TRUNC(start_time,'hh24'),'dd/mm/yyyy hh24:mi')
     order by date_hour;
   end if;
END PROC_STATISTICTOTALCALLEDVIP;

/

