create PROCEDURE "PROC_TOTALTRANSTOSURVEYSMSUSSD" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  optionType in VARCHAR2, -- 0: tong hop, 1: chi tiet
  listCalled in VARCHAR2,
  surveyType in number,
  pmax in number
) AS
BEGIN
  if optionType = '1' then
  -- thong ke chi tiet
    open rs for select a.line line, a.survey_code dtmfSMSUSSD, a.description dtmfContent, 
      (select count(*) from survey_log b where b.survey_code like a.survey_code || '%' 
      and a.line = b.line 
      and b.start_time between fromdate and todate 
      and a.survey_type = b.survey_type) sumCustomer from survey_tree a 
      where (listCalled is null or listCalled = '' or a.line in (select REGEXP_SUBSTR(listCalled,'[^,]+', 1, level) from DUAL 
          connect by REGEXP_SUBSTR(listCalled, '[^,]+', 1, level) is not null)) 
      and a.survey_code is not null and a.survey_type = surveyType 
      and rownum <=pmax;
  else
  -- thong ke tong hop
    open rs for select a.called line, count(distinct a.call_id) sumCallToACD, 
      count(distinct case when b.line is not null and b.survey_type = surveyType then a.call_id end) sumCallSentToCus, 
      count(distinct case when b.survey_code is not null and b.survey_type = surveyType then b.call_id end) sumCallRespondFromCus, 
      count(distinct case when b.survey_code is null and b.survey_type = surveyType then b.call_id end) sumCallNotRespondFromCus
      from callinfo a LEFT JOIN survey_log b ON a.call_id = b.call_id 
      where a.start_time between fromdate and todate
      and (listCalled is null or listCalled = '' or a.called in (select REGEXP_SUBSTR(listCalled,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(listCalled, '[^,]+', 1, level) is not null))
      group by a.called;
  end if;
END PROC_TOTALTRANSTOSURVEYSMSUSSD;

/

