create PROCEDURE "PROC_WS_CONNECTIVITY_INDEX" 
(  rs in OUT RS_TYPES.RS_CURSOR,
  listLine  in varchar2,
  PCALLER IN VARCHAR2,
  pstartTime in varchar2,
  pendTime in varchar2,
  prownum in number)
   IS
BEGIN
open rs for
   SELECT   *  FROM (
              SELECT   a.call_id callId,
                        a.caller caller,
                        a.called called,
                        to_char(a.start_time,'DD/MM/YYYY hh24:mi:ss') startTime,
                        a.waiting_time waitingTime,
                        nvl(to_char(a.first_ring_time,'DD/MM/YYYY hh24:mi:ss'),'  ') ringTime,
                        nvl(to_char(a.first_connect_time,'DD/MM/YYYY hh24:mi:ss'),'  ') connectTime,
                        nvl(a.agent_id,'  ') agentId,
                        to_char(a.end_time,'DD/MM/YYYY hh24:mi:ss') endTime,
                        a.duration duration,
                        a.in_reason endCode,
                        a.customer_level customerLevel
                         ,a.joined  joined
                 FROM   callinfo a
                WHERE  a.start_time BETWEEN TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss')
                        AND  TO_DATE (pendTime, 'DD/MM/YYYY hh24:mi:ss')
                        and (a.call_type = 0)
                        AND (listLine is null or listLine = '' or a.called in (
                        select regexp_substr(listLine,'[^,]+', 1, level) from dual
                        connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
                        AND (pcaller is null or pcaller = '' or lower(a.caller) like '%'||pcaller||'%' ESCAPE '\')
            ) WHERE   rownum <= prownum  
		ORDER BY   dbms_random.value(); 

END;

/

