create PROCEDURE "PROC_WS_DOSEARCHCALL" (
   RS IN OUT RS_TYPES.RS_CURSOR
, PCALLER IN VARCHAR2
, PAGENTID IN varchar2
, PFROMTIME IN date
, PTOTIME IN date
, PMINDURATION IN NUMBER
, PMAXDURATION IN NUMBER
, pmaxcallperagent in number
, PROWNUM IN NUMBER
) AS
BEGIN
       open RS for
           select agent_id, startd, ring, connectd, endt, conference_time, url, caller, called, rn  from (
           select agent_id
           , to_char(start_time,'yyyy-MM-dd hh24:mi:ss') as startd
           ,to_char(ring_time,'yyyy-MM-dd hh24:mi:ss') as ring
           ,to_char(connect_time,'yyyy-MM-dd hh24:mi:ss') as connectd
           ,to_char(end_time,'yyyy-MM-dd hh24:mi:ss') as endt
           ,answer_time as conference_time, url, caller, called
           ,row_number() over (partition by agent_id order by
dbms_random.value) rn
           from call
           where START_TIME BETWEEN PFROMTIME and PTOTIME
           and (call.agent_id in (select REGEXP_SUBSTR(PAGENTID,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(PAGENTID, '[^,]+', 1, level) is not null ))
           and call.caller like '%'||pcaller||'%'
           and call.answer_time between pminduration and pmaxduration
           --ORDER BY   dbms_random.value()
           ) where rn<=pmaxcallperagent and rownum <= prownum
           order by conference_time desc;

END PROC_WS_DOSEARCHCALL;

/

