create PROCEDURE "PROC_WS_INDEX_ONLINE" (
  rs in out rs_types.rs_cursor,
  fromDate in varchar2,
  toDate in varchar2,
  listLine in VARCHAR2,
  pcustLevel in number,
  ptimeType in number,
  pdur1 in number,
  pdur2 in number,
  pdur3 in number,
  prownum in number
) AS
BEGIN
   if ptimetype = 1 then
    open rs for select called as line, to_char(trunc(start_time),'dd-MM-yyyy') as date_hour,
        count(distinct call_id) as TONG_SO_CUOC,
        count(distinct case when joined = 0 then call_id end) as TONG_CUOC_ROT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12) then call_id end) as ROT_DO_HT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12)
        and duration >= pdur2 then call_id end) as ROT_DO_HT_SAU_N,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        then call_id end) as ROT_DO_KH,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        and duration >= pdur3 then call_id end) as ROT_DO_KH_SAU_N,
        count(distinct case when joined = 0 and (in_reason in (2,5, 12) and a.agent_id is not null) then call_id end) as ROT_DO_DTV,
        count(distinct case when joined > 0 then call_id end) as GAP_DTV,
        count(distinct case when joined > 0 and waiting_time >= pdur1 then call_id end) as GAP_DTV_SAU_N,
        sum(duration) as duration,
        sum(waiting_time) as waiting_time
       from callinfo a where a.start_time between TO_DATE (fromDate, 'DD/MM/YYYY hh24:mi:ss')
        and TO_DATE (toDate, 'DD/MM/YYYY hh24:mi:ss')
        and auto_transfer != 2 --AnhNT206 sua R8130
        and (listLine is null or listline = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
        and (pcustlevel = -1 or (pcustLevel = 0 and customer_level = pcustLevel) or (pcustLevel = 1 and customer_level > 0))
        and rownum <= prownum
        group by trunc(start_time),called
        order by date_hour;
  else
      open rs for select called as line, to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour,
        count(distinct call_id) as TONG_SO_CUOC,
        count(distinct case when joined = 0 then call_id end) as TONG_CUOC_ROT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12) then call_id end) as ROT_DO_HT,
        count(distinct case when joined = 0 and in_reason not in (1,2,5,12)
        and duration >= pdur2 then call_id end) as ROT_DO_HT_SAU_N,
         count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
        then call_id end) as ROT_DO_KH,
        count(distinct case when joined = 0 and (in_reason = 1 or (in_reason in (2,5, 12) and a.agent_id is null))
          and duration >= pdur3 then call_id end) as ROT_DO_KH_SAU_N,
       count(distinct case when joined = 0 and (in_reason in (2,5, 12) and a.agent_id is not null) then call_id end) as ROT_DO_DTV,
        count(distinct case when joined > 0 then call_id end) as GAP_DTV,
        count(distinct case when joined > 0 and waiting_time >= pdur1 then call_id end) as GAP_DTV_SAU_N,
        sum(duration) as duration,
        sum(waiting_time) as waiting_time
       from callinfo a where a.start_time between TO_DATE (fromDate, 'DD/MM/YYYY hh24:mi:ss')
        and TO_DATE (toDate, 'DD/MM/YYYY hh24:mi:ss')
         and auto_transfer != 2 --AnhNT206 sua R8130
        and (listLine is null or listline = '' or called in (
            select regexp_substr(listLine,'[^,]+', 1, level) from dual
            connect by regexp_substr(listLine, '[^,]+', 1, level) is not null ))
        and (pcustlevel = -1 or (pcustLevel = 0 and customer_level = pcustLevel) or (pcustLevel = 1 and customer_level > 0))
        and rownum <= prownum
        group by TRUNC(a.start_time,'hh24'), called
        order by date_hour;
  end if;
END PROC_WS_INDEX_ONLINE;

/

