create PROCEDURE "PROC_WS_PRODUCT_STATISTIC_BK" 
(  rs in OUT RS_TYPES.RS_CURSOR,
  pagentId in varchar2,
  pstartTime in varchar2,
  pendTime in varchar2,
  prownum in number)
   IS
BEGIN
open rs for
  SELECT   *  FROM (
             SELECT    a.agent_id agentId,
                        count(case when a.call_type = 0 and a.joined > 0 then a.call_id end) ans,
                        count(case when a.call_type = 0 and a.joined = 0 then a.call_id end) mis,
                        ROUND(AVG(case when a.call_type = 0 then a.AGENT_WAITING_TIME end),2) avgRinging,
                        MAX(case when a.call_type = 0 then a.AGENT_WAITING_TIME end) maxRinging,
                        ROUND(AVG(case when a.call_type = 0 then a.ANSWER_TIME end),2) avgAnswerTime,
                        MAX(case when a.call_type = 0 then a.ANSWER_TIME end) maxAnswerTime,
                        ROUND(SUM(case when a.call_type = 0 then a.ANSWER_TIME end)/60,2) totalAnswerTime,
                        count( distinct case when a.end_code in (2,4,5) then a.call_id end) endCallAgent
                FROM   call a
                WHERE  a.start_time BETWEEN TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss')
                AND  TO_DATE (pendTime, 'DD/MM/YYYY hh24:mi:ss')
                AND  (pagentId is null or pagentId = '' or lower(a.agent_id) in (
                select regexp_substr(lower(pagentId),'[^,]+', 1, level) from dual
                connect by regexp_substr(lower(pagentId), '[^,]+', 1, level) is not null ))
                group by a.agent_id  
             	ORDER BY   dbms_random.value())
             	WHERE   rownum <= prownum;  
END;

/

