create PROCEDURE "PROC_WS_STATISTICAL_AGENT" 
(  rs in OUT RS_TYPES.RS_CURSOR,
  pagentId in varchar2,
  pstartTime in varchar2,
  pendTime in varchar2,
  prownum in number)
   IS
BEGIN
open rs for
   SELECT   *  FROM (
              SELECT    a.agent_id  agentId,
                        nvl(sum(case when a.status = 2 then a.duration end),0) notAvailable,
                        nvl(sum(case when a.status = 3 then a.duration end),0) available,
                        nvl(sum(case when a.status = 10 then a.duration end),0) ringing,
                        nvl(sum(case when a.status = 11 then a.duration end),0) Answering,
                        nvl(sum(case when a.status = 4 then a.duration end),0) meeting,
                        nvl(sum(case when a.status = 5 then a.duration end),0) typing,
                        nvl(sum(case when a.status = 6 then a.duration end),0) atLunch,
                        nvl(sum(case when a.status = 7 then a.duration end),0) goOut,
                        nvl(sum(case when a.status = 16 then a.duration end),0) noAnswer,
                        count(case when a.status = 12 then a.agent_id end) dialNoAnswer,
                        nvl(sum(case when a.status = 17 then a.duration end),0) avaiableNoACD,
                        nvl(sum(case when a.status = 18 then a.duration end),0) avaiableCallOut
                 FROM   agent a
                WHERE  a.start_time BETWEEN TO_DATE (pstartTime, 'DD/MM/YYYY hh24:mi:ss')
                AND  TO_DATE (pendTime, 'DD/MM/YYYY hh24:mi:ss')
                AND  (pagentId is null or pagentId = '' or lower(a.agent_id) in (
                                      select regexp_substr(lower(pagentId),'[^,]+', 1, level) from dual
                connect by regexp_substr(lower(pagentId), '[^,]+', 1, level) is not null ))
                group by a.agent_id
             ORDER BY   dbms_random.value())
             WHERE   rownum <= prownum;
END; -- Procedure

/

