create PROCEDURE "TESTPROC_GETAGENTJOBSTATUS" (
-- thong ke thoi gian trang thai
  rs in out rs_types.rs_cursor,
  fromDate in DATE,
  toDate in DATE,
  agentIdIn in VARCHAR2,
  pstatus in NUMBER,
  poptionType in NUMBER,
  pdur1 in NUMBER,
  pdur2 in NUMBER,
  pdur3 in NUMBER,
  pdur4 in NUMBER,
  listGroupId in VARCHAR2,
  pmax in NUMBER
) AS
BEGIN
--  tam thoi chi tim kiem chinh xac theo agent_id
  if poptiontype = 0 then
     open rs for select * from (select a.agent_id, sum(case when a.duration >= pdur1 and a.duration <pdur2 then 1 else 0 end) as ringt1t2,
     sum(case when a.duration >= pdur2 and a.duration < pdur3 then 1 else 0 end) as ringt2t3,
     sum(case when a.duration >= pdur3 and a.duration < pdur4 then 1 else 0 end) as ringt3t4,
     sum(case when a.duration >= pdur4 then 1 else 0 end) as ringt4,
     sum(duration) as total_ring_time,count(status) as total, b.status_name
     from agent a,agent_status b 
     where a.START_TIME between FROMDATE and TODATE
     and a.STATUS = B.STATUS_CODE
     and ((POPTIONTYPE = 1) or (POPTIONTYPE = 0 and a.status in (10,11,12))) 
     and (PSTATUS = -1 or a.status = pstatus)
     and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like ('%'||agentIdIn||'%'))
      and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
     group by a.agent_id,b.status_name)
     where rownum <= pmax;
   else
      open rs for select * from (select a.agent_id, a.status, to_char(a.start_time,'dd-MM-yyyy hh24:mi:ss'),
      a.duration,to_char(a.stop_time,'dd-MM-yyyy hh24:mi:ss'),b.status_name
      from agent a, agent_status b 
       where a.start_time between fromDate and toDate
      and a.status = b.status_code
      and b.status_type = 1
      and (pstatus = -1 or a.status = pstatus)
      and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like ('%'||agentIdIn||'%'))
       and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
      order by a.agent_id,a.start_time)
      where rownum <= pmax;
   end if;
END testPROC_GETAGENTJOBSTATUS;

/

