create PROCEDURE "TESTPROC_GETSTATUSCHANGE" (
-- THONG KE SO LAN THAY DOI TRANG THAI
  RS in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date, 
  pAgentId in VARCHAR2,
  pstatus in number,
  pduration in number,
  PCOUNT in number,
  listGroupId in VARCHAR2,
  pmax in number
) AS
BEGIN

       open rs for select * from ( select a.agent_id,a.status, b.status_name, count(a.status) as status_changes, 
     count(case when a.duration >= pduration then a.status end),
     round(sum(duration)/60 + 0.5) as total from agent a, agent_status b 
     where b.status_type = 1 and a.status = b.status_code 
     and a.start_time between fromDate and toDate 
     and (PAGENTID is null or PAGENTID = '' or LOWER(AGENT_ID) like '%'||PAGENTID||'%')
       and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null ))  
     and (pstatus = -1 or a.status = pstatus)
     group by a.agent_id, a.status, b.status_name having count(*) >= pcount 
     order by agent_id, status_changes) where rownum <= pmax;
END testPROC_GETSTATUSCHANGE;

/

