create PROCEDURE "TESTPROC_GETSUBCALLEDTHANN" -- vos_vietnb
-- thong ke cuoc goi lon hon n lan
(
  rs in out rs_types.rs_cursor, -- --> 1
  fromDateIn in Date,             -- thoi gian bat dau thong ke --> 2
  toDateIn in Date,               -- thoi gian ket thuc thong ke --> 3
  listGroupId in VARCHAR2,      -- danh sach kenh --> 4
  listCalledIn in VARCHAR2,       -- danh sach kenh --> 5
  callerIn in VARCHAR2,           -- so dien thoai --> 6
  customerLevelIn in VARCHAR2,    -- loai khach hang --> 7
  ptypeIn in number,              -- loai bao cao --> 8
  ptotalCallIn in number,         -- tong so cuoc goi --> 9
  pjoinedIn in VARCHAR2,          -- dieu kien --> 10
  callIdIn in VARCHAR2,           -- ma cuoc goi --> 11
  agentIdIn in VARCHAR2,            -- ma nhan vien --> 12
  acdTimeIn in VARCHAR2,          -- thoi gian dam thoai --> 13
  waitingTimeIn in VARCHAR2,      -- thoi gian cho --> 14
  pmaxIn in number                -- so luong ban ghi toi da duoc export --> 15
) AS

BEGIN
    if ptypeIn = 1 then
    -- chi tiet
        open rs for select a.call_id,
               a.caller,
               a.CALLED,
               to_char(a.start_time,'dd/MM/yyyy hh24:mi:ss'),
               a.waiting_time,
               to_char(a.first_ring_time,'dd/MM/yyyy hh24:mi:ss'),
               to_char(a.first_connect_time,'dd/MM/yyyy hh24:mi:ss'),
               a.agent_id,
               to_char(a.end_time,'dd/MM/yyyy hh24:mi:ss'),
               a.duration,
                (case when a.in_reason = 1 then 'do KH' when (a.in_reason in (2,4,5) and a.agent_id is not null) then 'do Agent' 
      when a.in_reason in (3,6,10) then 'do HT' when a.in_reason = 12 
      then 'Do Supervisor' else 'do KH' end)
        from CALLINFO a 
        where a.START_TIME between FROMDATEIN and TODATEIN
         and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
        and (listCalledIn is null or listCalledIn = '' or lower(a.called) in (
          select regexp_substr(listCalledIn,'[^,]+', 1, level) from dual
          connect by REGEXP_SUBSTR(LISTCALLEDIN, '[^,]+', 1, level) is not null ))
        and (pjoinedIn = -1 or a.joined = pjoinedIn or (pjoinedIn > 0 and a.joined > 0))
        and(customerLevelIn = -1 or a.customer_level = customerLevelIn)
        and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%')
        and (callerIn is null or callerIn = '' or lower(a.caller) like '%'||callerIn||'%')
        and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%')
        and a.acd_time >= acdTimeIn
        and a.waiting_time >= waitingTimeIn
        and rownum <= PMAXIN
        order by a.start_time;
    else
    -- tong hop
        open rs for select * from ( select * from
        (
            select a.caller as sodienthoai, count(distinct a.call_id) as solangoi
            from callinfo a
            where start_time between fromDateIn and toDateIn
             and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
            and (listCalledIn is null or listCalledIn = '' or lower(a.called) in (
              select regexp_substr(listCalledIn,'[^,]+', 1, level) from dual
              connect by regexp_substr(listCalledIn, '[^,]+', 1, level) is not null ))
            and (pjoinedIn = -1 or joined = pjoinedIn or (pjoinedIn > 0 and joined > 0))
            and(customerLevelIn = -1 or a.customer_level = customerLevelIn)
            and (agentIdIn is null or agentIdIn = '' or lower(a.agent_id) like '%'||agentIdIn||'%')
            and (callerIn is null or callerIn = '' or lower(a.caller) like '%'||callerIn||'%')
            and (callIdIn is null or callIdIn = '' or lower(a.call_id) like '%'||callIdIn||'%')
            and a.acd_time >= acdTimeIn
            and a.waiting_time >= waitingTimeIn
            group by caller
        ) where solangoi >= ptotalCallIn order by solangoi) where rownum <= pmaxIn;
    end if;
END testPROC_GETSUBCALLEDTHANN;

/

