create PROCEDURE "TESTPROC_GET_CALL_PER_AGENT" (
  rs in OUT RS_TYPES.RS_CURSOR,
  fromDate in date,
  toDate in date, 
  LISTLINE in varchar2,
  PCALLTYPE in number,  
  customerLevelIn in number,
  PAGENTID in varchar2,
  LIMITTIME in number,
  listGroupId in VARCHAR2,
  PMAX in number
) as
  V_C_TOTAL number := 0;
  V_MC_TOTAL number := 0;
  v_at_total number := 0;
begin         

commit;
      open RS for 
          select AGENT_ID
          ,SUM(case when ANSWER_TIME > 0 then 1 else 0 end) CMET
          ,SUM(case when ANSWER_TIME = 0 then 1 else 0 end) CMISS
          ,ROUND(AVG(AGENT_WAITING_TIME)) AVG_WAITTIME
          ,ROUND(max(AGENT_WAITING_TIME)) MAX_WAITTIME
          ,ROUND(AVG(ANSWER_TIME)) AVG_ANSWERTIME
          ,ROUND(max(ANSWER_TIME)) MAX_ANSWERTIME
          ,round(SUM(ANSWER_TIME )) TT_ANSWERTIME
          ,COUNT(case when a.END_CODE in (2, 4, 5) then a.CALL_ID end) TOTALCALLENDBYAGENT
          from call a 
          where a.START_TIME BETWEEN FROMDATE and todate
          and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null )) 
            and (pcalltype is null or pcalltype = -1 or a.call_type = pcalltype)
          and (PAGENTID is null or PAGENTID = '' or LOWER(AGENT_ID) like '%'||PAGENTID||'%')
           and agent_id in (select user_name from users@tovsa where location_id in (
      select regexp_substr(listGroupId,'[^,]+', 1, level) from dual
      connect by regexp_substr(listGroupId, '[^,]+', 1, level) is not null )) 
          and ANSWER_TIME>=LIMITTIME
          and(customerLevelIn is null or customerLevelIn = -1 or a.customer_level = customerLevelIn)
          and agent_id is not null
          group by AGENT_ID
 ;
END testPROC_GET_CALL_PER_AGENT;

---------

/

