create PROCEDURE "TEST_GETIVRTOTALCALLBYDUR" (
  rs in out rs_types.rs_cursor,
  fromDate in Date,
  toDate in Date, 
  listLine in VARCHAR2,
  pcustLevel in number,
  pdur1 in number,
  pdur2 in number, 
  pdur3 in number, 
  pdur4 in number,
  ptimeType in number,
  pmax in number
) AS
BEGIN
  if ptimetype = 0 then
    open rs for select to_char(trunc(a.start_time),'dd-MM-yyyy') as date_hour,a.called,
    count(a.call_id),count(distinct a.caller),
    count(case when duration >=pdur1 and duration <pdur2 then a.call_id end) as ivrt1t2,
    count(case when duration >=pdur2 and duration <pdur3 then a.call_id end) as ivrt2t3,
    count(case when duration >=pdur3 and duration <pdur4 then a.call_id end) as ivrt3t4,
    count(case when duration >=pdur4 then a.call_id end) as ivrt4t5,
    count(a.call_id) as chingheivr,
    sum(0) as toacd,
   sum(0) as notmiss,
   sum(0) as miss 
    from callinfo a, line b where a.start_time between fromDate and toDate  
    and a.called = b.line_code and b.line_type != 1
    and (pcustlevel =-1 or a.customer_level = pcustlevel) 
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null ))
    group by trunc(a.start_time),a.called
    order by date_hour;
  else
        open rs for select to_char(TRUNC(a.start_time,'hh24'),'dd/mm/yyyy hh24:mi') as date_hour,a.called,
    count(a.call_id),count(distinct a.caller),
    count(case when duration >=pdur1 and duration <pdur2 then a.call_id end) as ivrt1t2,
    count(case when duration >=pdur2 and duration <pdur3 then a.call_id end) as ivrt2t3,
    count(case when duration >=pdur3 and duration <pdur4 then a.call_id end) as ivrt3t4,
    count(case when duration >=pdur4 then a.call_id end) as ivrt4t5,
    count(a.call_id) as chingheivr,
  sum(0) as toacd,
   sum(0) as notmiss,
    sum(0) as miss 
    from callinfo a, line b where a.start_time between fromDate and toDate 
    and a.called = b.line_code and b.line_type != 1
    and (pcustlevel =-1 or a.customer_level = pcustlevel) 
      and (listLine is null or listLine = '' or called in (
          select REGEXP_SUBSTR(LISTLINE,'[^,]+', 1, level) from DUAL
          connect by REGEXP_SUBSTR(LISTLINE, '[^,]+', 1, level) is not null )) 
    group by TRUNC(a.start_time,'hh24') ,a.called
    order by date_hour;
  end if;
END test_GETIVRTOTALCALLBYDUR;
---------

/

